/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: QName.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: hbrinkm $ $Date: 2006/11/01 09:14:27 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

/* Copyright 2006 SUN Microsystems, Inc. */
#ifndef INCLUDED_QNAME_HXX
#define INCLUDED_QNAME_HXX

#include <sal/types.h>
#include <WriterFilterDllApi.hxx>
#include <memory>


namespace writerfilter
{
	typedef int QName_t;

	namespace NS_anium { /* urn:oasis:names:tc:opendocument:xmlns:animation:1.0 */
		const QName_t LN_animate = 941;
		const QName_t LN_set = 949;
		const QName_t LN_animateMotion = 957;
		const QName_t LN_animateColor = 985;
		const QName_t LN_color_interpolation = 995;
		const QName_t LN_color_interpolation_direction = 1007;
		const QName_t LN_animateTransform = 1014;
		const QName_t LN_transitionFilter = 1026;
		const QName_t LN_id = 1053;
		const QName_t LN_sub_item = 1081;
		const QName_t LN_formula = 1119;
		const QName_t LN_par = 1251;
		const QName_t LN_seq = 1258;
		const QName_t LN_iterate = 1266;
		const QName_t LN_iterate_type = 1277;
		const QName_t LN_iterate_interval = 1289;
		const QName_t LN_audio = 1297;
		const QName_t LN_audio_level = 1309;
		const QName_t LN_command = 1313;
		const QName_t LN_param = 1319;
		const QName_t LN_name = 1322;
		const QName_t LN_value = 1329;
	}
	namespace NS_math { /* http://www.w3.org/1998/Math/MathML */
		const QName_t LN_math = 844;
	}
	namespace NS_w10 { /* urn:schemas-microsoft-com:office:word */
		const QName_t LN_bordertop = 1059;
		const QName_t LN_borderleft = 1068;
		const QName_t LN_borderright = 1079;
		const QName_t LN_borderbottom = 1089;
		const QName_t LN_wrap = 1091;
		const QName_t LN_anchorlock = 1098;
	}
	namespace NS_chart { /* urn:oasis:names:tc:opendocument:xmlns:chart:1.0 */
		const QName_t LN_scale_text = 153;
		const QName_t LN_three_dimensional = 163;
		const QName_t LN_deep = 169;
		const QName_t LN_symbol_type = 179;
		const QName_t LN_symbol_name = 190;
		const QName_t LN_symbol_image = 200;
		const QName_t LN_symbol_width = 209;
		const QName_t LN_symbol_height = 216;
		const QName_t LN_vertical = 222;
		const QName_t LN_connect_bars = 232;
		const QName_t LN_gap_width = 238;
		const QName_t LN_overlap = 247;
		const QName_t LN_japanese_candle_stick = 262;
		const QName_t LN_interpolation = 270;
		const QName_t LN_spline_order = 279;
		const QName_t LN_spline_resolution = 293;
		const QName_t LN_pie_offset = 299;
		const QName_t LN_lines = 302;
		const QName_t LN_solid_type = 309;
		const QName_t LN_stacked = 317;
		const QName_t LN_percentage = 327;
		const QName_t LN_link_data_style_to_source = 344;
		const QName_t LN_visible = 352;
		const QName_t LN_logarithmic = 364;
		const QName_t LN_maximum = 370;
		const QName_t LN_minimum = 380;
		const QName_t LN_origin = 386;
		const QName_t LN_interval_major = 400;
		const QName_t LN_interval_minor = 409;
		const QName_t LN_tick_marks_major_inner = 425;
		const QName_t LN_tick_marks_major_outer = 442;
		const QName_t LN_tick_marks_minor_inner = 459;
		const QName_t LN_tick_marks_minor_outer = 479;
		const QName_t LN_display_label = 489;
		const QName_t LN_text_overlap = 500;
		const QName_t LN_label_arrangement = 514;
		const QName_t LN_data_label_number = 528;
		const QName_t LN_data_label_text = 540;
		const QName_t LN_data_label_symbol = 554;
		const QName_t LN_error_category = 568;
		const QName_t LN_error_percentage = 581;
		const QName_t LN_error_margin = 593;
		const QName_t LN_error_lower_limit = 609;
		const QName_t LN_error_upper_limit = 622;
		const QName_t LN_error_upper_indicator = 639;
		const QName_t LN_error_lower_indicator = 656;
		const QName_t LN_series_source = 667;
		const QName_t LN_regression_type = 679;
		const QName_t LN_chart = 6384;
		const QName_t LN_class = 6390;
		const QName_t LN_column_mapping = 6402;
		const QName_t LN_row_mapping = 6410;
		const QName_t LN_style_name = 6415;
		const QName_t LN_title = 6417;
		const QName_t LN_subtitle = 6430;
		const QName_t LN_footer = 6435;
		const QName_t LN_legend = 6441;
		const QName_t LN_legend_position = 6452;
		const QName_t LN_legend_align = 6464;
		const QName_t LN_plot_area = 6505;
		const QName_t LN_data_source_has_labels = 6523;
		const QName_t LN_wall = 6530;
		const QName_t LN_floor = 6538;
		const QName_t LN_axis = 6544;
		const QName_t LN_dimension = 6553;
		const QName_t LN_name = 6560;
		const QName_t LN_grid = 6566;
		const QName_t LN_series = 6574;
		const QName_t LN_values_cell_range_address = 6587;
		const QName_t LN_label_cell_address = 6597;
		const QName_t LN_attached_axis = 6607;
		const QName_t LN_domain = 6613;
		const QName_t LN_categories = 6620;
		const QName_t LN_data_point = 6628;
		const QName_t LN_repeated = 6633;
		const QName_t LN_mean_value = 6643;
		const QName_t LN_error_indicator = 6655;
		const QName_t LN_regression_curve = 6672;
		const QName_t LN_stock_gain_marker = 6687;
		const QName_t LN_stock_loss_marker = 6704;
		const QName_t LN_stock_range_line = 6718;
	}
	namespace NS_sc12 { /* http://schemas.microsoft.com/office/excel/2005/8/singlecells */
		const QName_t LN_singleCells = 2300;
		const QName_t LN_table = 2303;
	}
	namespace NS_odc12 { /* urn:schemas-microsoft-com:office:odc */
		const QName_t LN_OfficeDataConnection = 91;
		const QName_t LN_Connection = 97;
		const QName_t LN_ConnectionString = 108;
		const QName_t LN_CommandType = 117;
		const QName_t LN_CommandText = 126;
		const QName_t LN_Parameter = 134;
		const QName_t LN_SourceFile = 141;
		const QName_t LN_HeaderFile = 149;
		const QName_t LN_MailMerge = 157;
		const QName_t LN_Version = 162;
		const QName_t LN_AlwaysUseConnectionFile = 177;
		const QName_t LN_CredentialsMethod = 191;
		const QName_t LN_SSOApplicationID = 203;
		const QName_t LN_Name = 207;
		const QName_t LN_DataType = 212;
	}
	namespace NS_c11 { /* urn:schemas-microsoft-com:office:component:spreadsheet */
		const QName_t LN_OWCVersion = 5246;
		const QName_t LN_worksheetoptions = 5259;
		const QName_t LN_displaycustomheaders = 5277;
		const QName_t LN_ComponentOptions = 5289;
		const QName_t LN_Toolbar = 5300;
		const QName_t LN_HideOfficeLogo = 5313;
		const QName_t LN_SpreadsheetAutoFit = 5327;
		const QName_t LN_Label = 5333;
		const QName_t LN_Caption = 5341;
		const QName_t LN_MaxHeight = 5352;
		const QName_t LN_MaxWidth = 5365;
		const QName_t LN_NextSheetNumber = 5377;
	}
	namespace NS_rng { /* http://relaxng.org/ns/structure/1.0 */
		const QName_t LN_anyName = 852;
		const QName_t LN_grammar = 1613;
		const QName_t LN_define = 1637;
		const QName_t LN_optional = 1657;
		const QName_t LN_attribute = 1667;
		const QName_t LN_ref = 1701;
		const QName_t LN_start = 1710;
		const QName_t LN_choice = 1720;
		const QName_t LN_element = 1731;
		const QName_t LN_zeroOrMore = 1852;
		const QName_t LN_group = 1880;
		const QName_t LN_empty = 1908;
		const QName_t LN_oneOrMore = 1962;
		const QName_t LN_text = 2003;
		const QName_t LN_value = 2021;
		const QName_t LN_mixed = 2109;
		const QName_t LN_interleave = 2162;
		const QName_t LN_data = 3258;
		const QName_t LN_param = 3276;
		const QName_t LN_except = 3360;
		const QName_t LN_nsName = 3371;
		const QName_t LN_parentRef = 3435;
		const QName_t LN_notAllowed = 3446;
		const QName_t LN_externalRef = 3459;
		const QName_t LN_div = 3466;
		const QName_t LN_include = 3474;
		const QName_t LN_list = 4096;
		const QName_t LN_name = 4177;
	}
	namespace NS_meta { /* urn:oasis:names:tc:opendocument:xmlns:meta:1.0 */
		const QName_t LN_date_string = 763;
		const QName_t LN_generator = 2200;
		const QName_t LN_keyword = 2236;
		const QName_t LN_initial_creator = 2251;
		const QName_t LN_printed_by = 2266;
		const QName_t LN_creation_date = 2277;
		const QName_t LN_print_date = 2296;
		const QName_t LN_template = 2307;
		const QName_t LN_date = 2331;
		const QName_t LN_auto_reload = 2342;
		const QName_t LN_delay = 2356;
		const QName_t LN_hyperlink_behaviour = 2372;
		const QName_t LN_editing_cycles = 2403;
		const QName_t LN_editing_duration = 2416;
		const QName_t LN_document_statistic = 2429;
		const QName_t LN_page_count = 2440;
		const QName_t LN_table_count = 2451;
		const QName_t LN_draw_count = 2462;
		const QName_t LN_image_count = 2472;
		const QName_t LN_ole_object_count = 2484;
		const QName_t LN_paragraph_count = 2497;
		const QName_t LN_word_count = 2512;
		const QName_t LN_character_count = 2524;
		const QName_t LN_frame_count = 2537;
		const QName_t LN_sentence_count = 2550;
		const QName_t LN_syllable_count = 2561;
		const QName_t LN_non_whitespace_character_count = 2585;
		const QName_t LN_row_count = 2596;
		const QName_t LN_cell_count = 2607;
		const QName_t LN_object_count = 2619;
		const QName_t LN_user_defined = 2632;
		const QName_t LN_name = 2635;
		const QName_t LN_value_type = 2647;
	}
	namespace NS_udcs { /* http://schemas.microsoft.com/data/udc/soap */
		const QName_t LN_Location = 745;
		const QName_t LN_Proxy = 754;
		const QName_t LN_Authentication = 766;
		const QName_t LN_Windows = 767;
		const QName_t LN_Basic = 776;
		const QName_t LN_useExplicit = 788;
		const QName_t LN_userId = 796;
		const QName_t LN_password = 800;
		const QName_t LN_SOAPAction = 809;
	}
	namespace NS_xlink { /* http://www.w3.org/1999/xlink */
		const QName_t LN_href = 2313;
		const QName_t LN_type = 2316;
		const QName_t LN_actuate = 2324;
		const QName_t LN_title = 2328;
		const QName_t LN_show = 2349;
	}
	namespace NS_style { /* urn:oasis:names:tc:opendocument:xmlns:style:1.0 */
		const QName_t LN_chart_properties = 144;
		const QName_t LN_num_prefix = 771;
		const QName_t LN_num_suffix = 782;
		const QName_t LN_num_format = 792;
		const QName_t LN_num_letter_sync = 805;
		const QName_t LN_style = 1336;
		const QName_t LN_name = 1341;
		const QName_t LN_display_name = 1353;
		const QName_t LN_parent_style_name = 1366;
		const QName_t LN_next_style_name = 1380;
		const QName_t LN_list_style_name = 1394;
		const QName_t LN_master_page_name = 1399;
		const QName_t LN_auto_update = 1410;
		const QName_t LN_class = 1417;
		const QName_t LN_default_outline_level = 1434;
		const QName_t LN_map = 1441;
		const QName_t LN_condition = 1448;
		const QName_t LN_apply_style_name = 1462;
		const QName_t LN_base_cell_address = 1466;
		const QName_t LN_default_style = 1479;
		const QName_t LN_page_layout = 1490;
		const QName_t LN_page_usage = 1502;
		const QName_t LN_header_style = 1514;
		const QName_t LN_footer_style = 1525;
		const QName_t LN_master_page = 1536;
		const QName_t LN_header = 1540;
		const QName_t LN_footer = 1546;
		const QName_t LN_header_left = 1558;
		const QName_t LN_footer_left = 1571;
		const QName_t LN_display = 1576;
		const QName_t LN_region_left = 1587;
		const QName_t LN_region_center = 1601;
		const QName_t LN_region_right = 1615;
		const QName_t LN_font_face = 1819;
		const QName_t LN_font_adornments = 2322;
		const QName_t LN_font_family_generic = 2334;
		const QName_t LN_font_pitch = 2344;
		const QName_t LN_font_charset = 2357;
		const QName_t LN_volatile = 2800;
		const QName_t LN_leader_char = 2814;
		const QName_t LN_type = 2818;
		const QName_t LN_position = 2828;
		const QName_t LN_family = 2938;
		const QName_t LN_font_size_asian = 3392;
		const QName_t LN_font_size_complex = 3408;
		const QName_t LN_font_size_rel = 3421;
		const QName_t LN_font_size_rel_asian = 3437;
		const QName_t LN_font_size_rel_complex = 3456;
		const QName_t LN_script_type = 3467;
		const QName_t LN_language_asian = 3493;
		const QName_t LN_language_complex = 3510;
		const QName_t LN_graphic_properties = 3515;
		const QName_t LN_country_asian = 3523;
		const QName_t LN_drawing_page_properties = 3535;
		const QName_t LN_country_complex = 3539;
		const QName_t LN_font_style_asian = 3563;
		const QName_t LN_font_style_complex = 3582;
		const QName_t LN_font_relief = 3594;
		const QName_t LN_text_underline_type = 3623;
		const QName_t LN_text_underline_style = 3642;
		const QName_t LN_text_underline_width = 3663;
		const QName_t LN_text_underline_color = 3679;
		const QName_t LN_font_weight_asian = 3703;
		const QName_t LN_font_weight_complex = 3723;
		const QName_t LN_text_underline_mode = 3739;
		const QName_t LN_text_line_through_mode = 3756;
		const QName_t LN_letter_kerning = 3770;
		const QName_t LN_text_blinking = 3784;
		const QName_t LN_text_combine = 3799;
		const QName_t LN_text_combine_start_char = 3822;
		const QName_t LN_text_combine_end_char = 3836;
		const QName_t LN_text_emphasize = 3848;
		const QName_t LN_text_scale = 3859;
		const QName_t LN_text_rotation_angle = 3877;
		const QName_t LN_text_rotation_scale = 3893;
		const QName_t LN_presentation_page_layout = 3908;
		const QName_t LN_page_layout_properties = 3931;
		const QName_t LN_paragraph_properties = 3958;
		const QName_t LN_paper_tray_name = 3962;
		const QName_t LN_print_orientation = 3976;
		const QName_t LN_line_height_at_least = 3987;
		const QName_t LN_register_truth_ref_style_name = 3998;
		const QName_t LN_line_spacing = 4000;
		const QName_t LN_print = 4005;
		const QName_t LN_print_page_order = 4021;
		const QName_t LN_font_independent_line_spacing = 4023;
		const QName_t LN_first_page_number = 4032;
		const QName_t LN_scale_to = 4044;
		const QName_t LN_scale_to_pages = 4056;
		const QName_t LN_justify_single_word = 4065;
		const QName_t LN_table_centering = 4072;
		const QName_t LN_footnote_max_height = 4090;
		const QName_t LN_footnote_sep = 4105;
		const QName_t LN_width = 4110;
		const QName_t LN_tab_stops = 4112;
		const QName_t LN_color = 4115;
		const QName_t LN_tab_stop = 4120;
		const QName_t LN_char = 4126;
		const QName_t LN_line_style = 4130;
		const QName_t LN_leader_type = 4141;
		const QName_t LN_adjustment = 4142;
		const QName_t LN_leader_style = 4150;
		const QName_t LN_distance_before_sep = 4156;
		const QName_t LN_leader_width = 4161;
		const QName_t LN_distance_after_sep = 4168;
		const QName_t LN_leader_color = 4175;
		const QName_t LN_layout_grid_mode = 4183;
		const QName_t LN_leader_text = 4185;
		const QName_t LN_leader_text_style = 4200;
		const QName_t LN_layout_grid_base_height = 4202;
		const QName_t LN_tab_stop_distance = 4214;
		const QName_t LN_layout_grid_ruby_height = 4222;
		const QName_t LN_layout_grid_lines = 4236;
		const QName_t LN_layout_grid_color = 4253;
		const QName_t LN_drop_cap = 4256;
		const QName_t LN_length = 4265;
		const QName_t LN_layout_grid_ruby_below = 4269;
		const QName_t LN_lines = 4275;
		const QName_t LN_distance = 4281;
		const QName_t LN_layout_grid_print = 4287;
		const QName_t LN_style_name = 4288;
		const QName_t LN_register_true = 4299;
		const QName_t LN_layout_grid_display = 4303;
		const QName_t LN_header_footer_properties = 4319;
		const QName_t LN_dynamic_spacing = 4335;
		const QName_t LN_auto_text_indent = 4346;
		const QName_t LN_text_properties = 4348;
		const QName_t LN_use_window_font_color = 4390;
		const QName_t LN_text_outline = 4403;
		const QName_t LN_text_line_through_type = 4417;
		const QName_t LN_background_image = 4434;
		const QName_t LN_text_line_through_style = 4440;
		const QName_t LN_repeat = 4444;
		const QName_t LN_filter_name = 4450;
		const QName_t LN_text_line_through_width = 4460;
		const QName_t LN_text_line_through_color = 4478;
		const QName_t LN_text_line_through_text = 4496;
		const QName_t LN_text_line_through_text_style = 4516;
		const QName_t LN_border_line_width = 4517;
		const QName_t LN_text_position = 4529;
		const QName_t LN_border_line_width_top = 4533;
		const QName_t LN_font_name = 4539;
		const QName_t LN_border_line_width_bottom = 4550;
		const QName_t LN_font_name_asian = 4551;
		const QName_t LN_font_name_complex = 4567;
		const QName_t LN_border_line_width_left = 4568;
		const QName_t LN_font_family_asian = 4584;
		const QName_t LN_border_line_width_right = 4586;
		const QName_t LN_font_family_complex = 4601;
		const QName_t LN_data_style_name = 4618;
		const QName_t LN_font_family_generic_asian = 4623;
		const QName_t LN_font_family_generic_complex = 4646;
		const QName_t LN_shadow = 4661;
		const QName_t LN_font_style_name = 4662;
		const QName_t LN_font_style_name_asian = 4681;
		const QName_t LN_font_style_name_complex = 4701;
		const QName_t LN_text_autospace = 4702;
		const QName_t LN_font_pitch_asian = 4716;
		const QName_t LN_punctuation_wrap = 4717;
		const QName_t LN_line_break = 4722;
		const QName_t LN_font_pitch_complex = 4735;
		const QName_t LN_vertical_align = 4738;
		const QName_t LN_writing_mode = 4751;
		const QName_t LN_writing_mode_automatic = 4768;
		const QName_t LN_snap_to_layout_grid = 4781;
		const QName_t LN_page_number = 4789;
		const QName_t LN_background_transparency = 4804;
		const QName_t LN_ruby_properties = 4816;
		const QName_t LN_ruby_position = 4829;
		const QName_t LN_ruby_align = 4840;
		const QName_t LN_section_properties = 4854;
		const QName_t LN_columns = 4863;
		const QName_t LN_column = 4891;
		const QName_t LN_column_sep = 4944;
		const QName_t LN_height = 4948;
		const QName_t LN_protect = 4953;
		const QName_t LN_table_properties = 4981;
		const QName_t LN_may_break_between_rows = 5000;
		const QName_t LN_table_column_properties = 5023;
		const QName_t LN_column_width = 5036;
		const QName_t LN_rel_column_width = 5049;
		const QName_t LN_use_optimal_column_width = 5067;
		const QName_t LN_table_row_properties = 5085;
		const QName_t LN_row_height = 5096;
		const QName_t LN_min_row_height = 5110;
		const QName_t LN_use_optimal_row_height = 5126;
		const QName_t LN_table_cell_properties = 5142;
		const QName_t LN_text_align_source = 5158;
		const QName_t LN_direction = 5160;
		const QName_t LN_glyph_orientation_vertical = 5182;
		const QName_t LN_diagonal_tl_br = 5196;
		const QName_t LN_diagonal_tl_br_widths = 5210;
		const QName_t LN_diagonal_bl_tr = 5222;
		const QName_t LN_diagonal_bl_tr_widths = 5236;
		const QName_t LN_rotation_angle = 5262;
		const QName_t LN_rotation_align = 5276;
		const QName_t LN_cell_protect = 5286;
		const QName_t LN_print_content = 5301;
		const QName_t LN_decimal_places = 5304;
		const QName_t LN_repeat_content = 5317;
		const QName_t LN_shrink_to_fit = 5330;
		const QName_t LN_list_level_properties = 5348;
		const QName_t LN_handout_master = 5800;
		const QName_t LN_page_layout_name = 5831;
		const QName_t LN_legend_expansion = 6478;
		const QName_t LN_legend_expansion_aspect_ratio = 6497;
		const QName_t LN_rel_width = 6516;
		const QName_t LN_rel_height = 6526;
		const QName_t LN_horizontal_pos = 6727;
		const QName_t LN_horizontal_rel = 6739;
		const QName_t LN_vertical_pos = 6750;
		const QName_t LN_vertical_rel = 6762;
		const QName_t LN_editable = 6770;
		const QName_t LN_wrap = 6778;
		const QName_t LN_wrap_dynamic_treshold = 6792;
		const QName_t LN_number_wrapped_paragraphs = 6806;
		const QName_t LN_wrap_contour = 6817;
		const QName_t LN_wrap_contour_mode = 6828;
		const QName_t LN_run_through = 6838;
		const QName_t LN_flow_with_text = 6853;
		const QName_t LN_overflow_behavior = 6867;
		const QName_t LN_mirror = 6872;
	}
	namespace NS_fo { /* urn:oasis:names:tc:opendocument:xmlns:xsl-fo-compatible:1.0 */
		const QName_t LN_clip = 5;
		const QName_t LN_language = 2509;
		const QName_t LN_country = 2520;
		const QName_t LN_font_size = 3374;
		const QName_t LN_letter_spacing = 3480;
		const QName_t LN_font_style = 3542;
		const QName_t LN_text_shadow = 3607;
		const QName_t LN_font_weight = 3686;
		const QName_t LN_hyphenate = 3905;
		const QName_t LN_hyphenation_remain_char_count = 3928;
		const QName_t LN_page_width = 3942;
		const QName_t LN_hyphenation_push_char_count = 3947;
		const QName_t LN_page_height = 3950;
		const QName_t LN_line_height = 3971;
		const QName_t LN_text_align = 4035;
		const QName_t LN_text_align_last = 4048;
		const QName_t LN_keep_together = 4079;
		const QName_t LN_widows = 4087;
		const QName_t LN_orphans = 4099;
		const QName_t LN_hyphenation_keep = 4228;
		const QName_t LN_hyphenation_ladder_count = 4247;
		const QName_t LN_margin_left = 4310;
		const QName_t LN_margin_right = 4322;
		const QName_t LN_text_indent = 4333;
		const QName_t LN_font_variant = 4354;
		const QName_t LN_margin_top = 4359;
		const QName_t LN_text_transform = 4367;
		const QName_t LN_color = 4372;
		const QName_t LN_margin_bottom = 4373;
		const QName_t LN_margin = 4381;
		const QName_t LN_break_before = 4394;
		const QName_t LN_break_after = 4407;
		const QName_t LN_background_color = 4418;
		const QName_t LN_border = 4455;
		const QName_t LN_border_top = 4467;
		const QName_t LN_border_bottom = 4480;
		const QName_t LN_border_left = 4489;
		const QName_t LN_border_right = 4503;
		const QName_t LN_font_family = 4570;
		const QName_t LN_padding = 4596;
		const QName_t LN_padding_top = 4609;
		const QName_t LN_padding_bottom = 4622;
		const QName_t LN_padding_left = 4635;
		const QName_t LN_padding_right = 4650;
		const QName_t LN_keep_with_next = 4675;
		const QName_t LN_column_count = 4876;
		const QName_t LN_column_gap = 4886;
		const QName_t LN_start_indent = 4902;
		const QName_t LN_end_indent = 4911;
		const QName_t LN_space_before = 4922;
		const QName_t LN_space_after = 4933;
		const QName_t LN_wrap_option = 5248;
		const QName_t LN_width = 5389;
		const QName_t LN_height = 5396;
		const QName_t LN_min_height = 6568;
		const QName_t LN_min_width = 6578;
		const QName_t LN_max_height = 6584;
		const QName_t LN_max_width = 6591;
	}
	namespace NS_xforms { /* http://www.w3.org/2002/xforms */
		const QName_t LN_model = 72;
		const QName_t LN_bind = 455;
	}
	namespace NS_draw { /* urn:oasis:names:tc:opendocument:xmlns:drawing:1.0 */
		const QName_t LN_wrap_influence_on_position = 21;
		const QName_t LN_frame_display_scrollbar = 35;
		const QName_t LN_frame_display_border = 51;
		const QName_t LN_frame_margin_horizontal = 66;
		const QName_t LN_frame_margin_vertical = 81;
		const QName_t LN_visible_area_left = 89;
		const QName_t LN_visible_area_top = 98;
		const QName_t LN_visible_area_width = 110;
		const QName_t LN_visible_area_height = 121;
		const QName_t LN_ole_draw_aspect = 133;
		const QName_t LN_custom_shape = 147;
		const QName_t LN_engine = 154;
		const QName_t LN_data = 159;
		const QName_t LN_enhanced_geometry = 171;
		const QName_t LN_mirror_vertical = 183;
		const QName_t LN_mirror_horizontal = 197;
		const QName_t LN_text_rotate_angle = 206;
		const QName_t LN_extrusion_allowed = 215;
		const QName_t LN_text_path_allowed = 226;
		const QName_t LN_concentric_gradient_fill_allowed = 242;
		const QName_t LN_extrusion = 253;
		const QName_t LN_extrusion_brightness = 265;
		const QName_t LN_extrusion_depth = 275;
		const QName_t LN_extrusion_diffusion = 287;
		const QName_t LN_extrusion_number_of_line_segments = 306;
		const QName_t LN_extrusion_light_face = 319;
		const QName_t LN_extrusion_first_light_harsh = 336;
		const QName_t LN_extrusion_second_light_harsh = 358;
		const QName_t LN_extrusion_first_light_level = 376;
		const QName_t LN_extrusion_second_light_level = 396;
		const QName_t LN_extrusion_first_light_direction = 417;
		const QName_t LN_extrusion_second_light_direction = 439;
		const QName_t LN_extrusion_metal = 451;
		const QName_t LN_extrusion_rotation_angle = 470;
		const QName_t LN_extrusion_rotation_center = 488;
		const QName_t LN_extrusion_shininess = 503;
		const QName_t LN_extrusion_skew = 516;
		const QName_t LN_extrusion_specularity = 532;
		const QName_t LN_extrusion_viewpoint = 547;
		const QName_t LN_extrusion_origin = 559;
		const QName_t LN_extrusion_color = 573;
		const QName_t LN_enhanced_path = 587;
		const QName_t LN_path_stretchpoint_x = 602;
		const QName_t LN_path_stretchpoint_y = 619;
		const QName_t LN_text_areas = 629;
		const QName_t LN_glue_points = 640;
		const QName_t LN_glue_point_type = 653;
		const QName_t LN_glue_point_leaving_directions = 673;
		const QName_t LN_text_path = 682;
		const QName_t LN_text_path_mode = 697;
		const QName_t LN_text_path_scale = 709;
		const QName_t LN_text_path_same_letter_heights = 727;
		const QName_t LN_modifiers = 737;
		const QName_t LN_background_size = 740;
		const QName_t LN_equation = 747;
		const QName_t LN_formula = 751;
		const QName_t LN_handle = 758;
		const QName_t LN_handle_mirror_vertical = 775;
		const QName_t LN_handle_mirror_horizontal = 793;
		const QName_t LN_handle_switched = 806;
		const QName_t LN_handle_position = 818;
		const QName_t LN_handle_range_x_minimum = 834;
		const QName_t LN_handle_range_x_maximum = 846;
		const QName_t LN_handle_range_y_minimum = 863;
		const QName_t LN_handle_range_y_maximum = 878;
		const QName_t LN_handle_polar = 889;
		const QName_t LN_handle_radius_range_minimum = 902;
		const QName_t LN_handle_radius_range_maximum = 922;
		const QName_t LN_gradient = 3547;
		const QName_t LN_display_name = 3552;
		const QName_t LN_style = 3558;
		const QName_t LN_cx = 3566;
		const QName_t LN_cy = 3572;
		const QName_t LN_start_color = 3585;
		const QName_t LN_end_color = 3596;
		const QName_t LN_start_intensity = 3612;
		const QName_t LN_end_intensity = 3625;
		const QName_t LN_angle = 3634;
		const QName_t LN_border = 3645;
		const QName_t LN_hatch = 3777;
		const QName_t LN_distance = 3783;
		const QName_t LN_rotation = 3795;
		const QName_t LN_fill_image = 3807;
		const QName_t LN_opacity = 3816;
		const QName_t LN_start = 3823;
		const QName_t LN_end = 3827;
		const QName_t LN_marker = 3835;
		const QName_t LN_stroke_dash = 3844;
		const QName_t LN_dots1 = 3854;
		const QName_t LN_dots1_length = 3867;
		const QName_t LN_dots2 = 3875;
		const QName_t LN_dots2_length = 3889;
		const QName_t LN_stroke = 5404;
		const QName_t LN_stroke_dash_names = 5421;
		const QName_t LN_marker_start = 5459;
		const QName_t LN_marker_end = 5470;
		const QName_t LN_marker_start_width = 5486;
		const QName_t LN_marker_end_width = 5498;
		const QName_t LN_marker_start_center = 5514;
		const QName_t LN_marker_end_center = 5526;
		const QName_t LN_stroke_linejoin = 5552;
		const QName_t LN_fill = 5558;
		const QName_t LN_fill_color = 5567;
		const QName_t LN_secondary_fill_color = 5582;
		const QName_t LN_fill_gradient_name = 5597;
		const QName_t LN_gradient_step_count = 5616;
		const QName_t LN_fill_hatch_name = 5629;
		const QName_t LN_fill_hatch_solid = 5642;
		const QName_t LN_fill_image_name = 5654;
		const QName_t LN_fill_image_width = 5670;
		const QName_t LN_fill_image_height = 5685;
		const QName_t LN_fill_image_ref_point_x = 5701;
		const QName_t LN_fill_image_ref_point_y = 5720;
		const QName_t LN_fill_image_ref_point = 5736;
		const QName_t LN_tile_repeat_offset = 5750;
		const QName_t LN_opacity_name = 5762;
		const QName_t LN_symbol_color = 5785;
		const QName_t LN_style_name = 5836;
		const QName_t LN_layer_set = 5845;
		const QName_t LN_layer = 5853;
		const QName_t LN_name = 5858;
		const QName_t LN_protected = 5863;
		const QName_t LN_display = 5868;
		const QName_t LN_page = 5872;
		const QName_t LN_master_page_name = 5877;
		const QName_t LN_shape_id = 5883;
		const QName_t LN_auto_grow_width = 5900;
		const QName_t LN_auto_grow_height = 5915;
		const QName_t LN_id = 5927;
		const QName_t LN_fit_to_size = 5928;
		const QName_t LN_rect = 5937;
		const QName_t LN_fit_to_contour = 5943;
		const QName_t LN_corner_radius = 5950;
		const QName_t LN_line = 5957;
		const QName_t LN_textarea_vertical_align = 5959;
		const QName_t LN_color = 5983;
		const QName_t LN_textarea_horizontal_align = 5985;
		const QName_t LN_color_mode = 5998;
		const QName_t LN_polyline = 5999;
		const QName_t LN_points = 6008;
		const QName_t LN_color_inversion = 6013;
		const QName_t LN_polygon = 6018;
		const QName_t LN_luminance = 6027;
		const QName_t LN_regular_polygon = 6034;
		const QName_t LN_contrast = 6037;
		const QName_t LN_concave = 6043;
		const QName_t LN_gamma = 6044;
		const QName_t LN_red = 6053;
		const QName_t LN_corners = 6055;
		const QName_t LN_green = 6060;
		const QName_t LN_sharpness = 6065;
		const QName_t LN_blue = 6070;
		const QName_t LN_path = 6071;
		const QName_t LN_image_opacity = 6082;
		const QName_t LN_shadow = 6090;
		const QName_t LN_circle = 6092;
		const QName_t LN_shadow_offset_x = 6104;
		const QName_t LN_kind = 6115;
		const QName_t LN_shadow_offset_y = 6119;
		const QName_t LN_start_angle = 6125;
		const QName_t LN_shadow_color = 6131;
		const QName_t LN_end_angle = 6136;
		const QName_t LN_shadow_opacity = 6143;
		const QName_t LN_ellipse = 6146;
		const QName_t LN_start_line_spacing_horizontal = 6169;
		const QName_t LN_connector = 6173;
		const QName_t LN_type = 6178;
		const QName_t LN_start_shape = 6190;
		const QName_t LN_start_line_spacing_vertical = 6194;
		const QName_t LN_start_glue_point = 6208;
		const QName_t LN_end_line_spacing_horizontal = 6216;
		const QName_t LN_end_shape = 6219;
		const QName_t LN_end_glue_point = 6234;
		const QName_t LN_end_line_spacing_vertical = 6237;
		const QName_t LN_line_skew = 6245;
		const QName_t LN_line_distance = 6252;
		const QName_t LN_caption = 6256;
		const QName_t LN_guide_overhang = 6266;
		const QName_t LN_caption_point_x = 6272;
		const QName_t LN_guide_distance = 6283;
		const QName_t LN_caption_point_y = 6287;
		const QName_t LN_measure = 6291;
		const QName_t LN_start_guide = 6295;
		const QName_t LN_control = 6301;
		const QName_t LN_end_guide = 6304;
		const QName_t LN_placing = 6315;
		const QName_t LN_page_thumbnail = 6316;
		const QName_t LN_page_number = 6322;
		const QName_t LN_parallel = 6327;
		const QName_t LN_g = 6329;
		const QName_t LN_measure_align = 6343;
		const QName_t LN_measure_vertical_align = 6360;
		const QName_t LN_unit = 6367;
		const QName_t LN_transform = 6368;
		const QName_t LN_show_unit = 6377;
		const QName_t LN_decimal_places = 6385;
		const QName_t LN_class_names = 6386;
		const QName_t LN_caption_type = 6399;
		const QName_t LN_text_style_name = 6406;
		const QName_t LN_caption_angle_type = 6409;
		const QName_t LN_z_index = 6413;
		const QName_t LN_caption_angle = 6418;
		const QName_t LN_caption_gap = 6426;
		const QName_t LN_caption_escape_direction = 6440;
		const QName_t LN_caption_escape = 6451;
		const QName_t LN_caption_line_length = 6468;
		const QName_t LN_glue_point = 6481;
		const QName_t LN_caption_fit_line_length = 6485;
		const QName_t LN_align = 6489;
		const QName_t LN_escape_direction = 6501;
		const QName_t LN_frame = 6508;
		const QName_t LN_copy_of = 6536;
		const QName_t LN_text_box = 6546;
		const QName_t LN_chain_next_name = 6559;
		const QName_t LN_image = 6594;
		const QName_t LN_filter_name = 6606;
		const QName_t LN_object = 6612;
		const QName_t LN_object_ole = 6619;
		const QName_t LN_notify_on_update_of_ranges = 6632;
		const QName_t LN_class_id = 6640;
		const QName_t LN_applet = 6647;
		const QName_t LN_code = 6654;
		const QName_t LN_archive = 6666;
		const QName_t LN_may_script = 6676;
		const QName_t LN_plugin = 6686;
		const QName_t LN_mime_type = 6695;
		const QName_t LN_param = 6702;
		const QName_t LN_value = 6709;
		const QName_t LN_floating_frame = 6722;
		const QName_t LN_frame_name = 6731;
		const QName_t LN_contour_polygon = 6744;
		const QName_t LN_contour_path = 6754;
		const QName_t LN_recreate_on_edit = 6767;
		const QName_t LN_a = 6780;
		const QName_t LN_image_map = 6799;
		const QName_t LN_area_rectangle = 6807;
		const QName_t LN_area_circle = 6815;
		const QName_t LN_area_polygon = 6824;
		const QName_t LN_nohref = 6832;
	}
	namespace NS_prj12 { /* http://schemas.microsoft.com/project */
		const QName_t LN_Type = 2074;
		const QName_t LN_UID = 2083;
		const QName_t LN_Start = 2091;
		const QName_t LN_Finish = 2101;
		const QName_t LN_Unit = 2111;
		const QName_t LN_Value = 2116;
		const QName_t LN_Project = 2127;
		const QName_t LN_Name = 2132;
		const QName_t LN_Title = 2138;
		const QName_t LN_Subject = 2143;
		const QName_t LN_Category = 2149;
		const QName_t LN_Company = 2155;
		const QName_t LN_Manager = 2161;
		const QName_t LN_Author = 2171;
		const QName_t LN_CreationDate = 2182;
		const QName_t LN_Revision = 2188;
		const QName_t LN_LastSaved = 2199;
		const QName_t LN_ScheduleFromStart = 2213;
		const QName_t LN_StartDate = 2223;
		const QName_t LN_FinishDate = 2232;
		const QName_t LN_FYStartDate = 2242;
		const QName_t LN_CriticalSlackLimit = 2257;
		const QName_t LN_CurrencyDigits = 2268;
		const QName_t LN_CurrencySymbol = 2280;
		const QName_t LN_CurrencySymbolPosition = 2299;
		const QName_t LN_CalendarUID = 2311;
		const QName_t LN_DefaultStartTime = 2321;
		const QName_t LN_DefaultFinishTime = 2333;
		const QName_t LN_MinutesPerDay = 2345;
		const QName_t LN_MinutesPerWeek = 2359;
		const QName_t LN_DaysPerMonth = 2368;
		const QName_t LN_DefaultTaskType = 2381;
		const QName_t LN_DefaultFixedCostAccrual = 2399;
		const QName_t LN_DefaultStandardRate = 2415;
		const QName_t LN_DefaultOvertimeRate = 2426;
		const QName_t LN_DurationFormat = 2441;
		const QName_t LN_WorkFormat = 2452;
		const QName_t LN_EditableActualCosts = 2466;
		const QName_t LN_HonorConstraints = 2481;
		const QName_t LN_EarnedValueMethod = 2494;
		const QName_t LN_InsertedProjectsLikeSummary = 2515;
		const QName_t LN_MultipleCriticalPaths = 2536;
		const QName_t LN_NewTasksEffortDriven = 2551;
		const QName_t LN_NewTasksEstimated = 2564;
		const QName_t LN_SplitsInProgressTasks = 2581;
		const QName_t LN_SpreadActualCost = 2597;
		const QName_t LN_SpreadPercentComplete = 2614;
		const QName_t LN_TaskUpdatesResource = 2631;
		const QName_t LN_FiscalYearStart = 2645;
		const QName_t LN_WeekStartDay = 2658;
		const QName_t LN_MoveCompletedEndsBack = 2675;
		const QName_t LN_MoveRemainingStartsBack = 2695;
		const QName_t LN_MoveRemainingStartsForward = 2717;
		const QName_t LN_MoveCompletedEndsForward = 2736;
		const QName_t LN_BaselineForEarnedValue = 2752;
		const QName_t LN_AutoAddNewResourcesAndTasks = 2775;
		const QName_t LN_StatusDate = 2786;
		const QName_t LN_CurrentDate = 2799;
		const QName_t LN_MicrosoftProjectServerURL = 2819;
		const QName_t LN_Autolink = 2829;
		const QName_t LN_NewTaskStartDate = 2842;
		const QName_t LN_DefaultTaskEVMethod = 2858;
		const QName_t LN_ProjectExternallyEdited = 2878;
		const QName_t LN_ExtendedCreationDate = 2894;
		const QName_t LN_ActualsInSync = 2907;
		const QName_t LN_RemoveFileProperties = 2923;
		const QName_t LN_AdminProject = 2931;
		const QName_t LN_OutlineCodes = 2944;
		const QName_t LN_OutlineCode = 2955;
		const QName_t LN_FieldID = 2966;
		const QName_t LN_FieldName = 2981;
		const QName_t LN_Alias = 2991;
		const QName_t LN_PhoneticAlias = 3007;
		const QName_t LN_Values = 3018;
		const QName_t LN_ValueID = 3029;
		const QName_t LN_ParentValueID = 3042;
		const QName_t LN_Description = 3047;
		const QName_t LN_Enterprise = 3061;
		const QName_t LN_EnterpriseOutlineCodeAlias = 3085;
		const QName_t LN_ResourceSubstitutionEnabled = 3107;
		const QName_t LN_LeafOnly = 3118;
		const QName_t LN_AllLevelsRequired = 3132;
		const QName_t LN_OnlyTableValuesAllowed = 3147;
		const QName_t LN_Masks = 3156;
		const QName_t LN_Mask = 3166;
		const QName_t LN_Level = 3176;
		const QName_t LN_Length = 3186;
		const QName_t LN_Separator = 3196;
		const QName_t LN_WBSMasks = 3209;
		const QName_t LN_VerifyUniqueCodes = 3223;
		const QName_t LN_GenerateCodes = 3229;
		const QName_t LN_Prefix = 3237;
		const QName_t LN_WBSMask = 3246;
		const QName_t LN_ExtendedAttributes = 3264;
		const QName_t LN_ExtendedAttribute = 3280;
		const QName_t LN_RollupType = 3291;
		const QName_t LN_CalculationType = 3306;
		const QName_t LN_Formula = 3314;
		const QName_t LN_RestrictValues = 3327;
		const QName_t LN_ValuelistSortOrder = 3344;
		const QName_t LN_AppendNewValues = 3357;
		const QName_t LN_Default = 3361;
		const QName_t LN_ValueList = 3375;
		const QName_t LN_ID = 3384;
		const QName_t LN_Calendars = 3395;
		const QName_t LN_Calendar = 3400;
		const QName_t LN_IsBaseCalendar = 3415;
		const QName_t LN_BaseCalendarUID = 3428;
		const QName_t LN_WeekDays = 3438;
		const QName_t LN_WeekDay = 3448;
		const QName_t LN_DayType = 3458;
		const QName_t LN_DayWorking = 3470;
		const QName_t LN_TimePeriod = 3477;
		const QName_t LN_FromDate = 3489;
		const QName_t LN_ToDate = 3499;
		const QName_t LN_WorkingTimes = 3511;
		const QName_t LN_WorkingTime = 3524;
		const QName_t LN_FromTime = 3531;
		const QName_t LN_ToTime = 3543;
		const QName_t LN_Tasks = 3555;
		const QName_t LN_Task = 3565;
		const QName_t LN_IsNull = 3576;
		const QName_t LN_CreateDate = 3589;
		const QName_t LN_Contact = 3599;
		const QName_t LN_WBS = 3606;
		const QName_t LN_WBSLevel = 3618;
		const QName_t LN_OutlineNumber = 3630;
		const QName_t LN_OutlineLevel = 3643;
		const QName_t LN_Priority = 3652;
		const QName_t LN_Duration = 3665;
		const QName_t LN_Work = 3673;
		const QName_t LN_Stop = 3682;
		const QName_t LN_Resume = 3692;
		const QName_t LN_ResumeValid = 3706;
		const QName_t LN_EffortDriven = 3719;
		const QName_t LN_Recurring = 3732;
		const QName_t LN_OverAllocated = 3742;
		const QName_t LN_Estimated = 3751;
		const QName_t LN_Milestone = 3762;
		const QName_t LN_Summary = 3773;
		const QName_t LN_Critical = 3785;
		const QName_t LN_IsSubproject = 3800;
		const QName_t LN_IsSubprojectReadOnly = 3818;
		const QName_t LN_SubprojectName = 3832;
		const QName_t LN_ExternalTask = 3843;
		const QName_t LN_ExternalTaskProject = 3858;
		const QName_t LN_EarlyStart = 3871;
		const QName_t LN_EarlyFinish = 3883;
		const QName_t LN_LateStart = 3894;
		const QName_t LN_LateFinish = 3907;
		const QName_t LN_StartVariance = 3921;
		const QName_t LN_FinishVariance = 3934;
		const QName_t LN_WorkVariance = 3944;
		const QName_t LN_FreeSlack = 3952;
		const QName_t LN_TotalSlack = 3960;
		const QName_t LN_FixedCost = 3970;
		const QName_t LN_FixedCostAccrual = 3986;
		const QName_t LN_PercentComplete = 3999;
		const QName_t LN_PercentWorkComplete = 4017;
		const QName_t LN_Cost = 4024;
		const QName_t LN_OvertimeCost = 4037;
		const QName_t LN_OvertimeWork = 4049;
		const QName_t LN_ActualStart = 4060;
		const QName_t LN_ActualFinish = 4073;
		const QName_t LN_ActualDuration = 4085;
		const QName_t LN_ActualCost = 4102;
		const QName_t LN_ActualOvertimeCost = 4122;
		const QName_t LN_ActualWork = 4135;
		const QName_t LN_ActualOvertimeWork = 4147;
		const QName_t LN_RegularWork = 4159;
		const QName_t LN_RemainingDuration = 4173;
		const QName_t LN_RemainingCost = 4186;
		const QName_t LN_RemainingWork = 4197;
		const QName_t LN_RemainingOvertimeCost = 4216;
		const QName_t LN_RemainingOvertimeWork = 4233;
		const QName_t LN_ACWP = 4243;
		const QName_t LN_CV = 4246;
		const QName_t LN_ConstraintType = 4260;
		const QName_t LN_ConstraintDate = 4274;
		const QName_t LN_Deadline = 4286;
		const QName_t LN_LevelAssignments = 4300;
		const QName_t LN_LevelingCanSplit = 4315;
		const QName_t LN_LevelingDelay = 4327;
		const QName_t LN_LevelingDelayFormat = 4343;
		const QName_t LN_PreLeveledStart = 4357;
		const QName_t LN_PreLeveledFinish = 4370;
		const QName_t LN_Hyperlink = 4378;
		const QName_t LN_HyperlinkAddress = 4391;
		const QName_t LN_HyperlinkSubAddress = 4408;
		const QName_t LN_IgnoreResourceCalendar = 4426;
		const QName_t LN_Notes = 4432;
		const QName_t LN_HideBar = 4443;
		const QName_t LN_Rollup = 4454;
		const QName_t LN_BCWS = 4462;
		const QName_t LN_BCWP = 4470;
		const QName_t LN_PhysicalPercentComplete = 4486;
		const QName_t LN_PredecessorLink = 4501;
		const QName_t LN_PredecessorUID = 4512;
		const QName_t LN_CrossProject = 4523;
		const QName_t LN_CrossProjectName = 4540;
		const QName_t LN_LinkLag = 4548;
		const QName_t LN_LagFormat = 4559;
		const QName_t LN_ActualWorkProtected = 4575;
		const QName_t LN_ActualOvertimeWorkProtected = 4593;
		const QName_t LN_Baseline = 4605;
		const QName_t LN_TimephasedData = 4619;
		const QName_t LN_Number = 4628;
		const QName_t LN_Interim = 4640;
		const QName_t LN_EstimatedDuration = 4657;
		const QName_t LN_Resources = 4668;
		const QName_t LN_Resource = 4677;
		const QName_t LN_Initials = 4685;
		const QName_t LN_Phonetics = 4694;
		const QName_t LN_NTAccount = 4705;
		const QName_t LN_MaterialLabel = 4719;
		const QName_t LN_Code = 4729;
		const QName_t LN_Group = 4734;
		const QName_t LN_WorkGroup = 4744;
		const QName_t LN_EmailAddress = 4756;
		const QName_t LN_MaxUnits = 4766;
		const QName_t LN_PeakUnits = 4775;
		const QName_t LN_AvailableFrom = 4790;
		const QName_t LN_AvailableTo = 4798;
		const QName_t LN_CanLevel = 4807;
		const QName_t LN_AccrueAt = 4815;
		const QName_t LN_StandardRate = 4828;
		const QName_t LN_StandardRateFormat = 4842;
		const QName_t LN_OvertimeRate = 4855;
		const QName_t LN_OvertimeRateFormat = 4870;
		const QName_t LN_CostPerUse = 4882;
		const QName_t LN_CostVariance = 4894;
		const QName_t LN_SV = 4897;
		const QName_t LN_IsGeneric = 4907;
		const QName_t LN_IsInactive = 4917;
		const QName_t LN_IsEnterprise = 4928;
		const QName_t LN_BookingType = 4938;
		const QName_t LN_ActiveDirectoryGUID = 4954;
		const QName_t LN_AvailabilityPeriods = 4966;
		const QName_t LN_AvailabilityPeriod = 4982;
		const QName_t LN_AvailableUnits = 4992;
		const QName_t LN_Rates = 4999;
		const QName_t LN_Rate = 5005;
		const QName_t LN_RatesFrom = 5013;
		const QName_t LN_RatesTo = 5021;
		const QName_t LN_RateTable = 5032;
		const QName_t LN_Assignments = 5041;
		const QName_t LN_Assignment = 5050;
		const QName_t LN_TaskUID = 5059;
		const QName_t LN_ResourceUID = 5071;
		const QName_t LN_Confirmed = 5080;
		const QName_t LN_CostRateTable = 5094;
		const QName_t LN_Delay = 5103;
		const QName_t LN_HasFixedRateUnits = 5116;
		const QName_t LN_FixedMaterial = 5129;
		const QName_t LN_LinkedFields = 5140;
		const QName_t LN_Overallocated = 5151;
		const QName_t LN_ResponsePending = 5168;
		const QName_t LN_Units = 5174;
		const QName_t LN_UpdateNeeded = 5188;
		const QName_t LN_VAC = 5194;
		const QName_t LN_WorkContour = 5205;
	}
	namespace NS_mdc12 { /* http://schemas.microsoft.com/package/2005/06/metadata/core-properties */
		const QName_t LN_CoreProperties = 1009;
		const QName_t LN_Creator = 1017;
		const QName_t LN_Title = 1021;
		const QName_t LN_Subject = 1027;
		const QName_t LN_Category = 1033;
		const QName_t LN_Keywords = 1041;
		const QName_t LN_Description = 1048;
		const QName_t LN_ContentType = 1058;
		const QName_t LN_ContentStatus = 1069;
		const QName_t LN_Version = 1077;
		const QName_t LN_Revision = 1084;
		const QName_t LN_DateCreated = 1094;
		const QName_t LN_DateModified = 1101;
		const QName_t LN_LastModifiedBy = 1109;
		const QName_t LN_LastPrinted = 1116;
		const QName_t LN_Language = 1124;
		const QName_t LN_Identifier = 1135;
	}
	namespace NS_table { /* urn:oasis:names:tc:opendocument:xmlns:table:1.0 */
		const QName_t LN_dde_link = 913;
		const QName_t LN_table_template = 1636;
		const QName_t LN_first_row = 1721;
		const QName_t LN_last_row = 1732;
		const QName_t LN_first_column = 1745;
		const QName_t LN_last_column = 1754;
		const QName_t LN_body = 1760;
		const QName_t LN_even_rows = 1768;
		const QName_t LN_odd_rows = 1781;
		const QName_t LN_even_columns = 1794;
		const QName_t LN_odd_columns = 1808;
		const QName_t LN_table = 2870;
		const QName_t LN_name = 2875;
		const QName_t LN_style_name = 2880;
		const QName_t LN_protected = 2885;
		const QName_t LN_protection_key = 2889;
		const QName_t LN_print = 2898;
		const QName_t LN_print_ranges = 2909;
		const QName_t LN_table_row = 2917;
		const QName_t LN_number_rows_repeated = 2933;
		const QName_t LN_default_cell_style_name = 2952;
		const QName_t LN_visibility = 2964;
		const QName_t LN_table_cell = 2979;
		const QName_t LN_covered_table_cell = 2998;
		const QName_t LN_number_columns_repeated = 3022;
		const QName_t LN_number_columns_spanned = 3041;
		const QName_t LN_number_rows_spanned = 3059;
		const QName_t LN_content_validation_name = 3080;
		const QName_t LN_formula = 3088;
		const QName_t LN_number_matrix_columns_spanned = 3110;
		const QName_t LN_number_matrix_rows_spanned = 3131;
		const QName_t LN_protect = 3138;
		const QName_t LN_table_column = 3151;
		const QName_t LN_table_header_columns = 3168;
		const QName_t LN_table_columns = 3183;
		const QName_t LN_table_column_group = 3202;
		const QName_t LN_display = 3208;
		const QName_t LN_table_header_rows = 3222;
		const QName_t LN_table_rows = 3228;
		const QName_t LN_table_row_group = 3241;
		const QName_t LN_is_sub_table = 3255;
		const QName_t LN_table_source = 3287;
		const QName_t LN_mode = 3295;
		const QName_t LN_table_name = 3300;
		const QName_t LN_filter_name = 3305;
		const QName_t LN_filter_options = 3320;
		const QName_t LN_refresh_delay = 3330;
		const QName_t LN_scenario = 3339;
		const QName_t LN_scenario_ranges = 3356;
		const QName_t LN_is_active = 3366;
		const QName_t LN_display_border = 3383;
		const QName_t LN_border_color = 3396;
		const QName_t LN_copy_back = 3407;
		const QName_t LN_copy_styles = 3418;
		const QName_t LN_copy_formulas = 3431;
		const QName_t LN_comment = 3442;
		const QName_t LN_shapes = 3450;
		const QName_t LN_cell_range_source = 3465;
		const QName_t LN_last_column_spanned = 3482;
		const QName_t LN_last_row_spanned = 3497;
		const QName_t LN_detective = 3508;
		const QName_t LN_operation = 3517;
		const QName_t LN_index = 3527;
		const QName_t LN_highlighted_range = 3544;
		const QName_t LN_cell_range_address = 3567;
		const QName_t LN_direction = 3578;
		const QName_t LN_contains_error = 3593;
		const QName_t LN_marked_invalid = 3609;
		const QName_t LN_structure_protected = 3624;
		const QName_t LN_calculation_settings = 3644;
		const QName_t LN_case_sensitive = 3657;
		const QName_t LN_precision_as_shown = 3676;
		const QName_t LN_search_criteria_must_apply_to_whole_cell = 3708;
		const QName_t LN_automatic_find_labels = 3730;
		const QName_t LN_use_regular_expressions = 3747;
		const QName_t LN_null_year = 3757;
		const QName_t LN_null_date = 3767;
		const QName_t LN_value_type = 3772;
		const QName_t LN_date_value_type = 3789;
		const QName_t LN_iteration = 3801;
		const QName_t LN_status = 3811;
		const QName_t LN_steps = 3821;
		const QName_t LN_maximum_difference = 3834;
		const QName_t LN_content_validations = 3849;
		const QName_t LN_content_validation = 3866;
		const QName_t LN_condition = 3869;
		const QName_t LN_base_cell_address = 3887;
		const QName_t LN_allow_empty_cell = 3901;
		const QName_t LN_display_list = 3915;
		const QName_t LN_help_message = 3926;
		const QName_t LN_title = 3932;
		const QName_t LN_error_message = 3943;
		const QName_t LN_message_type = 3955;
		const QName_t LN_error_macro = 3963;
		const QName_t LN_execute = 3972;
		const QName_t LN_label_ranges = 3983;
		const QName_t LN_label_range = 3996;
		const QName_t LN_label_cell_range_address = 4016;
		const QName_t LN_data_cell_range_address = 4034;
		const QName_t LN_orientation = 4045;
		const QName_t LN_named_expressions = 4062;
		const QName_t LN_named_range = 4074;
		const QName_t LN_range_usable_as = 4088;
		const QName_t LN_named_expression = 4111;
		const QName_t LN_expression = 4119;
		const QName_t LN_database_ranges = 4136;
		const QName_t LN_database_range = 4146;
		const QName_t LN_is_selection = 4158;
		const QName_t LN_on_update_keep_styles = 4176;
		const QName_t LN_on_update_keep_size = 4191;
		const QName_t LN_has_persistent_data = 4206;
		const QName_t LN_contains_header = 4219;
		const QName_t LN_display_filter_buttons = 4237;
		const QName_t LN_target_range_address = 4255;
		const QName_t LN_database_source_sql = 4272;
		const QName_t LN_database_name = 4277;
		const QName_t LN_sql_statement = 4291;
		const QName_t LN_parse_sql_statement = 4307;
		const QName_t LN_database_source_table = 4324;
		const QName_t LN_database_table_name = 4340;
		const QName_t LN_database_source_query = 4358;
		const QName_t LN_query_name = 4368;
		const QName_t LN_sort = 4379;
		const QName_t LN_bind_styles_to_content = 4395;
		const QName_t LN_language = 4401;
		const QName_t LN_country = 4406;
		const QName_t LN_algorithm = 4416;
		const QName_t LN_sort_by = 4423;
		const QName_t LN_field_number = 4436;
		const QName_t LN_data_type = 4448;
		const QName_t LN_order = 4457;
		const QName_t LN_subtotal_rules = 4472;
		const QName_t LN_page_breaks_on_group_change = 4492;
		const QName_t LN_sort_groups = 4504;
		const QName_t LN_subtotal_rule = 4513;
		const QName_t LN_group_by_field_number = 4532;
		const QName_t LN_subtotal_field = 4543;
		const QName_t LN_function = 4553;
		const QName_t LN_filter = 4562;
		const QName_t LN_condition_source = 4577;
		const QName_t LN_condition_source_range_address = 4598;
		const QName_t LN_display_duplicates = 4611;
		const QName_t LN_filter_and = 4627;
		const QName_t LN_filter_or = 4638;
		const QName_t LN_filter_condition = 4654;
		const QName_t LN_value = 4660;
		const QName_t LN_operator = 4672;
		const QName_t LN_data_pilot_tables = 4687;
		const QName_t LN_data_pilot_table = 4704;
		const QName_t LN_application_data = 4718;
		const QName_t LN_grand_total = 4731;
		const QName_t LN_ignore_empty_rows = 4748;
		const QName_t LN_identify_categories = 4762;
		const QName_t LN_buttons = 4773;
		const QName_t LN_show_filter_button = 4788;
		const QName_t LN_drill_down_on_double_click = 4806;
		const QName_t LN_source_cell_range = 4820;
		const QName_t LN_source_service = 4832;
		const QName_t LN_source_name = 4844;
		const QName_t LN_object_name = 4853;
		const QName_t LN_user_name = 4865;
		const QName_t LN_password = 4874;
		const QName_t LN_data_pilot_field = 4889;
		const QName_t LN_source_field_name = 4904;
		const QName_t LN_selected_page = 4914;
		const QName_t LN_is_data_layout_field = 4930;
		const QName_t LN_used_hierarchy = 4939;
		const QName_t LN_data_pilot_level = 4956;
		const QName_t LN_show_empty = 4964;
		const QName_t LN_data_pilot_subtotals = 4977;
		const QName_t LN_align = 4984;
		const QName_t LN_data_pilot_subtotal = 4990;
		const QName_t LN_data_pilot_members = 5004;
		const QName_t LN_border_model = 5009;
		const QName_t LN_data_pilot_member = 5016;
		const QName_t LN_show_details = 5027;
		const QName_t LN_data_pilot_display_info = 5044;
		const QName_t LN_enabled = 5052;
		const QName_t LN_data_field = 5062;
		const QName_t LN_member_count = 5074;
		const QName_t LN_display_member_mode = 5091;
		const QName_t LN_data_pilot_sort_info = 5108;
		const QName_t LN_sort_mode = 5118;
		const QName_t LN_data_pilot_layout_info = 5135;
		const QName_t LN_layout_mode = 5146;
		const QName_t LN_add_empty_lines = 5159;
		const QName_t LN_data_pilot_field_reference = 5179;
		const QName_t LN_field_name = 5192;
		const QName_t LN_member_type = 5201;
		const QName_t LN_member_name = 5214;
		const QName_t LN_type = 5216;
		const QName_t LN_data_pilot_groups = 5230;
		const QName_t LN_date_start = 5239;
		const QName_t LN_start = 5244;
		const QName_t LN_date_end = 5253;
		const QName_t LN_end = 5261;
		const QName_t LN_step = 5267;
		const QName_t LN_grouped_by = 5280;
		const QName_t LN_data_pilot_group = 5294;
		const QName_t LN_data_pilot_group_member = 5312;
		const QName_t LN_consolidation = 5323;
		const QName_t LN_source_cell_range_addresses = 5343;
		const QName_t LN_target_cell_address = 5364;
		const QName_t LN_use_labels = 5376;
		const QName_t LN_link_to_source_data = 5390;
		const QName_t LN_dde_links = 5402;
		const QName_t LN_tracked_changes = 5407;
		const QName_t LN_track_changes = 5414;
		const QName_t LN_insertion = 5417;
		const QName_t LN_position = 5424;
		const QName_t LN_count = 5433;
		const QName_t LN_dependencies = 5445;
		const QName_t LN_dependency = 5454;
		const QName_t LN_id = 5462;
		const QName_t LN_deletions = 5472;
		const QName_t LN_cell_content_deletion = 5490;
		const QName_t LN_change_deletion = 5501;
		const QName_t LN_deletion = 5505;
		const QName_t LN_multi_deletion_spanned = 5521;
		const QName_t LN_cut_offs = 5532;
		const QName_t LN_insertion_cut_off = 5546;
		const QName_t LN_movement_cut_off = 5559;
		const QName_t LN_start_position = 5569;
		const QName_t LN_end_position = 5580;
		const QName_t LN_movement = 5590;
		const QName_t LN_source_range_address = 5607;
		const QName_t LN_column = 5617;
		const QName_t LN_row = 5623;
		const QName_t LN_start_column = 5633;
		const QName_t LN_start_row = 5644;
		const QName_t LN_start_table = 5657;
		const QName_t LN_end_column = 5668;
		const QName_t LN_end_row = 5678;
		const QName_t LN_end_table = 5689;
		const QName_t LN_change_track_table_cell = 5705;
		const QName_t LN_cell_address = 5714;
		const QName_t LN_matrix_covered = 5729;
		const QName_t LN_cell_content_change = 5743;
		const QName_t LN_previous = 5752;
		const QName_t LN_acceptance_state = 5769;
		const QName_t LN_rejecting_change_id = 5784;
		const QName_t LN_end_cell_address = 6423;
		const QName_t LN_cell_range = 6424;
		const QName_t LN_end_x = 6428;
		const QName_t LN_end_y = 6434;
		const QName_t LN_table_background = 6447;
	}
	namespace NS_rs11 { /* urn:schemas-microsoft-com:rowset */
		const QName_t LN_data = 3855;
	}
	namespace NS_sxr12 { /* http://schemas.microsoft.com/office/excel/2005/8/sxref */
		const QName_t LN_pivotRefs = 2906;
		const QName_t LN_pivotRef = 2915;
		const QName_t LN_rule = 2918;
		const QName_t LN_pivotRefInternal = 2930;
		const QName_t LN_flags = 2940;
		const QName_t LN_slicers = 2949;
		const QName_t LN_slicer = 2959;
		const QName_t LN_elements = 2969;
		const QName_t LN_element = 2976;
		const QName_t LN_n = 2982;
		const QName_t LN_d = 2987;
		const QName_t LN_x = 2993;
		const QName_t LN_s = 2999;
		const QName_t LN_b = 3004;
		const QName_t LN_e = 3011;
	}
	namespace NS_xldr12 { /* http://schemas.microsoft.com/office/officeart/2005/8/xldr */
		const QName_t LN_cdrElemPr = 6645;
		const QName_t LN_spPr = 6650;
		const QName_t LN_style = 6653;
		const QName_t LN_txBody = 6659;
		const QName_t LN_xfrm = 6664;
		const QName_t LN_stCxn = 6670;
		const QName_t LN_endCxn = 6674;
		const QName_t LN_graphic = 6680;
		const QName_t LN_gspPr = 6685;
		const QName_t LN_sp = 6690;
		const QName_t LN_gsp = 6694;
		const QName_t LN_graphicFrame = 6697;
		const QName_t LN_cxnsp = 6705;
		const QName_t LN_col = 6711;
		const QName_t LN_colOff = 6715;
		const QName_t LN_row = 6723;
		const QName_t LN_rowOff = 6730;
		const QName_t LN_from = 6734;
		const QName_t LN_to = 6740;
		const QName_t LN_clientData = 6748;
		const QName_t LN_extents = 6758;
		const QName_t LN_pos = 6763;
		const QName_t LN_twoCellAnchor = 6774;
		const QName_t LN_oneCellAnchor = 6784;
		const QName_t LN_absoluteAnchor = 6795;
	}
	namespace NS_m12 { /* http://schemas.microsoft.com/office/omml/2004/12/core */
		const QName_t LN_nor = 218;
		const QName_t LN_lit = 225;
		const QName_t LN_scr = 230;
		const QName_t LN_sty = 234;
		const QName_t LN_brk = 239;
		const QName_t LN_aln = 245;
		const QName_t LN_rPr = 249;
		const QName_t LN_t = 254;
		const QName_t LN_chr = 257;
		const QName_t LN_accPr = 261;
		const QName_t LN_e = 264;
		const QName_t LN_pos = 268;
		const QName_t LN_barPr = 272;
		const QName_t LN_opEmu = 276;
		const QName_t LN_noBreak = 284;
		const QName_t LN_boxPr = 291;
		const QName_t LN_hideTop = 297;
		const QName_t LN_hideBot = 304;
		const QName_t LN_hideLeft = 311;
		const QName_t LN_hideRight = 320;
		const QName_t LN_strikeH = 329;
		const QName_t LN_strikeV = 335;
		const QName_t LN_strikeBLTR = 346;
		const QName_t LN_strikeTLBR = 356;
		const QName_t LN_boxFormPr = 366;
		const QName_t LN_begChr = 367;
		const QName_t LN_sepChr = 372;
		const QName_t LN_endChr = 378;
		const QName_t LN_grow = 382;
		const QName_t LN_shp = 387;
		const QName_t LN_dPr = 392;
		const QName_t LN_baseJc = 395;
		const QName_t LN_maxDist = 401;
		const QName_t LN_objDist = 405;
		const QName_t LN_rSpRule = 412;
		const QName_t LN_rSp = 418;
		const QName_t LN_eqArrPr = 423;
		const QName_t LN_type = 426;
		const QName_t LN_numJc = 431;
		const QName_t LN_denJc = 435;
		const QName_t LN_fPr = 440;
		const QName_t LN_num = 443;
		const QName_t LN_den = 448;
		const QName_t LN_fName = 452;
		const QName_t LN_groupChrPr = 458;
		const QName_t LN_lim = 463;
		const QName_t LN_count = 466;
		const QName_t LN_mcJc = 471;
		const QName_t LN_mcPr = 478;
		const QName_t LN_mc = 480;
		const QName_t LN_plcHide = 485;
		const QName_t LN_cGpRule = 493;
		const QName_t LN_cSp = 498;
		const QName_t LN_cGp = 505;
		const QName_t LN_mcs = 507;
		const QName_t LN_mPr = 513;
		const QName_t LN_mr = 517;
		const QName_t LN_limLoc = 521;
		const QName_t LN_subHide = 526;
		const QName_t LN_supHide = 531;
		const QName_t LN_naryPr = 535;
		const QName_t LN_sub = 538;
		const QName_t LN_sup = 544;
		const QName_t LN_show = 549;
		const QName_t LN_zeroWid = 556;
		const QName_t LN_zeroAsc = 565;
		const QName_t LN_zeroDesc = 574;
		const QName_t LN_transp = 583;
		const QName_t LN_phantPr = 589;
		const QName_t LN_degHide = 591;
		const QName_t LN_radPr = 596;
		const QName_t LN_deg = 601;
		const QName_t LN_acc = 606;
		const QName_t LN_bar = 611;
		const QName_t LN_box = 615;
		const QName_t LN_boxForm = 624;
		const QName_t LN_d = 630;
		const QName_t LN_eqArr = 636;
		const QName_t LN_f = 641;
		const QName_t LN_func = 647;
		const QName_t LN_groupChr = 650;
		const QName_t LN_limLow = 658;
		const QName_t LN_limUpp = 664;
		const QName_t LN_m = 669;
		const QName_t LN_nary = 676;
		const QName_t LN_phant = 677;
		const QName_t LN_rad = 683;
		const QName_t LN_sPre = 688;
		const QName_t LN_sSub = 690;
		const QName_t LN_sSubSup = 698;
		const QName_t LN_sSup = 701;
		const QName_t LN_r = 705;
		const QName_t LN_argSz = 712;
		const QName_t LN_argPr = 720;
		const QName_t LN_jc = 725;
		const QName_t LN_mathFont = 734;
		const QName_t LN_defSz = 741;
		const QName_t LN_brkBin = 749;
		const QName_t LN_brkBinSub = 759;
		const QName_t LN_smallFrac = 768;
		const QName_t LN_dispDef = 778;
		const QName_t LN_lMargin = 783;
		const QName_t LN_rMargin = 795;
		const QName_t LN_defJc = 802;
		const QName_t LN_preSp = 810;
		const QName_t LN_postSp = 817;
		const QName_t LN_intraSp = 823;
		const QName_t LN_interSp = 833;
		const QName_t LN_wrapRight = 841;
		const QName_t LN_wrapIndent = 848;
		const QName_t LN_naryGrow = 856;
		const QName_t LN_intLim = 864;
		const QName_t LN_naryLim = 871;
		const QName_t LN_mathPr = 880;
		const QName_t LN_oMathParaPr = 890;
		const QName_t LN_oMath = 895;
		const QName_t LN_oMathPara = 903;
	}
	namespace NS_number { /* urn:oasis:names:tc:opendocument:xmlns:datastyle:1.0 */
		const QName_t LN_number_style = 2366;
		const QName_t LN_number = 2373;
		const QName_t LN_decimal_replacement = 2387;
		const QName_t LN_display_factor = 2400;
		const QName_t LN_embedded_text = 2410;
		const QName_t LN_position = 2417;
		const QName_t LN_scientific_number = 2428;
		const QName_t LN_min_exponent_digits = 2446;
		const QName_t LN_fraction = 2455;
		const QName_t LN_min_numerator_digits = 2470;
		const QName_t LN_min_denominator_digits = 2485;
		const QName_t LN_denominator_value = 2501;
		const QName_t LN_currency_style = 2514;
		const QName_t LN_currency_symbol = 2528;
		const QName_t LN_language = 2534;
		const QName_t LN_country = 2540;
		const QName_t LN_percentage_style = 2553;
		const QName_t LN_date_style = 2563;
		const QName_t LN_day = 2570;
		const QName_t LN_style = 2573;
		const QName_t LN_month = 2582;
		const QName_t LN_textual = 2590;
		const QName_t LN_possessive_form = 2605;
		const QName_t LN_year = 2613;
		const QName_t LN_era = 2621;
		const QName_t LN_day_of_week = 2633;
		const QName_t LN_week_of_year = 2644;
		const QName_t LN_quarter = 2654;
		const QName_t LN_time_style = 2666;
		const QName_t LN_truncate_on_overflow = 2683;
		const QName_t LN_hours = 2691;
		const QName_t LN_minutes = 2703;
		const QName_t LN_seconds = 2711;
		const QName_t LN_decimal_places = 2726;
		const QName_t LN_am_pm = 2734;
		const QName_t LN_boolean_style = 2746;
		const QName_t LN_boolean = 2754;
		const QName_t LN_text_style = 2765;
		const QName_t LN_text = 2768;
		const QName_t LN_text_content = 2781;
		const QName_t LN_title = 2790;
		const QName_t LN_automatic_order = 2813;
		const QName_t LN_format_source = 2826;
		const QName_t LN_transliteration_format = 2844;
		const QName_t LN_transliteration_language = 2865;
		const QName_t LN_transliteration_country = 2882;
		const QName_t LN_transliteration_style = 2900;
		const QName_t LN_min_integer_digits = 2913;
		const QName_t LN_grouping = 2924;
		const QName_t LN_calendar = 2928;
	}
	namespace NS_p12 { /* http://schemas.microsoft.com/package/2005/06/content-types */
		const QName_t LN_Types = 937;
		const QName_t LN_Default = 948;
		const QName_t LN_Override = 954;
	}
	namespace NS_voldeps12 { /* http://schemas.microsoft.com/office/excel/2005/8/voldeps */
		const QName_t LN_volTypes = 3155;
		const QName_t LN_volType = 3167;
		const QName_t LN_main = 3175;
		const QName_t LN_topic = 3184;
		const QName_t LN_value = 3190;
		const QName_t LN_subtopic = 3198;
		const QName_t LN_ref = 3205;
	}
	namespace NS_pt12 { /* http://schemas.microsoft.com/office/excel/2005/8/pivot */
		const QName_t LN_pivotCacheDefinition = 227;
		const QName_t LN_pivotCacheRecords = 241;
		const QName_t LN_pivotTableDefinition = 255;
		const QName_t LN_cacheSource = 263;
		const QName_t LN_fields = 269;
		const QName_t LN_hierarchies = 278;
		const QName_t LN_kpis = 283;
		const QName_t LN_sdTupleCache = 294;
		const QName_t LN_ciFmlas = 301;
		const QName_t LN_calcMbrs = 308;
		const QName_t LN_fsb = 310;
		const QName_t LN_field = 315;
		const QName_t LN_shItems = 324;
		const QName_t LN_group = 326;
		const QName_t LN_wksht = 333;
		const QName_t LN_consol = 339;
		const QName_t LN_pages = 345;
		const QName_t LN_rngSets = 353;
		const QName_t LN_page = 359;
		const QName_t LN_item = 361;
		const QName_t LN_rngSet = 368;
		const QName_t LN_m = 373;
		const QName_t LN_n = 379;
		const QName_t LN_b = 383;
		const QName_t LN_e = 389;
		const QName_t LN_s = 393;
		const QName_t LN_d = 397;
		const QName_t LN_mbrs = 404;
		const QName_t LN_mpm = 410;
		const QName_t LN_mpn = 416;
		const QName_t LN_mpb = 422;
		const QName_t LN_mps = 430;
		const QName_t LN_mpd = 434;
		const QName_t LN_rangeDesc = 445;
		const QName_t LN_discMapping = 456;
		const QName_t LN_grItems = 465;
		const QName_t LN_x = 469;
		const QName_t LN_r = 474;
		const QName_t LN_kpi = 481;
		const QName_t LN_hierarchy = 492;
		const QName_t LN_flds = 496;
		const QName_t LN_grLvls = 504;
		const QName_t LN_fld = 509;
		const QName_t LN_grLvl = 518;
		const QName_t LN_grps = 525;
		const QName_t LN_grp = 533;
		const QName_t LN_grMbrs = 539;
		const QName_t LN_grMbr = 548;
		const QName_t LN_entries = 555;
		const QName_t LN_sets = 562;
		const QName_t LN_qryCache = 571;
		const QName_t LN_mbr = 578;
		const QName_t LN_set = 584;
		const QName_t LN_tuples = 592;
		const QName_t LN_sortByTuple = 605;
		const QName_t LN_qry = 612;
		const QName_t LN_ciFmla = 620;
		const QName_t LN_rule = 626;
		const QName_t LN_calcMbr = 634;
		const QName_t LN_filters = 643;
		const QName_t LN_filter = 648;
		const QName_t LN_location = 659;
		const QName_t LN_rwFlds = 665;
		const QName_t LN_rwItms = 675;
		const QName_t LN_rwDrills = 684;
		const QName_t LN_colFlds = 692;
		const QName_t LN_colItms = 702;
		const QName_t LN_colDrills = 711;
		const QName_t LN_pgFields = 719;
		const QName_t LN_datFields = 729;
		const QName_t LN_fmts = 735;
		const QName_t LN_condfmts = 744;
		const QName_t LN_crtfmts = 755;
		const QName_t LN_drillSaved = 765;
		const QName_t LN_strSelects = 772;
		const QName_t LN_dims = 780;
		const QName_t LN_mgs = 787;
		const QName_t LN_tableStyle = 790;
		const QName_t LN_sxfilters = 801;
		const QName_t LN_items = 807;
		const QName_t LN_cdls = 815;
		const QName_t LN_autoSortScope = 824;
		const QName_t LN_cdl = 831;
		const QName_t LN_pgField = 837;
		const QName_t LN_datField = 845;
		const QName_t LN_i = 850;
		const QName_t LN_fmt = 853;
		const QName_t LN_cfmt = 862;
		const QName_t LN_crtfmt = 870;
		const QName_t LN_drill = 875;
		const QName_t LN_strSelect = 883;
		const QName_t LN_mbrProps = 892;
		const QName_t LN_itms = 899;
		const QName_t LN_selctPg = 906;
		const QName_t LN_mp = 911;
		const QName_t LN_dim = 915;
		const QName_t LN_mg = 921;
		const QName_t LN_map = 925;
		const QName_t LN_sxfilter = 932;
		const QName_t LN_autofilter = 939;
	}
	namespace NS_xml { /* http://www.w3.org/XML/1998/namespace */
		const QName_t LN_lang = 3341;
		const QName_t LN_base = 3347;
	}
	namespace NS_w11 { /* http://schemas.microsoft.com/office/word/2003/wordml */
		const QName_t LN_ilvl = 1121;
		const QName_t LN_ilfo = 1127;
		const QName_t LN_top = 1131;
		const QName_t LN_left = 1134;
		const QName_t LN_bottom = 1139;
		const QName_t LN_right = 1143;
		const QName_t LN_between = 1147;
		const QName_t LN_bar = 1151;
		const QName_t LN_tab = 1154;
		const QName_t LN_pStyle = 1156;
		const QName_t LN_keepNext = 1162;
		const QName_t LN_keepLines = 1164;
		const QName_t LN_pageBreakBefore = 1168;
		const QName_t LN_framePr = 1172;
		const QName_t LN_widowControl = 1175;
		const QName_t LN_listPr = 1179;
		const QName_t LN_supressLineNumbers = 1184;
		const QName_t LN_pBdr = 1189;
		const QName_t LN_shd = 1191;
		const QName_t LN_tabs = 1196;
		const QName_t LN_suppressAutoHyphens = 1200;
		const QName_t LN_kinsoku = 1201;
		const QName_t LN_wordWrap = 1207;
		const QName_t LN_overflowPunct = 1209;
		const QName_t LN_topLinePunct = 1214;
		const QName_t LN_autoSpaceDE = 1216;
		const QName_t LN_autoSpaceDN = 1221;
		const QName_t LN_bidi = 1227;
		const QName_t LN_adjustRightInd = 1230;
		const QName_t LN_snapToGrid = 1236;
		const QName_t LN_spacing = 1239;
		const QName_t LN_ind = 1243;
		const QName_t LN_contextualSpacing = 1248;
		const QName_t LN_suppressOverlap = 1253;
		const QName_t LN_jc = 1256;
		const QName_t LN_textDirection = 1261;
		const QName_t LN_textAlignment = 1265;
		const QName_t LN_outlineLvl = 1270;
		const QName_t LN_divId = 1273;
		const QName_t LN_cnfStyle = 1278;
		const QName_t LN_rPr = 1283;
		const QName_t LN_sectPr = 1286;
		const QName_t LN_binData = 1290;
		const QName_t LN_movie = 1295;
		const QName_t LN_background = 1300;
		const QName_t LN_applet = 1306;
		const QName_t LN_msAccessHTML = 1308;
		const QName_t LN_scriptAnchor = 1321;
		const QName_t LN_ocx = 1325;
		const QName_t LN_args = 1330;
		const QName_t LN_appletText = 1335;
		const QName_t LN_scriptId = 1345;
		const QName_t LN_language = 1350;
		const QName_t LN_scriptText = 1359;
		const QName_t LN_fldData = 1364;
		const QName_t LN_r = 1368;
		const QName_t LN_fldSimple = 1371;
		const QName_t LN_hlink = 1378;
		const QName_t LN_col = 1381;
		const QName_t LN_hdr = 1386;
		const QName_t LN_ftr = 1390;
		const QName_t LN_footnotePr = 1396;
		const QName_t LN_endnotePr = 1401;
		const QName_t LN_type = 1406;
		const QName_t LN_pgSz = 1409;
		const QName_t LN_pgMar = 1416;
		const QName_t LN_paperSrc = 1421;
		const QName_t LN_pgBorders = 1427;
		const QName_t LN_lnNumType = 1431;
		const QName_t LN_pgNumType = 1436;
		const QName_t LN_cols = 1439;
		const QName_t LN_formProt = 1445;
		const QName_t LN_vAlign = 1451;
		const QName_t LN_noEndnote = 1455;
		const QName_t LN_titlePg = 1460;
		const QName_t LN_textFlow = 1464;
		const QName_t LN_rtlGutter = 1469;
		const QName_t LN_docGrid = 1474;
		const QName_t LN_br = 1477;
		const QName_t LN_t = 1483;
		const QName_t LN_delText = 1486;
		const QName_t LN_instrText = 1492;
		const QName_t LN_delInstrText = 1497;
		const QName_t LN_noBreakHyphen = 1501;
		const QName_t LN_softHyphen = 1507;
		const QName_t LN_annotationRef = 1508;
		const QName_t LN_footnoteRef = 1515;
		const QName_t LN_endnoteRef = 1518;
		const QName_t LN_separator = 1523;
		const QName_t LN_continuationSeparator = 1527;
		const QName_t LN_footnote = 1532;
		const QName_t LN_endnote = 1537;
		const QName_t LN_sym = 1541;
		const QName_t LN_pgNum = 1547;
		const QName_t LN_cr = 1552;
		const QName_t LN_pict = 1556;
		const QName_t LN_fldChar = 1562;
		const QName_t LN_ruby = 1566;
		const QName_t LN_rStyle = 1572;
		const QName_t LN_rFonts = 1577;
		const QName_t LN_b = 1582;
		const QName_t LN_b_cs = 1590;
		const QName_t LN_i = 1593;
		const QName_t LN_i_cs = 1602;
		const QName_t LN_caps = 1607;
		const QName_t LN_smallCaps = 1611;
		const QName_t LN_strike = 1617;
		const QName_t LN_dstrike = 1619;
		const QName_t LN_outline = 1626;
		const QName_t LN_shadow = 1631;
		const QName_t LN_emboss = 1634;
		const QName_t LN_imprint = 1642;
		const QName_t LN_noProof = 1647;
		const QName_t LN_vanish = 1650;
		const QName_t LN_webHidden = 1656;
		const QName_t LN_color = 1661;
		const QName_t LN_w = 1665;
		const QName_t LN_kern = 1670;
		const QName_t LN_position = 1675;
		const QName_t LN_sz = 1680;
		const QName_t LN_sz_cs = 1687;
		const QName_t LN_highlight = 1690;
		const QName_t LN_u = 1697;
		const QName_t LN_effect = 1703;
		const QName_t LN_bdr = 1706;
		const QName_t LN_fitText = 1713;
		const QName_t LN_vertAlign = 1718;
		const QName_t LN_rtl = 1725;
		const QName_t LN_cs = 1729;
		const QName_t LN_em = 1733;
		const QName_t LN_hyphen = 1739;
		const QName_t LN_lang = 1744;
		const QName_t LN_asianLayout = 1747;
		const QName_t LN_specVanish = 1750;
		const QName_t LN_lists = 1756;
		const QName_t LN_styles = 1761;
		const QName_t LN_fonts = 1763;
		const QName_t LN_rubyAlign = 1769;
		const QName_t LN_hps = 1774;
		const QName_t LN_hpsRaise = 1779;
		const QName_t LN_hpsBaseText = 1786;
		const QName_t LN_lid = 1791;
		const QName_t LN_rubyPr = 1796;
		const QName_t LN_rt = 1801;
		const QName_t LN_rubyBase = 1807;
		const QName_t LN_pPr = 1812;
		const QName_t LN_subDoc = 1816;
		const QName_t LN_gridCol = 1824;
		const QName_t LN_insideH = 1828;
		const QName_t LN_insideV = 1835;
		const QName_t LN_tl2br = 1841;
		const QName_t LN_tr2bl = 1846;
		const QName_t LN_tcW = 1851;
		const QName_t LN_gridSpan = 1855;
		const QName_t LN_hmerge = 1861;
		const QName_t LN_vmerge = 1866;
		const QName_t LN_tcBorders = 1873;
		const QName_t LN_noWrap = 1877;
		const QName_t LN_tcMar = 1883;
		const QName_t LN_tcFitText = 1886;
		const QName_t LN_tcPr = 1892;
		const QName_t LN_gridBefore = 1897;
		const QName_t LN_gridAfter = 1903;
		const QName_t LN_wBefore = 1904;
		const QName_t LN_wAfter = 1911;
		const QName_t LN_cantSplit = 1915;
		const QName_t LN_trHeight = 1919;
		const QName_t LN_tblHeader = 1926;
		const QName_t LN_tblCellSpacing = 1927;
		const QName_t LN_tblPrEx = 1933;
		const QName_t LN_trPr = 1935;
		const QName_t LN_tc = 1941;
		const QName_t LN_tblStyle = 1944;
		const QName_t LN_tblpPr = 1950;
		const QName_t LN_tblOverlap = 1951;
		const QName_t LN_tblRtl = 1957;
		const QName_t LN_bidiVisual = 1960;
		const QName_t LN_tblStyleRowBandSize = 1966;
		const QName_t LN_tblStyleColBandSize = 1969;
		const QName_t LN_tblW = 1974;
		const QName_t LN_tblInd = 1980;
		const QName_t LN_tblBorders = 1984;
		const QName_t LN_tblLayout = 1991;
		const QName_t LN_tblCellMar = 1997;
		const QName_t LN_tblLook = 2004;
		const QName_t LN_tblPr = 2008;
		const QName_t LN_tblGrid = 2014;
		const QName_t LN_tr = 2019;
		const QName_t LN_pos = 2026;
		const QName_t LN_numFmt = 2032;
		const QName_t LN_numStart = 2034;
		const QName_t LN_numRestart = 2040;
		const QName_t LN_active = 2046;
		const QName_t LN_hash = 2051;
		const QName_t LN_column = 2055;
		const QName_t LN_uniqueTag = 2060;
		const QName_t LN_name = 2065;
		const QName_t LN_mappedName = 2071;
		const QName_t LN_dynamicAddress = 2076;
		const QName_t LN_udl = 2081;
		const QName_t LN_table = 2086;
		const QName_t LN_src = 2093;
		const QName_t LN_filter = 2098;
		const QName_t LN_sort = 2102;
		const QName_t LN_fieldMapData = 2108;
		const QName_t LN_colDelim = 2114;
		const QName_t LN_jdsoType = 2119;
		const QName_t LN_fHdr = 2125;
		const QName_t LN_recipientData = 2130;
		const QName_t LN_mainDocumentType = 2135;
		const QName_t LN_linkToQuery = 2142;
		const QName_t LN_dataType = 2146;
		const QName_t LN_defaultSQL = 2150;
		const QName_t LN_connectString = 2158;
		const QName_t LN_query = 2163;
		const QName_t LN_dataSource = 2170;
		const QName_t LN_headerSource = 2174;
		const QName_t LN_doNotSuppressBlankLines = 2179;
		const QName_t LN_destination = 2183;
		const QName_t LN_addressFieldName = 2189;
		const QName_t LN_mailSubject = 2194;
		const QName_t LN_mailAsAttachment = 2198;
		const QName_t LN_viewMergedData = 2202;
		const QName_t LN_activeRecord = 2206;
		const QName_t LN_checkErrors = 2210;
		const QName_t LN_odso = 2216;
		const QName_t LN_origWordTableRules = 2218;
		const QName_t LN_wpJustification = 2225;
		const QName_t LN_noTabHangInd = 2227;
		const QName_t LN_noLeading = 2231;
		const QName_t LN_spaceForUL = 2235;
		const QName_t LN_noColumnBalance = 2241;
		const QName_t LN_balanceSingleByteDoubleByteWidth = 2245;
		const QName_t LN_transparentMetafiles = 2250;
		const QName_t LN_noExtraLineSpacing = 2253;
		const QName_t LN_doNotLeaveBackslashAlone = 2258;
		const QName_t LN_ulTrailSpace = 2263;
		const QName_t LN_doNotExpandShiftReturn = 2265;
		const QName_t LN_spacingInWholePoints = 2270;
		const QName_t LN_lineWrapLikeWord6 = 2274;
		const QName_t LN_printBodyTextBeforeHeader = 2276;
		const QName_t LN_printColBlack = 2282;
		const QName_t LN_wpSpaceWidth = 2286;
		const QName_t LN_showBreaksInFrames = 2290;
		const QName_t LN_subFontBySize = 2294;
		const QName_t LN_suppressBottomSpacing = 2301;
		const QName_t LN_suppressTopSpacing = 2304;
		const QName_t LN_suppressTopSpacingMac5 = 2310;
		const QName_t LN_suppressTopSpacingWP = 2314;
		const QName_t LN_suppressSpBfAfterPgBrk = 2317;
		const QName_t LN_swapBordersFacingPages = 2320;
		const QName_t LN_convMailMergeEsc = 2325;
		const QName_t LN_truncateFontHeight = 2329;
		const QName_t LN_mwSmallCaps = 2332;
		const QName_t LN_usePrinterMetrics = 2336;
		const QName_t LN_ww6BorderRules = 2341;
		const QName_t LN_wrapTrailSpaces = 2343;
		const QName_t LN_footnoteLayoutLikeWW8 = 2348;
		const QName_t LN_shapeLayoutLikeWW8 = 2354;
		const QName_t LN_alignTablesRowByRow = 2358;
		const QName_t LN_forgetLastTabAlignment = 2364;
		const QName_t LN_adjustLineHeightInTable = 2365;
		const QName_t LN_autoSpaceLikeWord95 = 2371;
		const QName_t LN_noSpaceRaiseLower = 2375;
		const QName_t LN_doNotUseHTMLParagraphAutoSpacing = 2377;
		const QName_t LN_layoutRawTableWidth = 2382;
		const QName_t LN_layoutTableRowsApart = 2388;
		const QName_t LN_useWord97LineBreakingRules = 2392;
		const QName_t LN_breakWrappedTables = 2395;
		const QName_t LN_snapToGridInCell = 2402;
		const QName_t LN_dontAllowFieldEndSelect = 2405;
		const QName_t LN_applyBreakingRules = 2408;
		const QName_t LN_wrapTextWithPunct = 2413;
		const QName_t LN_useAsianBreakRules = 2418;
		const QName_t LN_useWord2002TableStyleRules = 2421;
		const QName_t LN_dontGrowAutofit = 2424;
		const QName_t LN_useFELayout = 2430;
		const QName_t LN_docVar = 2432;
		const QName_t LN_view = 2437;
		const QName_t LN_zoom = 2442;
		const QName_t LN_removePersonalInformation = 2447;
		const QName_t LN_dontDisplayPageBoundaries = 2453;
		const QName_t LN_displayBackgroundShape = 2457;
		const QName_t LN_printPostScriptOverText = 2460;
		const QName_t LN_printFractionalCharacterWidth = 2465;
		const QName_t LN_printFormsData = 2469;
		const QName_t LN_embedTrueTypeFonts = 2474;
		const QName_t LN_doNotEmbedSystemFonts = 2478;
		const QName_t LN_saveSubsetFonts = 2482;
		const QName_t LN_saveFormsData = 2486;
		const QName_t LN_mirrorMargins = 2492;
		const QName_t LN_alignBordersAndEdges = 2495;
		const QName_t LN_bordersDontSurroundHeader = 2499;
		const QName_t LN_bordersDontSurroundFooter = 2506;
		const QName_t LN_gutterAtTop = 2510;
		const QName_t LN_hideSpellingErrors = 2513;
		const QName_t LN_hideGrammaticalErrors = 2521;
		const QName_t LN_activeWritingStyle = 2523;
		const QName_t LN_proofState = 2527;
		const QName_t LN_formsDesign = 2533;
		const QName_t LN_attachedTemplate = 2539;
		const QName_t LN_linkStyles = 2543;
		const QName_t LN_stylePaneFormatFilter = 2547;
		const QName_t LN_documentType = 2552;
		const QName_t LN_mailMerge = 2555;
		const QName_t LN_revisionView = 2560;
		const QName_t LN_trackRevisions = 2565;
		const QName_t LN_documentProtection = 2569;
		const QName_t LN_autoFormatOverride = 2572;
		const QName_t LN_defaultTabStop = 2577;
		const QName_t LN_autoHyphenation = 2583;
		const QName_t LN_consecutiveHyphenLimit = 2587;
		const QName_t LN_hyphenationZone = 2593;
		const QName_t LN_doNotHyphenateCaps = 2598;
		const QName_t LN_showEnvelope = 2602;
		const QName_t LN_summaryLength = 2608;
		const QName_t LN_clickAndTypeStyle = 2612;
		const QName_t LN_defaultTableStyle = 2617;
		const QName_t LN_evenAndOddHeaders = 2622;
		const QName_t LN_bookFoldRevPrinting = 2624;
		const QName_t LN_bookFoldPrinting = 2630;
		const QName_t LN_bookFoldPrintingSheets = 2634;
		const QName_t LN_drawingGridHorizontalSpacing = 2640;
		const QName_t LN_drawingGridVerticalSpacing = 2643;
		const QName_t LN_displayHorizontalDrawingGridEvery = 2649;
		const QName_t LN_displayVerticalDrawingGridEvery = 2653;
		const QName_t LN_useMarginsForDrawingGridOrigin = 2659;
		const QName_t LN_drawingGridHorizontalOrigin = 2663;
		const QName_t LN_drawingGridVerticalOrigin = 2670;
		const QName_t LN_doNotShadeFormData = 2673;
		const QName_t LN_punctuationKerning = 2677;
		const QName_t LN_characterSpacingControl = 2682;
		const QName_t LN_printTwoOnOne = 2689;
		const QName_t LN_strictFirstAndLastChars = 2693;
		const QName_t LN_noLineBreaksAfter = 2700;
		const QName_t LN_noLineBreaksBefore = 2704;
		const QName_t LN_webPageEncoding = 2708;
		const QName_t LN_optimizeForBrowser = 2712;
		const QName_t LN_relyOnVML = 2718;
		const QName_t LN_allowPNG = 2722;
		const QName_t LN_doNotRelyOnCSS = 2727;
		const QName_t LN_doNotSaveWebPagesAsSingleFile = 2730;
		const QName_t LN_doNotOrganizeInFolder = 2737;
		const QName_t LN_doNotUseLongFileNames = 2741;
		const QName_t LN_pixelsPerInch = 2743;
		const QName_t LN_targetScreenSz = 2748;
		const QName_t LN_savePreviewPicture = 2753;
		const QName_t LN_validateAgainstSchema = 2757;
		const QName_t LN_saveInvalidXML = 2762;
		const QName_t LN_ignoreMixedContent = 2767;
		const QName_t LN_alwaysShowPlaceholderText = 2771;
		const QName_t LN_doNotUnderlineInvalidXML = 2777;
		const QName_t LN_removeWordSchemaOnSave = 2780;
		const QName_t LN_useXSLTWhenSaving = 2789;
		const QName_t LN_saveThroughXSLT = 2791;
		const QName_t LN_showXMLTags = 2796;
		const QName_t LN_alwaysMergeEmptyNamespace = 2803;
		const QName_t LN_hdrShapeDefaults = 2806;
		const QName_t LN_compat = 2811;
		const QName_t LN_docVars = 2816;
		const QName_t LN_sourceFileName = 2822;
		const QName_t LN_marW = 2825;
		const QName_t LN_marH = 2833;
		const QName_t LN_scrollbar = 2835;
		const QName_t LN_noResizeAllowed = 2838;
		const QName_t LN_linkedToFile = 2845;
		const QName_t LN_noBorder = 2848;
		const QName_t LN_flatBorders = 2853;
		const QName_t LN_framesetSplitbar = 2857;
		const QName_t LN_frameLayout = 2863;
		const QName_t LN_frameset = 2868;
		const QName_t LN_frame = 2871;
		const QName_t LN_start = 2877;
		const QName_t LN_nfc = 2881;
		const QName_t LN_lvlRestart = 2887;
		const QName_t LN_isLgl = 2892;
		const QName_t LN_suff = 2895;
		const QName_t LN_lvlText = 2901;
		const QName_t LN_lvlPicBulletId = 2904;
		const QName_t LN_legacy = 2908;
		const QName_t LN_lvlJc = 2912;
		const QName_t LN_lsid = 2916;
		const QName_t LN_plt = 2920;
		const QName_t LN_tmpl = 2925;
		const QName_t LN_styleLink = 2927;
		const QName_t LN_listStyleLink = 2932;
		const QName_t LN_lvl = 2937;
		const QName_t LN_startOverride = 2942;
		const QName_t LN_ilst = 2947;
		const QName_t LN_lvlOverride = 2951;
		const QName_t LN_listPicBullet = 2957;
		const QName_t LN_listDef = 2962;
		const QName_t LN_list = 2967;
		const QName_t LN_ilfoMacAtCleanup = 2973;
		const QName_t LN_aliases = 2980;
		const QName_t LN_sti = 2985;
		const QName_t LN_basedOn = 2992;
		const QName_t LN_next = 2996;
		const QName_t LN_link = 3001;
		const QName_t LN_autoRedefine = 3009;
		const QName_t LN_hidden = 3014;
		const QName_t LN_semiHidden = 3021;
		const QName_t LN_locked = 3024;
		const QName_t LN_personal = 3031;
		const QName_t LN_personalCompose = 3034;
		const QName_t LN_personalReply = 3040;
		const QName_t LN_rsid = 3046;
		const QName_t LN_tblStylePr = 3050;
		const QName_t LN_lsdException = 3057;
		const QName_t LN_versionOfBuiltInStylenames = 3063;
		const QName_t LN_latentStyles = 3068;
		const QName_t LN_style = 3074;
		const QName_t LN_altName = 3078;
		const QName_t LN_panose_1 = 3084;
		const QName_t LN_charset = 3091;
		const QName_t LN_family = 3094;
		const QName_t LN_notTrueType = 3099;
		const QName_t LN_pitch = 3104;
		const QName_t LN_sig = 3109;
		const QName_t LN_defaultFonts = 3114;
		const QName_t LN_font = 3121;
		const QName_t LN_blockQuote = 3123;
		const QName_t LN_bodyDiv = 3129;
		const QName_t LN_marLeft = 3133;
		const QName_t LN_marRight = 3136;
		const QName_t LN_marTop = 3140;
		const QName_t LN_marBottom = 3145;
		const QName_t LN_divBdr = 3150;
		const QName_t LN_divsChild = 3153;
		const QName_t LN_div = 3160;
		const QName_t LN_txbxContent = 3164;
		const QName_t LN_p = 3169;
		const QName_t LN_tbl = 3177;
		const QName_t LN_cfChunk = 3180;
		const QName_t LN_proofErr = 3188;
		const QName_t LN_permStart = 3191;
		const QName_t LN_permEnd = 3195;
		const QName_t LN_ignoreSubtree = 3200;
		const QName_t LN_ignoreElements = 3207;
		const QName_t LN_divs = 3214;
		const QName_t LN_docOleData = 3224;
		const QName_t LN_docSuppData = 3231;
		const QName_t LN_shapeDefaults = 3245;
		const QName_t LN_bgPict = 3250;
		const QName_t LN_docPr = 3256;
		const QName_t LN_body = 3261;
		const QName_t LN_wordDocument = 3269;
	}
	namespace NS_sl12 { /* http://schemas.microsoft.com/schemaLibrary/2003/core */
		const QName_t LN_schemaLibrary = 285;
		const QName_t LN_schema = 288;
	}
	namespace NS_s12 { /* http://schemas.microsoft.com/office/excel/2005/8/styles */
		const QName_t LN_Styles = 2376;
		const QName_t LN_fmts = 2379;
		const QName_t LN_fonts = 2384;
		const QName_t LN_fills = 2391;
		const QName_t LN_borders = 2394;
		const QName_t LN_xfs = 2404;
		const QName_t LN_styles = 2406;
		const QName_t LN_dxfs = 2414;
		const QName_t LN_tableStyles = 2422;
		const QName_t LN_colorpalette = 2433;
		const QName_t LN_fsb = 2438;
		const QName_t LN_color = 2444;
		const QName_t LN_left = 2449;
		const QName_t LN_right = 2454;
		const QName_t LN_top = 2458;
		const QName_t LN_bottom = 2463;
		const QName_t LN_diag = 2468;
		const QName_t LN_vertical = 2473;
		const QName_t LN_horizontal = 2483;
		const QName_t LN_fontPr = 2493;
		const QName_t LN_fill = 2496;
		const QName_t LN_pattern = 2500;
		const QName_t LN_gradient = 2507;
		const QName_t LN_image = 2511;
		const QName_t LN_fgColor = 2522;
		const QName_t LN_bgColor = 2529;
		const QName_t LN_stop = 2535;
		const QName_t LN_fmt = 2541;
		const QName_t LN_xf = 2545;
		const QName_t LN_alignment = 2554;
		const QName_t LN_protection = 2566;
		const QName_t LN_styleInfo = 2574;
		const QName_t LN_style = 2579;
		const QName_t LN_dxf = 2586;
		const QName_t LN_font = 2591;
		const QName_t LN_indexedColors = 2604;
		const QName_t LN_themeColors = 2618;
		const QName_t LN_mruColors = 2625;
		const QName_t LN_rgbcolor = 2637;
		const QName_t LN_tableStyle = 2641;
		const QName_t LN_tableStyleElement = 2657;
		const QName_t LN_charset = 2661;
		const QName_t LN_family = 2669;
		const QName_t LN_b = 2672;
		const QName_t LN_i = 2676;
		const QName_t LN_strike = 2680;
		const QName_t LN_outline = 2688;
		const QName_t LN_shadow = 2690;
		const QName_t LN_condense = 2697;
		const QName_t LN_extend = 2702;
		const QName_t LN_sz = 2706;
		const QName_t LN_u = 2710;
		const QName_t LN_vertAlign = 2715;
		const QName_t LN_fontScheme = 2721;
	}
	namespace NS_udc { /* http://schemas.microsoft.com/data/udc */
		const QName_t LN_DataSource = 561;
		const QName_t LN_Type = 569;
		const QName_t LN_SubType = 575;
		const QName_t LN_Name = 580;
		const QName_t LN_ConnectionInfo = 595;
		const QName_t LN_Description = 598;
		const QName_t LN_Keywords = 603;
		const QName_t LN_TooltipInfo = 614;
		const QName_t LN_ClientParameterBindings = 632;
		const QName_t LN_ClientParameterBinding = 649;
		const QName_t LN_CredentialBinding = 663;
		const QName_t LN_Credential = 674;
		const QName_t LN_Attribute = 685;
		const QName_t LN_If = 689;
		const QName_t LN_ClientParameterValue = 706;
		const QName_t LN_CredentialValue = 717;
	}
	namespace NS_dr3d { /* urn:oasis:names:tc:opendocument:xmlns:dr3d:1.0 */
		const QName_t LN_distance = 4;
		const QName_t LN_focal_length = 11;
		const QName_t LN_shadow_slant = 22;
		const QName_t LN_shade_mode = 32;
		const QName_t LN_ambient_color = 44;
		const QName_t LN_lighting_mode = 56;
		const QName_t LN_transform = 59;
		const QName_t LN_light = 64;
		const QName_t LN_diffuse_color = 73;
		const QName_t LN_direction = 78;
		const QName_t LN_enabled = 82;
		const QName_t LN_specular = 87;
		const QName_t LN_cube = 92;
		const QName_t LN_min_edge = 100;
		const QName_t LN_max_edge = 106;
		const QName_t LN_sphere = 114;
		const QName_t LN_center = 119;
		const QName_t LN_size = 125;
		const QName_t LN_extrude = 131;
		const QName_t LN_rotate = 137;
		const QName_t LN_horizontal_segments = 6498;
		const QName_t LN_vertical_segments = 6512;
		const QName_t LN_edge_rounding = 6524;
		const QName_t LN_edge_rounding_mode = 6539;
		const QName_t LN_back_scale = 6548;
		const QName_t LN_depth = 6554;
		const QName_t LN_backface_culling = 6569;
		const QName_t LN_end_angle = 6573;
		const QName_t LN_close_front = 6581;
		const QName_t LN_close_back = 6589;
		const QName_t LN_normals_kind = 6596;
		const QName_t LN_normals_direction = 6608;
		const QName_t LN_texture_generation_mode_x = 6623;
		const QName_t LN_texture_generation_mode_y = 6634;
		const QName_t LN_texture_kind = 6644;
		const QName_t LN_texture_filter = 6656;
		const QName_t LN_texture_mode = 6669;
		const QName_t LN_emissive_color = 6684;
		const QName_t LN_specular_color = 6696;
		const QName_t LN_shininess = 6710;
		const QName_t LN_shadow = 6713;
		const QName_t LN_scene = 6842;
		const QName_t LN_vrp = 6848;
		const QName_t LN_vpn = 6854;
		const QName_t LN_vup = 6862;
		const QName_t LN_projection = 6870;
	}
	namespace NS_rdf { /* http://www.w3.org/1999/02/22-rdf-syntax-ns# */
		const QName_t LN_RDF = 3354;
		const QName_t LN_ID = 3380;
		const QName_t LN_nodeID = 3388;
		const QName_t LN_about = 3398;
		const QName_t LN_resource = 3409;
		const QName_t LN_datatype = 3413;
		const QName_t LN_parseType = 3424;
	}
	namespace NS_sb12 { /* http://schemas.microsoft.com/office/excel/2005/8/supbook */
		const QName_t LN_supBook = 2761;
		const QName_t LN_sheetNames = 2773;
		const QName_t LN_namedLinks = 2785;
		const QName_t LN_supSheet = 2794;
		const QName_t LN_sheetName = 2801;
		const QName_t LN_xrow = 2808;
		const QName_t LN_xc = 2815;
		const QName_t LN_xv = 2824;
		const QName_t LN_namedRange = 2834;
		const QName_t LN_DDELink = 2841;
		const QName_t LN_OLELink = 2851;
		const QName_t LN_values = 2854;
		const QName_t LN_value = 2859;
		const QName_t LN_val = 2866;
	}
	namespace NS_wb12 { /* http://schemas.microsoft.com/office/excel/2005/8/workbook */
		const QName_t LN_supBookSource = 7;
		const QName_t LN_imageRelation = 16;
		const QName_t LN_pivotCache = 25;
		const QName_t LN_docRouteInfo = 36;
		const QName_t LN_docRouteOriginator = 49;
		const QName_t LN_docRouteRecipient = 63;
		const QName_t LN_book = 3243;
		const QName_t LN_fileVersion = 3252;
		const QName_t LN_fileSharing = 3266;
		const QName_t LN_bookViews = 3277;
		const QName_t LN_userBookViews = 6652;
		const QName_t LN_sheets = 6661;
		const QName_t LN_wbPr = 6668;
		const QName_t LN_webPub = 6677;
		const QName_t LN_webPubItems = 6682;
		const QName_t LN_smartTag = 6693;
		const QName_t LN_smartTagTypes = 6707;
		const QName_t LN_fileRecovery = 6720;
		const QName_t LN_calcPr = 6728;
		const QName_t LN_extRefs = 6735;
		const QName_t LN_namedRanges = 6746;
		const QName_t LN_pivotCaches = 6757;
		const QName_t LN_docRoute = 6765;
		const QName_t LN_oleSize = 6776;
		const QName_t LN_bookProtection = 6787;
		const QName_t LN_image = 6791;
		const QName_t LN_fsb = 6794;
		const QName_t LN_bookView = 6802;
		const QName_t LN_userBookView = 6811;
		const QName_t LN_sheet = 6813;
		const QName_t LN_smartTagType = 6823;
		const QName_t LN_namedRange = 6827;
		const QName_t LN_name = 6831;
		const QName_t LN_value = 6835;
		const QName_t LN_comment = 6841;
		const QName_t LN_customMenu = 6852;
		const QName_t LN_description = 6855;
		const QName_t LN_help = 6863;
		const QName_t LN_statusBar = 6871;
	}
	namespace NS_RowsetSchema { /* #RowsetSchema */
		const QName_t LN_row = 3831;
	}
	namespace NS_ec12 { /* http://schemas.microsoft.com/office/excel/2005/8/externalconnection */
		const QName_t LN_webqProps = 0;
		const QName_t LN_txtWiz = 6;
		const QName_t LN_qParams = 12;
		const QName_t LN_fsb = 19;
		const QName_t LN_tables = 26;
		const QName_t LN_qParam = 33;
		const QName_t LN_m = 37;
		const QName_t LN_s = 42;
		const QName_t LN_x = 48;
		const QName_t LN_fldInfos = 55;
		const QName_t LN_fldInfo = 61;
		const QName_t LN_extConns = 6837;
		const QName_t LN_extConn = 6847;
		const QName_t LN_dbProps = 6856;
		const QName_t LN_olapProps = 6865;
	}
	namespace NS_qt12 { /* http://schemas.microsoft.com/office/excel/2005/8/querytable */
		const QName_t LN_querytable = 976;
		const QName_t LN_qtRefr = 983;
		const QName_t LN_fsb = 986;
		const QName_t LN_delNms = 992;
		const QName_t LN_qtflds = 999;
		const QName_t LN_delNm = 1003;
		const QName_t LN_qtfld = 1005;
	}
	namespace NS_o12 { /* urn:schemas-microsoft-com:office:office */
		const QName_t LN_DocumentProperties = 240;
		const QName_t LN_Name = 243;
		const QName_t LN_Description = 248;
		const QName_t LN_Keywords = 251;
		const QName_t LN_File = 3355;
		const QName_t LN_MainFile = 3365;
		const QName_t LN_Title = 3370;
		const QName_t LN_Subject = 3376;
		const QName_t LN_Author = 3381;
		const QName_t LN_LastAuthor = 3394;
		const QName_t LN_Revision = 3399;
		const QName_t LN_AppName = 3410;
		const QName_t LN_TotalTime = 3419;
		const QName_t LN_LastPrinted = 3425;
		const QName_t LN_Created = 3433;
		const QName_t LN_LastSaved = 3440;
		const QName_t LN_Pages = 3443;
		const QName_t LN_Words = 3453;
		const QName_t LN_Characters = 3463;
		const QName_t LN_Category = 3468;
		const QName_t LN_PresentationFormat = 3484;
		const QName_t LN_Manager = 3487;
		const QName_t LN_Company = 3492;
		const QName_t LN_Guid = 3501;
		const QName_t LN_HyperlinkBase = 3503;
		const QName_t LN_Bytes = 3513;
		const QName_t LN_Lines = 3522;
		const QName_t LN_Paragraphs = 3532;
		const QName_t LN_CharactersWithSpaces = 3556;
		const QName_t LN_Version = 3560;
		const QName_t LN_SmartTagType = 3568;
		const QName_t LN_SmartTags = 3579;
		const QName_t LN_CustomDocumentProperties = 3600;
		const QName_t LN_OfficeDocumentSettings = 3620;
		const QName_t LN_DownloadComponents = 3638;
		const QName_t LN_LocationOfComponents = 3655;
		const QName_t LN_shapedefaults = 3667;
		const QName_t LN_colormru = 3681;
		const QName_t LN_colormenu = 3694;
		const QName_t LN_colors = 3702;
		const QName_t LN_shapelayout = 3716;
		const QName_t LN_idmap = 3724;
		const QName_t LN_regrouptable = 3738;
		const QName_t LN_rules = 3746;
		const QName_t LN_entry = 3750;
		const QName_t LN_r = 3758;
		const QName_t LN_proxy = 3766;
		const QName_t LN_skew = 3774;
		const QName_t LN_extrusion = 3780;
		const QName_t LN_callout = 3792;
		const QName_t LN_lock = 3796;
		const QName_t LN_OLEObject = 3808;
		const QName_t LN_complex = 3819;
	}
	namespace NS_s11 { /* uuid:BDC6E3F0-6DA3-11d1-A2A3-00AA00C14882 */
		const QName_t LN_Schema = 3890;
		const QName_t LN_ElementType = 3900;
		const QName_t LN_attribute = 3904;
		const QName_t LN_extends = 3914;
		const QName_t LN_AttributeType = 3927;
		const QName_t LN_datatype = 3938;
	}
	namespace NS_x11 { /* urn:schemas-microsoft-com:office:excel */
		const QName_t LN_CacheDetails = 1;
		const QName_t LN_FieldListTop = 10;
		const QName_t LN_FieldListBottom = 20;
		const QName_t LN_FieldListRight = 31;
		const QName_t LN_FieldListLeft = 43;
		const QName_t LN_PivotAxis = 52;
		const QName_t LN_VersionUpdateableMin = 65;
		const QName_t LN_VersionLastUpdate = 76;
		const QName_t LN_VersionRefreshableMin = 88;
		const QName_t LN_DefaultVersion = 96;
		const QName_t LN_PivotField = 104;
		const QName_t LN_CubeField = 112;
		const QName_t LN_CalculatedMember = 122;
		const QName_t LN_MemberName = 129;
		const QName_t LN_ParentUniqueName = 142;
		const QName_t LN_SolveOrder = 152;
		const QName_t LN_Invalid = 158;
		const QName_t LN_Set = 164;
		const QName_t LN_PTLineItems = 174;
		const QName_t LN_PTSource = 181;
		const QName_t LN_PTFormula = 192;
		const QName_t LN_PTFormat = 199;
		const QName_t LN_CacheFile = 205;
		const QName_t LN_QuerySource = 213;
		const QName_t LN_DefaultItem = 221;
		const QName_t LN_AllItemName = 228;
		const QName_t LN_Dimension = 236;
		const QName_t LN_DontShowInFieldList = 250;
		const QName_t LN_Measure = 258;
		const QName_t LN_EnableMultiplePageItems = 273;
		const QName_t LN_GroupLevel = 280;
		const QName_t LN_IsGroupLevel = 289;
		const QName_t LN_GroupDefinition = 300;
		const QName_t LN_LengthLevelUniqueName = 312;
		const QName_t LN_DisplayIn = 322;
		const QName_t LN_GroupNumber = 330;
		const QName_t LN_ParentName = 340;
		const QName_t LN_ParentIsOther = 351;
		const QName_t LN_GroupMember = 363;
		const QName_t LN_IsNotFiltered = 374;
		const QName_t LN_TotalAllMembers = 388;
		const QName_t LN_DetailMaxHeight = 403;
		const QName_t LN_DetailMaxWidth = 413;
		const QName_t LN_NoDetailAutoFit = 424;
		const QName_t LN_DetailRowHeight = 438;
		const QName_t LN_TotalFormat = 450;
		const QName_t LN_MemberFormat = 460;
		const QName_t LN_FieldLabelFormat = 475;
		const QName_t LN_DetailSortOrder = 487;
		const QName_t LN_CellsExpanded = 499;
		const QName_t LN_CellsNotExpanded = 512;
		const QName_t LN_CellsExpandedSeqNum = 527;
		const QName_t LN_Operator = 536;
		const QName_t LN_Alignment = 542;
		const QName_t LN_CaptionAlignment = 553;
		const QName_t LN_FitWidth = 563;
		const QName_t LN_FitHeight = 572;
		const QName_t LN_LeftToRight = 585;
		const QName_t LN_BlackAndWhite = 597;
		const QName_t LN_NoPrinterInfo = 610;
		const QName_t LN_DraftQuality = 621;
		const QName_t LN_CommentsLayout = 633;
		const QName_t LN_Scale = 642;
		const QName_t LN_PrintErrors = 654;
		const QName_t LN_ValidPrinterInfo = 666;
		const QName_t LN_PaperSizeIndex = 678;
		const QName_t LN_HorizontalResolution = 696;
		const QName_t LN_VerticalResolution = 710;
		const QName_t LN_Gridlines = 718;
		const QName_t LN_NumberOfCopies = 730;
		const QName_t LN_RowColHeadings = 742;
		const QName_t LN_PTRule = 750;
		const QName_t LN_FormatType = 761;
		const QName_t LN_IndividualCellBorders = 777;
		const QName_t LN_ItemType = 785;
		const QName_t LN_BlockTotal = 797;
		const QName_t LN_CountOfSameItems = 811;
		const QName_t LN_PTLineItem = 819;
		const QName_t LN_RuleType = 827;
		const QName_t LN_Rule = 835;
		const QName_t LN_RuleV10 = 842;
		const QName_t LN_ParseRuleAsV10 = 851;
		const QName_t LN_Area = 858;
		const QName_t LN_Outline = 861;
		const QName_t LN_MissingItemsLimit = 872;
		const QName_t LN_VersionLastRefresh = 888;
		const QName_t LN_RefreshName = 898;
		const QName_t LN_RefreshDate = 905;
		const QName_t LN_RefreshDateCopy = 916;
		const QName_t LN_ConsolidationReference = 931;
		const QName_t LN_NoSaveData = 938;
		const QName_t LN_SourceConsolidation = 952;
		const QName_t LN_BackgroundQuery = 963;
		const QName_t LN_CubeSource = 971;
		const QName_t LN_DisableRefresh = 981;
		const QName_t LN_HasNoRecords = 990;
		const QName_t LN_OptimizeCache = 1000;
		const QName_t LN_RefreshOnFileOpen = 1006;
		const QName_t LN_PublishObject = 1012;
		const QName_t LN_DivID = 1019;
		const QName_t LN_SourceType = 1023;
		const QName_t LN_HtmlType = 1029;
		const QName_t LN_AutoRepublish = 1040;
		const QName_t LN_QueryType = 1046;
		const QName_t LN_CommandText = 1051;
		const QName_t LN_CommandType = 1054;
		const QName_t LN_Maintain = 1062;
		const QName_t LN_Connection = 1066;
		const QName_t LN_Parameter = 1071;
		const QName_t LN_CommandTextOrignal = 1083;
		const QName_t LN_SourceConnectionFile = 1096;
		const QName_t LN_SourceDataFile = 1104;
		const QName_t LN_RobustConnect = 1112;
		const QName_t LN_RefreshTimeSpan = 1122;
		const QName_t LN_LocalConnection = 1136;
		const QName_t LN_NoRefreshCache = 1145;
		const QName_t LN_UseLocalConnection = 1159;
		const QName_t LN_VersionLastEdit = 1170;
		const QName_t LN_DoNotJoinDelimiters = 1182;
		const QName_t LN_NoTextToColumns = 1194;
		const QName_t LN_DisableDateRecognition = 1208;
		const QName_t LN_EnableRedirections = 1222;
		const QName_t LN_EditWebPage = 1232;
		const QName_t LN_RefreshedInXl9 = 1247;
		const QName_t LN_EntirePage = 1255;
		const QName_t LN_HTMLFormat = 1267;
		const QName_t LN_URLString = 1274;
		const QName_t LN_WebPostString = 1287;
		const QName_t LN_RefreshInfo = 1298;
		const QName_t LN_TextWizardSettings = 1312;
		const QName_t LN_HTMLTables = 1324;
		const QName_t LN_UseSameSettings = 1340;
		const QName_t LN_Query97 = 1348;
		const QName_t LN_DoNotPromptForFile = 1363;
		const QName_t LN_AutoFormatWidth = 1376;
		const QName_t LN_DisableEdit = 1389;
		const QName_t LN_Filled = 1397;
		const QName_t LN_InsertEntireRows = 1412;
		const QName_t LN_NewAsync = 1422;
		const QName_t LN_NoAutofit = 1433;
		const QName_t LN_NoTitles = 1444;
		const QName_t LN_OverwriteCells = 1457;
		const QName_t LN_Synchronous = 1470;
		const QName_t LN_NextId = 1476;
		const QName_t LN_ColumnInfo = 1487;
		const QName_t LN_DoNotPersist = 1500;
		const QName_t LN_DoNotPersistSort = 1516;
		const QName_t LN_DoNotPersstAF = 1526;
		const QName_t LN_Sort = 1535;
		const QName_t LN_CaseSensitive = 1548;
		const QName_t LN_FuturePersist = 1561;
		const QName_t LN_HeaderRow = 1574;
		const QName_t LN_IdWrapped = 1584;
		const QName_t LN_AlertVersion = 1596;
		const QName_t LN_SortOrder = 1608;
		const QName_t LN_ExtraLeftColumns = 1622;
		const QName_t LN_ExtraRightColumns = 1639;
		const QName_t LN_DeletedTitle = 1651;
		const QName_t LN_NoToggleDataHeader = 1668;
		const QName_t LN_AlternateMethod = 1681;
		const QName_t LN_NoAutoPage = 1692;
		const QName_t LN_SheetName = 1705;
		const QName_t LN_ExternName = 1717;
		const QName_t LN_Xct = 1726;
		const QName_t LN_FormatSettings = 1740;
		const QName_t LN_Delimiters = 1749;
		const QName_t LN_Comma = 1757;
		const QName_t LN_Consecutive = 1767;
		const QName_t LN_Custom = 1777;
		const QName_t LN_SemiColon = 1790;
		const QName_t LN_Space = 1799;
		const QName_t LN_Tab = 1805;
		const QName_t LN_TextQualifier = 1818;
		const QName_t LN_StartRow = 1830;
		const QName_t LN_Decimal = 1843;
		const QName_t LN_ThousandSeparator = 1859;
		const QName_t LN_FitToPage = 1872;
		const QName_t LN_DoNotDisplayColHeaders = 1891;
		const QName_t LN_DoNotDisplayRowHeaders = 1910;
		const QName_t LN_ViewableRange = 1920;
		const QName_t LN_GridlineColor = 1934;
		const QName_t LN_ExcelWorksheetType = 1948;
		const QName_t LN_IntlMacro = 1956;
		const QName_t LN_Unsynced = 1965;
		const QName_t LN_Selected = 1975;
		const QName_t LN_CodeName = 1986;
		const QName_t LN_PageSetup = 2000;
		const QName_t LN_DisplayPageBreak = 2016;
		const QName_t LN_TransitionExpressionEvaluation = 2044;
		const QName_t LN_TransitionFormulaEntry = 2062;
		const QName_t LN_Print = 2067;
		const QName_t LN_Zoom = 2075;
		const QName_t LN_PageBreakZoom = 2089;
		const QName_t LN_ShowPageBreakZoom = 2107;
		const QName_t LN_DefaultRowHeight = 2126;
		const QName_t LN_DefaultColumnWidth = 2144;
		const QName_t LN_StandardWidth = 2160;
		const QName_t LN_Visible = 2164;
		const QName_t LN_LeftColumnVisible = 2181;
		const QName_t LN_DisplayRightToLeft = 2196;
		const QName_t LN_GridlineColorIndex = 2212;
		const QName_t LN_DisplayFormulas = 2226;
		const QName_t LN_DoNotDisplayGridlines = 2240;
		const QName_t LN_DoNotDisplayHeadings = 2255;
		const QName_t LN_DoNotDisplayOutline = 2271;
		const QName_t LN_ApplyAutomaticOutlineStyles = 2288;
		const QName_t LN_NoSummaryRowsBelowDetail = 2309;
		const QName_t LN_NoSummaryColumnsRightDetail = 2326;
		const QName_t LN_DoNotDisplayZeros = 2339;
		const QName_t LN_ActiveColumn = 2350;
		const QName_t LN_FilterOn = 2360;
		const QName_t LN_TopRowVisible = 2369;
		const QName_t LN_TopRowBottomPane = 2383;
		const QName_t LN_LeftColumnRightPane = 2398;
		const QName_t LN_ActivePane = 2407;
		const QName_t LN_SplitHorizontal = 2420;
		const QName_t LN_SplitVertical = 2431;
		const QName_t LN_FreezePanes = 2445;
		const QName_t LN_FrozenNoSplit = 2456;
		const QName_t LN_TabColorIndex = 2467;
		const QName_t LN_Panes = 2476;
		const QName_t LN_ProtectContents = 2488;
		const QName_t LN_ProtectObjects = 2502;
		const QName_t LN_ProtectScenarios = 2518;
		const QName_t LN_EnableSelection = 2531;
		const QName_t LN_AllowFormatCells = 2546;
		const QName_t LN_AllowSizeCols = 2558;
		const QName_t LN_AllowSizeRows = 2571;
		const QName_t LN_AllowInsertCols = 2584;
		const QName_t LN_AllowInsertRows = 2599;
		const QName_t LN_AllowInsertHyperlinks = 2615;
		const QName_t LN_AllowDeleteCols = 2628;
		const QName_t LN_AllowDeleteRows = 2642;
		const QName_t LN_AllowSort = 2655;
		const QName_t LN_AllowFilter = 2668;
		const QName_t LN_AllowUsePivotTables = 2684;
		const QName_t LN_SpaceAbove = 2696;
		const QName_t LN_SpaceBelow = 2707;
		const QName_t LN_ZeroHeight = 2720;
		const QName_t LN_Layout = 2723;
		const QName_t LN_Header = 2732;
		const QName_t LN_Footer = 2740;
		const QName_t LN_PageMargins = 2751;
		const QName_t LN_Count = 2759;
		const QName_t LN_SheetIndex = 2769;
		const QName_t LN_Crn = 2778;
		const QName_t LN_Moper = 2787;
		const QName_t LN_ExcelName = 2798;
		const QName_t LN_FunctionGroup = 2810;
		const QName_t LN_FunctionGroupIndex = 2827;
		const QName_t LN_KeyboardShortcut = 2839;
		const QName_t LN_Macro = 2850;
		const QName_t LN_phonetictext = 2860;
		const QName_t LN_AutoFilterColumn = 2876;
		const QName_t LN_WorkbookOptions = 2890;
		const QName_t LN_MoveAfterReturn = 2903;
		const QName_t LN_ParameterValue = 5139;
		const QName_t LN_PromptString = 5149;
		const QName_t LN_NonDefaultName = 5164;
		const QName_t LN_SQLType = 5172;
		const QName_t LN_RefreshOnChange = 5190;
		const QName_t LN_DisplayEmptyMembers = 5202;
		const QName_t LN_Label = 5208;
		const QName_t LN_Caption = 5211;
		const QName_t LN_NotVisible = 5221;
		const QName_t LN_Orientation = 5232;
		const QName_t LN_PivotCache = 5241;
		const QName_t LN_CacheIndex = 5252;
		const QName_t LN_PTPivotData = 5264;
		const QName_t LN_InvertedRowMember = 5279;
		const QName_t LN_InvertedColumnMember = 5295;
		const QName_t LN_LeafRowMember = 5308;
		const QName_t LN_LeafColumnMember = 5320;
		const QName_t LN_Item = 5329;
		const QName_t LN_SourceName = 5340;
		const QName_t LN_BoundField = 5351;
		const QName_t LN_DataType = 5357;
		const QName_t LN_FilterCaption = 5370;
		const QName_t LN_PLDataOrientation = 5386;
		const QName_t LN_PLPosition = 5397;
		const QName_t LN_Position = 5403;
		const QName_t LN_ShowAllItems = 5416;
		const QName_t LN_NumberFormat = 5432;
		const QName_t LN_CurrentPage = 5442;
		const QName_t LN_NewItemsHidden = 5455;
		const QName_t LN_DataTable = 5465;
		const QName_t LN_Subtotal = 5466;
		const QName_t LN_Range = 5475;
		const QName_t LN_PLSubtotal = 5479;
		const QName_t LN_RowInputCell = 5485;
		const QName_t LN_DetailFormat = 5491;
		const QName_t LN_ColumnInputCell = 5497;
		const QName_t LN_SubtotalFormat = 5502;
		const QName_t LN_ExcelWorkbook = 5507;
		const QName_t LN_DetailWidth = 5513;
		const QName_t LN_PublishObjects = 5522;
		const QName_t LN_GroupedWidth = 5524;
		const QName_t LN_SupBook = 5530;
		const QName_t LN_TotalWidth = 5534;
		const QName_t LN_SelectedSheets = 5542;
		const QName_t LN_PivotItem = 5543;
		const QName_t LN_DataField = 5550;
		const QName_t LN_WindowHidden = 5553;
		const QName_t LN_MapChildItems = 5563;
		const QName_t LN_HideHorizontalScrollBar = 5571;
		const QName_t LN_AutoShowCount = 5575;
		const QName_t LN_HideVerticalScrollBar = 5587;
		const QName_t LN_AutoShowField = 5588;
		const QName_t LN_AutoShowRange = 5599;
		const QName_t LN_HideWorkbookTabs = 5602;
		const QName_t LN_AutoShowType = 5613;
		const QName_t LN_WindowHeight = 5615;
		const QName_t LN_WindowWidth = 5625;
		const QName_t LN_AutoSortOrder = 5626;
		const QName_t LN_WindowTopX = 5634;
		const QName_t LN_AutoSortField = 5638;
		const QName_t LN_WindowTopY = 5646;
		const QName_t LN_BaseField = 5649;
		const QName_t LN_BaseItem = 5659;
		const QName_t LN_ActiveSheet = 5661;
		const QName_t LN_ActiveChart = 5669;
		const QName_t LN_BlankLineAfterItems = 5675;
		const QName_t LN_FirstVisibleSheet = 5683;
		const QName_t LN_CantGetUniqueItems = 5691;
		const QName_t LN_GroupBy = 5697;
		const QName_t LN_HidePivotTableFieldList = 5702;
		const QName_t LN_GroupStart = 5707;
		const QName_t LN_ProtectStructure = 5713;
		const QName_t LN_GroupEnd = 5717;
		const QName_t LN_ProtectWindows = 5727;
		const QName_t LN_GroupStartAuto = 5731;
		const QName_t LN_DisplayInkNotes = 5741;
		const QName_t LN_GroupEndAuto = 5742;
		const QName_t LN_GroupType = 5751;
		const QName_t LN_EmbedSaveSmartTags = 5758;
		const QName_t LN_LayoutPageBreak = 5765;
		const QName_t LN_FutureVer = 5768;
		const QName_t LN_TabRatio = 5777;
		const QName_t LN_ParentField = 5779;
		const QName_t LN_Function = 5790;
		const QName_t LN_WindowIconic = 5791;
		const QName_t LN_LayoutForm = 5801;
		const QName_t LN_DisplayDrawingObjects = 5808;
		const QName_t LN_LayoutSubtotalLocation = 5816;
		const QName_t LN_CreateBackup = 5820;
		const QName_t LN_NoDragToRow = 5827;
		const QName_t LN_Calculation = 5829;
		const QName_t LN_NoDragToColumn = 5839;
		const QName_t LN_DoNotCalculateBeforeSave = 5846;
		const QName_t LN_NoDragToData = 5849;
		const QName_t LN_Date1904 = 5856;
		const QName_t LN_NoDragToHide = 5861;
		const QName_t LN_RefModeR1C1 = 5866;
		const QName_t LN_NoDragToPage = 5875;
		const QName_t LN_Iteration = 5880;
		const QName_t LN_MemberProperty = 5887;
		const QName_t LN_MaxIterations = 5892;
		const QName_t LN_MaxChange = 5902;
		const QName_t LN_MemberPropertiesOrder = 5907;
		const QName_t LN_HideDropDowns = 5920;
		const QName_t LN_PrecisionAsDisplayed = 5921;
		const QName_t LN_DrilledLevel = 5934;
		const QName_t LN_DoNotSaveLinkValues = 5938;
		const QName_t LN_ServerSortOrder = 5947;
		const QName_t LN_NoAutoRecover = 5951;
		const QName_t LN_IsMemberProperty = 5961;
		const QName_t LN_AcceptLabelsInFormulas = 5969;
		const QName_t LN_FilterMember = 5975;
		const QName_t LN_Uncalced = 5981;
		const QName_t LN_Name = 5988;
		const QName_t LN_UniqueName = 5990;
		const QName_t LN_Level = 5996;
		const QName_t LN_DataValidation = 6003;
		const QName_t LN_ServerBased = 6009;
		const QName_t LN_AutoFilter = 6016;
		const QName_t LN_SubtotalName = 6023;
		const QName_t LN_PLTPivotItem = 6035;
		const QName_t LN_AutoFilterCondition = 6038;
		const QName_t LN_FormulaV10 = 6047;
		const QName_t LN_AutoFilterOr = 6051;
		const QName_t LN_ParseFormulaAsV10 = 6062;
		const QName_t LN_AutoFilterAnd = 6066;
		const QName_t LN_PLCaption = 6073;
		const QName_t LN_Sorting = 6074;
		const QName_t LN_PLGroupType = 6087;
		const QName_t LN_ConditionalFormatting = 6095;
		const QName_t LN_PLName = 6099;
		const QName_t LN_QueryTable = 6107;
		const QName_t LN_SourceHierarchy = 6113;
		const QName_t LN_PivotTable = 6120;
		const QName_t LN_MemberPropertyParent = 6130;
		const QName_t LN_WorksheetSource = 6133;
		const QName_t LN_SourceHierarchyLevel = 6148;
		const QName_t LN_WorksheetOptions = 6149;
		const QName_t LN_Watches = 6159;
		const QName_t LN_TotalAlignment = 6163;
		const QName_t LN_Watch = 6166;
		const QName_t LN_Source = 6177;
		const QName_t LN_TotalCaptionAlignment = 6183;
		const QName_t LN_PageBreaks = 6187;
		const QName_t LN_FormulaIndex = 6195;
		const QName_t LN_ColBreaks = 6200;
		const QName_t LN_Hidden = 6205;
		const QName_t LN_ColBreak = 6211;
		const QName_t LN_HideDetail = 6218;
		const QName_t LN_Column = 6221;
		const QName_t LN_CachePosition = 6228;
		const QName_t LN_RowBreaks = 6232;
		const QName_t LN_Member = 6240;
		const QName_t LN_RowBreak = 6244;
		const QName_t LN_Row = 6253;
		const QName_t LN_DrilledMember = 6255;
		const QName_t LN_ColFirst = 6262;
		const QName_t LN_DataValueEditing = 6273;
		const QName_t LN_ColLast = 6275;
		const QName_t LN_Number = 6278;
		const QName_t LN_QTSource = 6284;
		const QName_t LN_Text = 6285;
		const QName_t LN_Boolean = 6293;
		const QName_t LN_ErrorString = 6296;
		const QName_t LN_Error = 6302;
		const QName_t LN_NullString = 6306;
		const QName_t LN_Horizontal = 6314;
		const QName_t LN_PageFieldOrder = 6324;
		const QName_t LN_Rotation = 6325;
		const QName_t LN_Vertical = 6336;
		const QName_t LN_PageFieldWrapCount = 6339;
		const QName_t LN_ReadingOrder = 6350;
		const QName_t LN_DisableDrillDown = 6352;
		const QName_t LN_Path = 6356;
		const QName_t LN_Left = 6362;
		const QName_t LN_DisableFieldDialog = 6372;
		const QName_t LN_Cell = 6373;
		const QName_t LN_Top = 6381;
		const QName_t LN_DisableWizard = 6387;
		const QName_t LN_NotInverted = 6393;
		const QName_t LN_Id = 6400;
		const QName_t LN_DisplayErrorString = 6401;
		const QName_t LN_Clipped = 6407;
		const QName_t LN_NoPreserveFormatting = 6414;
		const QName_t LN_Descending = 6416;
		const QName_t LN_FillDown = 6421;
		const QName_t LN_HasNoAutoFormat = 6422;
		const QName_t LN_RowNumbers = 6429;
		const QName_t LN_SortKey = 6431;
		const QName_t LN_User = 6437;
		const QName_t LN_SubtotalHiddenPageItems = 6438;
		const QName_t LN_Condition = 6444;
		const QName_t LN_NoAutoFormatWidth = 6448;
		const QName_t LN_Qualifier = 6454;
		const QName_t LN_NoRowGrand = 6460;
		const QName_t LN_Value1 = 6461;
		const QName_t LN_Value2 = 6470;
		const QName_t LN_NoColumnGrand = 6471;
		const QName_t LN_Format = 6474;
		const QName_t LN_FileName = 6482;
		const QName_t LN_NoDisplayNullString = 6487;
		const QName_t LN_Reference = 6493;
		const QName_t LN_Type = 6495;
		const QName_t LN_NoPrintRepeatItems = 6499;
		const QName_t LN_CellRangeList = 6506;
		const QName_t LN_PivotView = 6507;
		const QName_t LN_UseBlank = 6515;
		const QName_t LN_Min = 6521;
		const QName_t LN_AutoFormatAlignment = 6522;
		const QName_t LN_Max = 6528;
		const QName_t LN_Value = 6533;
		const QName_t LN_AutoFormatBorder = 6535;
		const QName_t LN_ComboHide = 6542;
		const QName_t LN_AutoFormatFont = 6549;
		const QName_t LN_IMEMode = 6552;
		const QName_t LN_AutoFormatName = 6561;
		const QName_t LN_InputHide = 6562;
		const QName_t LN_InputTitle = 6571;
		const QName_t LN_AutoFormatNumber = 6575;
		const QName_t LN_InputMessage = 6580;
		const QName_t LN_AutoFormatPattern = 6583;
		const QName_t LN_ErrorHide = 6588;
		const QName_t LN_GrandTotalString = 6593;
		const QName_t LN_ErrorStyle = 6595;
		const QName_t LN_ErrorMessage = 6603;
		const QName_t LN_PrintSetTitles = 6604;
		const QName_t LN_ErrorTitle = 6610;
		const QName_t LN_MergeLabels = 6611;
		const QName_t LN_Formula = 6616;
		const QName_t LN_OleLink = 6621;
		const QName_t LN_PageFieldStyle = 6622;
		const QName_t LN_PLExport = 6627;
		const QName_t LN_WantAdvise = 6629;
		const QName_t LN_WantPict = 6635;
		const QName_t LN_ImmediateItemsOnDrop = 6638;
		const QName_t LN_Cf = 6639;
		const QName_t LN_FieldType = 6648;
		const QName_t LN_ShowPageMultipleItemLabel = 6658;
		const QName_t LN_FieldStart = 6660;
		const QName_t LN_SmallGrid = 6667;
		const QName_t LN_Missing = 6671;
		const QName_t LN_SeqNum = 6678;
		const QName_t LN_TableStyle = 6681;
		const QName_t LN_Tag = 6688;
		const QName_t LN_Expanded = 6691;
		const QName_t LN_RowLast = 6698;
		const QName_t LN_VacatedStyle = 6701;
		const QName_t LN_Pane = 6708;
		const QName_t LN_ActiveRow = 6716;
		const QName_t LN_HideTotalsAnnotation = 6717;
		const QName_t LN_ActiveCol = 6729;
		const QName_t LN_ShowCellBackgroundFromOLAP = 6736;
		const QName_t LN_RangeSelection = 6741;
		const QName_t LN_Selection = 6749;
		const QName_t LN_NoViewCalculatedMembers = 6752;
		const QName_t LN_ExcelType = 6759;
		const QName_t LN_VisualTotals = 6764;
		const QName_t LN_ParameterType = 6772;
		const QName_t LN_Location = 6775;
		const QName_t LN_PLPivotField = 6785;
		const QName_t LN_PLTotal = 6793;
		const QName_t LN_DataMember = 6801;
		const QName_t LN_DataAxisEmpty = 6810;
		const QName_t LN_DisplayFieldList = 6819;
		const QName_t LN_NoAutoFit = 6829;
		const QName_t LN_Height = 6834;
		const QName_t LN_Width = 6839;
		const QName_t LN_MaxHeight = 6845;
		const QName_t LN_MaxWidth = 6849;
		const QName_t LN_MemberExpand = 6861;
		const QName_t LN_ConnectionString = 6864;
	}
	namespace NS_ss11 { /* urn:schemas-microsoft-com:office:spreadsheet */
		const QName_t LN_Workbook = 3199;
		const QName_t LN_Styles = 3206;
		const QName_t LN_Style = 3213;
		const QName_t LN_Names = 3217;
		const QName_t LN_Worksheet = 3226;
		const QName_t LN_NamedRange = 3234;
		const QName_t LN_Alignment = 3238;
		const QName_t LN_Borders = 3247;
		const QName_t LN_Font = 3253;
		const QName_t LN_Interior = 3262;
		const QName_t LN_NumberFormat = 3271;
		const QName_t LN_Protection = 3274;
		const QName_t LN_Border = 3283;
		const QName_t LN_Column = 3286;
		const QName_t LN_Row = 3293;
		const QName_t LN_Cell = 3296;
		const QName_t LN_Data = 3302;
		const QName_t LN_Comment = 3308;
		const QName_t LN_NamedCell = 3317;
		const QName_t LN_Table = 3325;
	}
	namespace NS_rtf { /* urn:rtf:1.7 */
		const QName_t LN_tsvertalb = 2;
		const QName_t LN_tsvertalc = 9;
		const QName_t LN_tsvertalt = 14;
		const QName_t LN_twoonone = 23;
		const QName_t LN_tx = 27;
		const QName_t LN_txe = 34;
		const QName_t LN_uc = 39;
		const QName_t LN_ud = 45;
		const QName_t LN_ul = 50;
		const QName_t LN_ulc = 58;
		const QName_t LN_uld = 62;
		const QName_t LN_uldash = 70;
		const QName_t LN_uldashd = 75;
		const QName_t LN_uldashdd = 83;
		const QName_t LN_uldb = 86;
		const QName_t LN_ulhair = 94;
		const QName_t LN_ulhwave = 101;
		const QName_t LN_ulldash = 105;
		const QName_t LN_ulnone = 113;
		const QName_t LN_ulth = 118;
		const QName_t LN_ulthd = 124;
		const QName_t LN_ulthdash = 130;
		const QName_t LN_ulthdashd = 140;
		const QName_t LN_ulthdashdd = 148;
		const QName_t LN_ulthldash = 155;
		const QName_t LN_ululdbwave = 166;
		const QName_t LN_ulw = 172;
		const QName_t LN_ulwave = 178;
		const QName_t LN_u = 182;
		const QName_t LN_up = 187;
		const QName_t LN_upr = 193;
		const QName_t LN_urtf = 198;
		const QName_t LN_useltbaln = 204;
		const QName_t LN_userprops = 211;
		const QName_t LN_v = 214;
		const QName_t LN_vern = 219;
		const QName_t LN_version = 224;
		const QName_t LN_vertalb = 231;
		const QName_t LN_vertalc = 235;
		const QName_t LN_vertalj = 244;
		const QName_t LN_vertalt = 252;
		const QName_t LN_vertdoc = 260;
		const QName_t LN_vertsect = 266;
		const QName_t LN_viewkind = 274;
		const QName_t LN_viewnobound = 282;
		const QName_t LN_viewscale = 292;
		const QName_t LN_viewzk = 296;
		const QName_t LN_wbitmap = 303;
		const QName_t LN_wbmbitspixel = 313;
		const QName_t LN_wbmplanes = 323;
		const QName_t LN_wbmwidthbytes = 331;
		const QName_t LN_webhidden = 342;
		const QName_t LN_widctlpar = 350;
		const QName_t LN_widowctrl = 360;
		const QName_t LN_windowcaption = 371;
		const QName_t LN_wmetafile = 381;
		const QName_t LN_wpeqn = 391;
		const QName_t LN_wpjst = 398;
		const QName_t LN_wpsp = 406;
		const QName_t LN_wraptrsp = 414;
		const QName_t LN_wrppunct = 421;
		const QName_t LN_xe = 429;
		const QName_t LN_xef = 433;
		const QName_t LN_yr = 441;
		const QName_t LN_yts = 447;
		const QName_t LN_yxe = 453;
		const QName_t LN_zwbo = 461;
		const QName_t LN_zwj = 468;
		const QName_t LN_zwnbo = 477;
		const QName_t LN_zwnj = 484;
		const QName_t LN_dobypara = 501;
		const QName_t LN_doccomm = 511;
		const QName_t LN_doctemp = 520;
		const QName_t LN_doctype = 529;
		const QName_t LN_docvar = 537;
		const QName_t LN_dodhgt = 546;
		const QName_t LN_dolock = 551;
		const QName_t LN_donotshowcomments = 567;
		const QName_t LN_donotshowinsdel = 579;
		const QName_t LN_donotshowmarkup = 594;
		const QName_t LN_donotshowprops = 608;
		const QName_t LN_dpaendhol = 618;
		const QName_t LN_dpaendl = 625;
		const QName_t LN_dpaendsol = 635;
		const QName_t LN_dpaendw = 646;
		const QName_t LN_dparc = 652;
		const QName_t LN_dparcflipx = 662;
		const QName_t LN_dparcflipy = 672;
		const QName_t LN_dpastarthol = 686;
		const QName_t LN_dpastartl = 694;
		const QName_t LN_dpastartsol = 704;
		const QName_t LN_dpastartw = 713;
		const QName_t LN_dpcallout = 722;
		const QName_t LN_dpcoa = 731;
		const QName_t LN_dpcoaccent = 739;
		const QName_t LN_dpcobestfit = 753;
		const QName_t LN_dpcoborder = 762;
		const QName_t LN_dpcodabs = 769;
		const QName_t LN_dpcodbottom = 781;
		const QName_t LN_dpcodcenter = 791;
		const QName_t LN_dpcodescent = 803;
		const QName_t LN_dpcodtop = 812;
		const QName_t LN_dpcolength = 820;
		const QName_t LN_dpcominusx = 828;
		const QName_t LN_dpcominusy = 838;
		const QName_t LN_dpcooffset = 847;
		const QName_t LN_dpcosmarta = 855;
		const QName_t LN_dpcotdouble = 865;
		const QName_t LN_dpcotright = 874;
		const QName_t LN_dpcotsingle = 884;
		const QName_t LN_dpcottriple = 893;
		const QName_t LN_dpcount = 900;
		const QName_t LN_dpellipse = 909;
		const QName_t LN_dpendgroup = 919;
		const QName_t LN_dpfillbgcb = 928;
		const QName_t LN_dpfillbgcg = 936;
		const QName_t LN_dpfillbgcr = 945;
		const QName_t LN_dpfillbggray = 955;
		const QName_t LN_dpfillbgpal = 964;
		const QName_t LN_dpfillfgcb = 972;
		const QName_t LN_dpfillfgcg = 979;
		const QName_t LN_dpfillfgcr = 988;
		const QName_t LN_dpfillfggray = 997;
		const QName_t LN_dpfillfgpal = 1004;
		const QName_t LN_dpfillpat = 1010;
		const QName_t LN_dpgroup = 1013;
		const QName_t LN_dpline = 1020;
		const QName_t LN_dplinecob = 1024;
		const QName_t LN_dplinecog = 1030;
		const QName_t LN_dplinecor = 1037;
		const QName_t LN_dplinedado = 1045;
		const QName_t LN_dplinedadodo = 1056;
		const QName_t LN_dplinedash = 1065;
		const QName_t LN_dplinedot = 1073;
		const QName_t LN_dplinegray = 1082;
		const QName_t LN_dplinehollow = 1093;
		const QName_t LN_dplinepal = 1100;
		const QName_t LN_dplinesolid = 1106;
		const QName_t LN_dplinew = 1113;
		const QName_t LN_dppolycount = 1120;
		const QName_t LN_dppolygon = 1129;
		const QName_t LN_dppolyline = 1141;
		const QName_t LN_dpptx = 1146;
		const QName_t LN_dppty = 1153;
		const QName_t LN_dprect = 1160;
		const QName_t LN_dproundr = 1166;
		const QName_t LN_dpshadow = 1174;
		const QName_t LN_dpshadx = 1183;
		const QName_t LN_dpshady = 1190;
		const QName_t LN_dptxbtlr = 1199;
		const QName_t LN_dptxbx = 1206;
		const QName_t LN_dptxbxmar = 1215;
		const QName_t LN_dptxbxtext = 1225;
		const QName_t LN_dptxlrtb = 1233;
		const QName_t LN_dptxlrtbv = 1242;
		const QName_t LN_dptxtbrl = 1252;
		const QName_t LN_dptxtbrlv = 1262;
		const QName_t LN_dpx = 1268;
		const QName_t LN_dpxsize = 1276;
		const QName_t LN_dpy = 1284;
		const QName_t LN_dpysize = 1291;
		const QName_t LN_dropcapli = 1303;
		const QName_t LN_dropcapt = 1311;
		const QName_t LN_ds = 1316;
		const QName_t LN_dxfrtext = 1327;
		const QName_t LN_dy = 1333;
		const QName_t LN_edmins = 1342;
		const QName_t LN_embo = 1349;
		const QName_t LN_emdash = 1356;
		const QName_t LN_emfblip = 1365;
		const QName_t LN_emspace = 1373;
		const QName_t LN_endash = 1382;
		const QName_t LN_enddoc = 1391;
		const QName_t LN_endnhere = 1404;
		const QName_t LN_endnotes = 1407;
		const QName_t LN_enspace = 1418;
		const QName_t LN_expnd = 1426;
		const QName_t LN_expndtw = 1435;
		const QName_t LN_expshrtn = 1446;
		const QName_t LN_f = 1452;
		const QName_t LN_faauto = 1459;
		const QName_t LN_facenter7_0 = 1473;
		const QName_t LN_facingp = 1481;
		const QName_t LN_fahang = 1488;
		const QName_t LN_falt = 1496;
		const QName_t LN_faroman = 1506;
		const QName_t LN_favar = 1513;
		const QName_t LN_fbias = 1520;
		const QName_t LN_fbidi = 1529;
		const QName_t LN_fchars = 1538;
		const QName_t LN_fcharset = 1549;
		const QName_t LN_fdecor = 1557;
		const QName_t LN_fet = 1563;
		const QName_t LN_fetch = 1575;
		const QName_t LN_ffdefres = 1585;
		const QName_t LN_ffdeftext = 1594;
		const QName_t LN_ffentrymcr = 1606;
		const QName_t LN_ffexitmcr = 1618;
		const QName_t LN_ffformat = 1627;
		const QName_t LN_ffhaslistbox = 1641;
		const QName_t LN_ffhelptext = 1653;
		const QName_t LN_ffhps = 1660;
		const QName_t LN_ffl = 1669;
		const QName_t LN_ffmaxlen = 1677;
		const QName_t LN_ffname = 1685;
		const QName_t LN_ffownhelp = 1696;
		const QName_t LN_ffownstat = 1709;
		const QName_t LN_ffprot = 1719;
		const QName_t LN_ffrecalc = 1730;
		const QName_t LN_ffres = 1738;
		const QName_t LN_ffsize = 1746;
		const QName_t LN_ffstattext = 1758;
		const QName_t LN_fftype = 1765;
		const QName_t LN_fftypetxt = 1776;
		const QName_t LN_fi = 1785;
		const QName_t LN_fid = 1792;
		const QName_t LN_field = 1797;
		const QName_t LN_file = 1802;
		const QName_t LN_filetbl = 1813;
		const QName_t LN_fittext = 1825;
		const QName_t LN_fldalt = 1836;
		const QName_t LN_flddirty = 1847;
		const QName_t LN_fldedit = 1857;
		const QName_t LN_fldinst = 1867;
		const QName_t LN_fldlock = 1878;
		const QName_t LN_fldpriv = 1889;
		const QName_t LN_fldrslt = 1898;
		const QName_t LN_fldtype = 1907;
		const QName_t LN_fmodern = 1917;
		const QName_t LN_fn = 1922;
		const QName_t LN_fname = 1928;
		const QName_t LN_fnetwork = 1937;
		const QName_t LN_fnil = 1945;
		const QName_t LN_fnonfilesys = 1955;
		const QName_t LN_fontemb = 1964;
		const QName_t LN_fontfile = 1973;
		const QName_t LN_fonttbl = 1982;
		const QName_t LN_footer = 1990;
		const QName_t LN_footerf = 2002;
		const QName_t LN_footerl = 2013;
		const QName_t LN_footery = 2024;
		const QName_t LN_footnote = 2029;
		const QName_t LN_formdisp = 2038;
		const QName_t LN_formfield = 2052;
		const QName_t LN_formprot = 2061;
		const QName_t LN_formshade = 2072;
		const QName_t LN_fosnum = 2084;
		const QName_t LN_fprq = 2092;
		const QName_t LN_fracwidth = 2104;
		const QName_t LN_frelative = 2117;
		const QName_t LN_frmtxbtlr = 2129;
		const QName_t LN_frmtxlrtb = 2141;
		const QName_t LN_frmtxlrtbv = 2154;
		const QName_t LN_frmtxtbrl = 2165;
		const QName_t LN_frmtxtbrlv = 2178;
		const QName_t LN_froman = 2187;
		const QName_t LN_fromhtml = 2197;
		const QName_t LN_fromtext = 2207;
		const QName_t LN_fs = 2214;
		const QName_t LN_fscript = 2221;
		const QName_t LN_fswiss = 2229;
		const QName_t LN_ftnalt = 2238;
		const QName_t LN_ftnbj = 2244;
		const QName_t LN_ftncn = 2252;
		const QName_t LN_ftnil = 2261;
		const QName_t LN_ftnlytwnine = 2269;
		const QName_t LN_ftnnalc = 2275;
		const QName_t LN_ftnnar = 2285;
		const QName_t LN_ftnnauc = 2293;
		const QName_t LN_ftnnchi = 2302;
		const QName_t LN_ftnnchosung = 2315;
		const QName_t LN_ftnncnum = 2323;
		const QName_t LN_ftnndbar = 2330;
		const QName_t LN_ftnndbnum = 2340;
		const QName_t LN_ftnndbnumd = 2352;
		const QName_t LN_ftnndbnumk = 2363;
		const QName_t LN_ftnndbnumt = 2370;
		const QName_t LN_ftnnganada = 2380;
		const QName_t LN_ftnngbnum = 2390;
		const QName_t LN_ftnngbnumd = 2401;
		const QName_t LN_ftnngbnumk = 2409;
		const QName_t LN_ftnngbnuml = 2419;
		const QName_t LN_ftnnrlc = 2427;
		const QName_t LN_ftnnruc = 2435;
		const QName_t LN_ftnnzodiac = 2448;
		const QName_t LN_ftnnzodiacd = 2459;
		const QName_t LN_ftnnzodiacl = 2471;
		const QName_t LN_ftnrestart = 2480;
		const QName_t LN_ftnrstcont = 2490;
		const QName_t LN_ftnrstpg = 2498;
		const QName_t LN_ftnsep = 2508;
		const QName_t LN_ftnsepc = 2519;
		const QName_t LN_ftnstart = 2526;
		const QName_t LN_ftntj = 2538;
		const QName_t LN_fttruetype = 2548;
		const QName_t LN_fvaliddos = 2559;
		const QName_t LN_fvalidhpfs = 2568;
		const QName_t LN_fvalidmac = 2576;
		const QName_t LN_fvalidntfs = 2589;
		const QName_t LN_g = 2595;
		const QName_t LN_gcw = 2601;
		const QName_t LN_generator = 2606;
		const QName_t LN_green = 2611;
		const QName_t LN_gridtbl = 2620;
		const QName_t LN_gutter = 2627;
		const QName_t LN_gutterprl = 2639;
		const QName_t LN_guttersxn = 2651;
		const QName_t LN_header = 2656;
		const QName_t LN_headerf = 2665;
		const QName_t LN_headerl = 2674;
		const QName_t LN_headery = 2685;
		const QName_t LN_hich = 2692;
		const QName_t LN_highlight = 2698;
		const QName_t LN_hlfr = 2705;
		const QName_t LN_hlinkbase = 2716;
		const QName_t LN_hlloc = 2725;
		const QName_t LN_hlsrc = 2733;
		const QName_t LN_horzdoc = 2742;
		const QName_t LN_horzsect = 2750;
		const QName_t LN_hr = 2756;
		const QName_t LN_htmautsp = 2766;
		const QName_t LN_htmlbase = 2776;
		const QName_t LN_htmlrtf = 2788;
		const QName_t LN_htmltag = 2795;
		const QName_t LN_hyphauto = 2807;
		const QName_t LN_hyphcaps = 2817;
		const QName_t LN_hyphconsec = 2830;
		const QName_t LN_hyphhotz = 2837;
		const QName_t LN_hyphpar = 2847;
		const QName_t LN_i = 2852;
		const QName_t LN_id = 2855;
		const QName_t LN_ilvl = 2861;
		const QName_t LN_impr = 2869;
		const QName_t LN_info = 2872;
		const QName_t LN_insrsid = 2883;
		const QName_t LN_intbl = 2893;
		const QName_t LN_ipgp = 2899;
		const QName_t LN_irow = 2905;
		const QName_t LN_irowband = 2914;
		const QName_t LN_itap = 2921;
		const QName_t LN_ixe = 2926;
		const QName_t LN_jcompress = 2936;
		const QName_t LN_jexpand = 2945;
		const QName_t LN_jpegblip = 2956;
		const QName_t LN_jsksu = 2965;
		const QName_t LN_keep = 2974;
		const QName_t LN_keepn = 2986;
		const QName_t LN_kerning = 2997;
		const QName_t LN_keycode = 3010;
		const QName_t LN_keywords = 3015;
		const QName_t LN_ksulang = 3025;
		const QName_t LN_landscape = 3037;
		const QName_t LN_lang = 3044;
		const QName_t LN_langfe = 3052;
		const QName_t LN_langfenp = 3064;
		const QName_t LN_langnp = 3075;
		const QName_t LN_lastrow = 3086;
		const QName_t LN_lbr = 3093;
		const QName_t LN_lchars = 3102;
		const QName_t LN_ldblquote = 3112;
		const QName_t LN_level = 3119;
		const QName_t LN_levelfollow = 3130;
		const QName_t LN_levelindent = 3139;
		const QName_t LN_leveljc = 3148;
		const QName_t LN_leveljcn = 3159;
		const QName_t LN_levellegal = 3171;
		const QName_t LN_levelnfc = 3182;
		const QName_t LN_levelnfcn = 3194;
		const QName_t LN_levelnorestart = 3211;
		const QName_t LN_levelnumbers = 3221;
		const QName_t LN_levelold = 3227;
		const QName_t LN_levelpicture = 3236;
		const QName_t LN_levelprev = 3248;
		const QName_t LN_levelprevspace = 3260;
		const QName_t LN_psover = 3263;
		const QName_t LN_psz = 3272;
		const QName_t LN_levelspace = 3275;
		const QName_t LN_pubauto = 3282;
		const QName_t LN_levelstartat = 3285;
		const QName_t LN_pvmrg = 3290;
		const QName_t LN_pvpara = 3299;
		const QName_t LN_leveltemplateid = 3301;
		const QName_t LN_pvpg = 3307;
		const QName_t LN_leveltext = 3310;
		const QName_t LN_pwd = 3311;
		const QName_t LN_li = 3319;
		const QName_t LN_pxe = 3321;
		const QName_t LN_line = 3323;
		const QName_t LN_qc = 3326;
		const QName_t LN_qd = 3331;
		const QName_t LN_linebetcol = 3332;
		const QName_t LN_qj = 3336;
		const QName_t LN_linecont = 3343;
		const QName_t LN_qk = 3346;
		const QName_t LN_ql = 3351;
		const QName_t LN_linemod = 3353;
		const QName_t LN_qmspace = 3359;
		const QName_t LN_lineppage = 3363;
		const QName_t LN_qr = 3368;
		const QName_t LN_qt = 3378;
		const QName_t LN_linerestart = 3379;
		const QName_t LN_linestart = 3390;
		const QName_t LN_rawclbgbdiag = 3391;
		const QName_t LN_linestarts = 3401;
		const QName_t LN_rawclbgcross = 3405;
		const QName_t LN_linex = 3411;
		const QName_t LN_rawclbgdcross = 3417;
		const QName_t LN_linkself = 3420;
		const QName_t LN_rawbgdkbdiag = 3429;
		const QName_t LN_linkstyles = 3430;
		const QName_t LN_linkval = 3441;
		const QName_t LN_rawclbgdkcross = 3444;
		const QName_t LN_lin = 3447;
		const QName_t LN_lisa = 3454;
		const QName_t LN_rawclbgdkdcross = 3460;
		const QName_t LN_lisb = 3461;
		const QName_t LN_rawclbgdkfdiag = 3473;
		const QName_t LN_listhybrid = 3475;
		const QName_t LN_listid = 3481;
		const QName_t LN_rawclbgdkhor = 3485;
		const QName_t LN_listname = 3490;
		const QName_t LN_rawclbgdkvert = 3496;
		const QName_t LN_ab = 3498;
		const QName_t LN_listoverridecount = 3506;
		const QName_t LN_rawclbgfdiag = 3509;
		const QName_t LN_absh = 3514;
		const QName_t LN_rawclbghoriz = 3521;
		const QName_t LN_listoverrideformat = 3525;
		const QName_t LN_abslock = 3528;
		const QName_t LN_rawclbgvert = 3533;
		const QName_t LN_listoverridestart = 3541;
		const QName_t LN_rdblquote = 3546;
		const QName_t LN_absnoovrlp = 3549;
		const QName_t LN_red = 3551;
		const QName_t LN_listpicture = 3557;
		const QName_t LN_absw = 3561;
		const QName_t LN_rempersonalinfo = 3571;
		const QName_t LN_acaps = 3573;
		const QName_t LN_listrestarthdn = 3575;
		const QName_t LN_result = 3581;
		const QName_t LN_acccomma = 3584;
		const QName_t LN_listsimple = 3586;
		const QName_t LN_revauth = 3591;
		const QName_t LN_accdot = 3592;
		const QName_t LN_liststyleid = 3598;
		const QName_t LN_accnone = 3603;
		const QName_t LN_revauthdel = 3604;
		const QName_t LN_acf = 3610;
		const QName_t LN_liststylename = 3611;
		const QName_t LN_revbar = 3613;
		const QName_t LN_additive = 3617;
		const QName_t LN_revdttm = 3622;
		const QName_t LN_listtemplateid = 3626;
		const QName_t LN_adjustright = 3628;
		const QName_t LN_revdttmdel = 3635;
		const QName_t LN_adn = 3636;
		const QName_t LN_listtext = 3637;
		const QName_t LN_revised = 3647;
		const QName_t LN_aenddoc = 3648;
		const QName_t LN_lnbrkrule = 3649;
		const QName_t LN_revisions = 3650;
		const QName_t LN_aendnotes = 3656;
		const QName_t LN_lndscpsxn = 3660;
		const QName_t LN_revprop = 3661;
		const QName_t LN_aexpnd = 3666;
		const QName_t LN_lnongrid = 3670;
		const QName_t LN_revprot = 3671;
		const QName_t LN_af = 3674;
		const QName_t LN_loch = 3677;
		const QName_t LN_revtbl = 3680;
		const QName_t LN_affixed = 3685;
		const QName_t LN_lquote = 3688;
		const QName_t LN_revtim = 3690;
		const QName_t LN_afs = 3693;
		const QName_t LN_ls = 3695;
		const QName_t LN_ri = 3698;
		const QName_t LN_aftnbj = 3701;
		const QName_t LN_ltrch = 3705;
		const QName_t LN_rin = 3707;
		const QName_t LN_row = 3712;
		const QName_t LN_aftncn = 3713;
		const QName_t LN_ltrdoc = 3715;
		const QName_t LN_rquote = 3721;
		const QName_t LN_ltrmark = 3727;
		const QName_t LN_rsid = 3728;
		const QName_t LN_ltrpar = 3733;
		const QName_t LN_aftnnalc = 3734;
		const QName_t LN_rsidroot = 3737;
		const QName_t LN_ltrrow = 3741;
		const QName_t LN_aftnnar = 3743;
		const QName_t LN_rsidtbl = 3745;
		const QName_t LN_ltrsect = 3748;
		const QName_t LN_aftnnauc = 3752;
		const QName_t LN_rsltbmp = 3754;
		const QName_t LN_aftnnchi = 3761;
		const QName_t LN_rslthtml = 3763;
		const QName_t LN_lytcalctblwd = 3764;
		const QName_t LN_rsltmerge = 3775;
		const QName_t LN_lytexcttp = 3776;
		const QName_t LN_aftnnchosung = 3779;
		const QName_t LN_rsltpict = 3787;
		const QName_t LN_lytprtmet = 3788;
		const QName_t LN_aftnncnum = 3790;
		const QName_t LN_rsltrtf = 3798;
		const QName_t LN_lyttblrtgr = 3802;
		const QName_t LN_aftnndbar = 3803;
		const QName_t LN_rslttxt = 3809;
		const QName_t LN_mac = 3810;
		const QName_t LN_aftnndbnum = 3812;
		const QName_t LN_rtf = 3815;
		const QName_t LN_macpict = 3820;
		const QName_t LN_rtlch = 3824;
		const QName_t LN_aftnndbnumd = 3826;
		const QName_t LN_makebackup = 3830;
		const QName_t LN_rtldoc = 3833;
		const QName_t LN_aftnndbnumk = 3838;
		const QName_t LN_manager = 3839;
		const QName_t LN_rtlgutter = 3842;
		const QName_t LN_margb = 3846;
		const QName_t LN_aftnndbnumt = 3847;
		const QName_t LN_rtlmark = 3852;
		const QName_t LN_margbsxn = 3856;
		const QName_t LN_aftnnganada = 3860;
		const QName_t LN_rtlpar = 3862;
		const QName_t LN_margl = 3864;
		const QName_t LN_rtlrow = 3868;
		const QName_t LN_aftnngbnum = 3873;
		const QName_t LN_marglsxn = 3876;
		const QName_t LN_rtlsect = 3880;
		const QName_t LN_aftnngbnumd = 3884;
		const QName_t LN_margmirror = 3886;
		const QName_t LN_rxe = 3888;
		const QName_t LN_s = 3891;
		const QName_t LN_margr = 3897;
		const QName_t LN_aftnngbnumk = 3898;
		const QName_t LN_sa = 3899;
		const QName_t LN_margrsxn = 3906;
		const QName_t LN_saauto = 3909;
		const QName_t LN_aftnngbnuml = 3910;
		const QName_t LN_margt = 3913;
		const QName_t LN_aftnnrlc = 3919;
		const QName_t LN_saftnnalc = 3920;
		const QName_t LN_margtsxn = 3923;
		const QName_t LN_aftnnruc = 3929;
		const QName_t LN_saftnnar = 3930;
		const QName_t LN_mhtmltag = 3935;
		const QName_t LN_saftnnauc = 3939;
		const QName_t LN_aftnnzodiac = 3940;
		const QName_t LN_min = 3941;
		const QName_t LN_mo = 3946;
		const QName_t LN_saftnnchi = 3948;
		const QName_t LN_aftnnzodiacd = 3949;
		const QName_t LN_msmcap = 3954;
		const QName_t LN_saftnnchosung = 3956;
		const QName_t LN_aftnnzodiacl = 3957;
		const QName_t LN_nestcell = 3959;
		const QName_t LN_saftnncnum = 3965;
		const QName_t LN_nestrow = 3966;
		const QName_t LN_aftnrestart = 3969;
		const QName_t LN_saftnndbar = 3978;
		const QName_t LN_aftnrstcont = 3980;
		const QName_t LN_nesttableprops = 3981;
		const QName_t LN_saftnndbnum = 3989;
		const QName_t LN_aftnsep = 3991;
		const QName_t LN_nextfile = 3992;
		const QName_t LN_aftnsepc = 4002;
		const QName_t LN_saftnndbnumd = 4004;
		const QName_t LN_nobrkwrptbl = 4006;
		const QName_t LN_aftnstart = 4012;
		const QName_t LN_nocolbal = 4014;
		const QName_t LN_saftnndbnumk = 4015;
		const QName_t LN_aftntj = 4022;
		const QName_t LN_ai = 4027;
		const QName_t LN_saftnndbnumt = 4028;
		const QName_t LN_nocompatoptions = 4029;
		const QName_t LN_alang = 4036;
		const QName_t LN_nocwrap = 4039;
		const QName_t LN_saftnnganada = 4041;
		const QName_t LN_noextrasprl = 4050;
		const QName_t LN_allowfieldendsel = 4051;
		const QName_t LN_saftnngbnum = 4053;
		const QName_t LN_allprot = 4057;
		const QName_t LN_nofchars = 4058;
		const QName_t LN_saftnngbnumd = 4064;
		const QName_t LN_alntblind = 4069;
		const QName_t LN_nofcharsws = 4071;
		const QName_t LN_saftnngbnumk = 4077;
		const QName_t LN_alt = 4078;
		const QName_t LN_nofpages = 4080;
		const QName_t LN_animtext = 4089;
		const QName_t LN_saftnngbnuml = 4091;
		const QName_t LN_nofwords = 4093;
		const QName_t LN_annotation = 4097;
		const QName_t LN_saftnnrlc = 4103;
		const QName_t LN_nolead = 4104;
		const QName_t LN_annotprot = 4108;
		const QName_t LN_noline = 4114;
		const QName_t LN_saftnnruc = 4116;
		const QName_t LN_ansi = 4117;
		const QName_t LN_ansicpg = 4128;
		const QName_t LN_nolnhtadjtbl = 4131;
		const QName_t LN_saftnnzodiac = 4134;
		const QName_t LN_aoutl = 4137;
		const QName_t LN_nonesttables = 4143;
		const QName_t LN_saftnnzodiacd = 4145;
		const QName_t LN_ApplyBrkRules = 4149;
		const QName_t LN_nonshppict = 4151;
		const QName_t LN_saftnnzodiacl = 4155;
		const QName_t LN_ascaps = 4157;
		const QName_t LN_nooverflow = 4163;
		const QName_t LN_ashad = 4165;
		const QName_t LN_saftnrestart = 4166;
		const QName_t LN_noproof = 4170;
		const QName_t LN_asianbrkrule = 4178;
		const QName_t LN_saftnrstcont = 4180;
		const QName_t LN_nosectexpand = 4181;
		const QName_t LN_aspalpha = 4187;
		const QName_t LN_saftnstart = 4190;
		const QName_t LN_aspnum = 4192;
		const QName_t LN_nosnaplinegrid = 4195;
		const QName_t LN_sautoupd = 4198;
		const QName_t LN_astrike = 4203;
		const QName_t LN_sb = 4205;
		const QName_t LN_nospaceforul = 4209;
		const QName_t LN_atnauthor = 4213;
		const QName_t LN_sbasedon = 4215;
		const QName_t LN_nosupersub = 4218;
		const QName_t LN_atndate = 4223;
		const QName_t LN_sbauto = 4224;
		const QName_t LN_notabind = 4227;
		const QName_t LN_atnicn = 4231;
		const QName_t LN_sbkcol = 4232;
		const QName_t LN_atnid = 4240;
		const QName_t LN_noultrlspc = 4241;
		const QName_t LN_sbkeven = 4244;
		const QName_t LN_atnparent = 4250;
		const QName_t LN_sbknone = 4252;
		const QName_t LN_nowidctlpar = 4254;
		const QName_t LN_atnref = 4257;
		const QName_t LN_sbkodd = 4259;
		const QName_t LN_nowrap = 4262;
		const QName_t LN_atntime = 4267;
		const QName_t LN_sbkpage = 4268;
		const QName_t LN_nowwrap = 4270;
		const QName_t LN_sbys = 4278;
		const QName_t LN_atrfend = 4280;
		const QName_t LN_noxlattoyen = 4282;
		const QName_t LN_scaps = 4289;
		const QName_t LN_atrfstart = 4290;
		const QName_t LN_objalias = 4292;
		const QName_t LN_scompose = 4295;
		const QName_t LN_aul = 4297;
		const QName_t LN_objalign = 4304;
		const QName_t LN_sec = 4305;
		const QName_t LN_auld = 4306;
		const QName_t LN_sect = 4308;
		const QName_t LN_auldb = 4312;
		const QName_t LN_objattph = 4313;
		const QName_t LN_sectd = 4317;
		const QName_t LN_aulnone = 4320;
		const QName_t LN_objautlink = 4323;
		const QName_t LN_sectdefaultcl = 4329;
		const QName_t LN_aulw = 4330;
		const QName_t LN_objclass = 4332;
		const QName_t LN_aup = 4336;
		const QName_t LN_sectexpand = 4338;
		const QName_t LN_objcropb = 4344;
		const QName_t LN_author = 4345;
		const QName_t LN_b = 4349;
		const QName_t LN_sectlinegrid = 4352;
		const QName_t LN_objcropl = 4353;
		const QName_t LN_background = 4355;
		const QName_t LN_sectnum = 4360;
		const QName_t LN_objcropr = 4363;
		const QName_t LN_bdbfhdr = 4364;
		const QName_t LN_sectrsid = 4369;
		const QName_t LN_objcropt = 4374;
		const QName_t LN_bdrrlswsix = 4377;
		const QName_t LN_objdata = 4383;
		const QName_t LN_bgbdiag = 4384;
		const QName_t LN_sectspecifycl = 4385;
		const QName_t LN_object = 4388;
		const QName_t LN_bgcross = 4393;
		const QName_t LN_objemb = 4397;
		const QName_t LN_sectspecifygen = 4399;
		const QName_t LN_bgdcross = 4404;
		const QName_t LN_objh = 4405;
		const QName_t LN_sectspecifyl = 4411;
		const QName_t LN_objhtml = 4412;
		const QName_t LN_bgdkbdiag = 4415;
		const QName_t LN_sectunlocked = 4421;
		const QName_t LN_objicemb = 4422;
		const QName_t LN_bgdkcross = 4424;
		const QName_t LN_sftnbj = 4428;
		const QName_t LN_objlink = 4430;
		const QName_t LN_bgdkdcross = 4435;
		const QName_t LN_sftnnalc = 4441;
		const QName_t LN_objlock = 4442;
		const QName_t LN_bgdkfdiag = 4447;
		const QName_t LN_sftnnar = 4452;
		const QName_t LN_objname = 4453;
		const QName_t LN_bgdkhoriz = 4459;
		const QName_t LN_objocx = 4463;
		const QName_t LN_sftnnauc = 4464;
		const QName_t LN_bgdkvert = 4468;
		const QName_t LN_objpub = 4471;
		const QName_t LN_sftnnchi = 4474;
		const QName_t LN_bgfdiag = 4477;
		const QName_t LN_objscalex = 4481;
		const QName_t LN_sftnnchosung = 4483;
		const QName_t LN_bghoriz = 4485;
		const QName_t LN_objscaley = 4490;
		const QName_t LN_sftnncnum = 4494;
		const QName_t LN_bgvert = 4495;
		const QName_t LN_bin = 4499;
		const QName_t LN_objsect = 4500;
		const QName_t LN_sftnndbar = 4506;
		const QName_t LN_binfsxn = 4509;
		const QName_t LN_objsetsize = 4510;
		const QName_t LN_sftnndbnum = 4514;
		const QName_t LN_binsxn = 4519;
		const QName_t LN_objsub = 4521;
		const QName_t LN_sftnndbnumd = 4524;
		const QName_t LN_bkmkcolf = 4526;
		const QName_t LN_objtime = 4528;
		const QName_t LN_bkmkcoll = 4536;
		const QName_t LN_sftnndbnumk = 4537;
		const QName_t LN_objtransy = 4538;
		const QName_t LN_bkmkend = 4546;
		const QName_t LN_objupdate = 4547;
		const QName_t LN_sftnndbnumt = 4549;
		const QName_t LN_bkmkpub = 4554;
		const QName_t LN_objw = 4556;
		const QName_t LN_sftnnganada = 4560;
		const QName_t LN_oldas = 4563;
		const QName_t LN_bkmkstart = 4564;
		const QName_t LN_sftnngbnum = 4569;
		const QName_t LN_bliptag = 4573;
		const QName_t LN_oldcprops = 4574;
		const QName_t LN_sftnngbnumd = 4580;
		const QName_t LN_blipuid = 4581;
		const QName_t LN_oldpprops = 4582;
		const QName_t LN_blipupi = 4589;
		const QName_t LN_sftnngbnumk = 4590;
		const QName_t LN_oldsprops = 4591;
		const QName_t LN_blue = 4595;
		const QName_t LN_oldtprops = 4604;
		const QName_t LN_sftnngbnuml = 4606;
		const QName_t LN_bookfold = 4607;
		const QName_t LN_sftnnrlc = 4613;
		const QName_t LN_oldlinewrap = 4616;
		const QName_t LN_bookfoldrev = 4617;
		const QName_t LN_operator = 4621;
		const QName_t LN_sftnnruc = 4626;
		const QName_t LN_otblrul = 4631;
		const QName_t LN_bookfoldsheets = 4632;
		const QName_t LN_box = 4637;
		const QName_t LN_sftnnzodiac = 4641;
		const QName_t LN_outl = 4643;
		const QName_t LN_brdrart = 4649;
		const QName_t LN_sftnnzodiacd = 4651;
		const QName_t LN_outlinelevel = 4653;
		const QName_t LN_brdrb = 4658;
		const QName_t LN_overlay = 4664;
		const QName_t LN_sftnnzodiacl = 4667;
		const QName_t LN_brdrbar = 4669;
		const QName_t LN_page = 4670;
		const QName_t LN_brdrbtw = 4678;
		const QName_t LN_sftnrestart = 4679;
		const QName_t LN_pagebb = 4680;
		const QName_t LN_brdrcf = 4689;
		const QName_t LN_panose = 4690;
		const QName_t LN_sftnrstcont = 4692;
		const QName_t LN_paperh = 4697;
		const QName_t LN_brdrdash = 4699;
		const QName_t LN_sftnrstpg = 4703;
		const QName_t LN_paperw = 4707;
		const QName_t LN_brdrdashd = 4708;
		const QName_t LN_par = 4713;
		const QName_t LN_sftnstart = 4714;
		const QName_t LN_brdrdashdd = 4720;
		const QName_t LN_pararsid = 4723;
		const QName_t LN_sftntj = 4725;
		const QName_t LN_pard = 4730;
		const QName_t LN_shad = 4732;
		const QName_t LN_brdrdashdotstr = 4737;
		const QName_t LN_pc = 4739;
		const QName_t LN_shading = 4742;
		const QName_t LN_pca = 4745;
		const QName_t LN_brdrdashsm = 4749;
		const QName_t LN_shidden = 4752;
		const QName_t LN_pgbrdrb = 4755;
		const QName_t LN_brdrdb = 4757;
		const QName_t LN_shift = 4760;
		const QName_t LN_brdrdot = 4764;
		const QName_t LN_pgbrdrfoot = 4765;
		const QName_t LN_shpbottom = 4770;
		const QName_t LN_brdremboss = 4776;
		const QName_t LN_pgbrdrhead = 4777;
		const QName_t LN_shpbxcolumn = 4780;
		const QName_t LN_pgbrdrl = 4784;
		const QName_t LN_brdrengrave = 4787;
		const QName_t LN_shpbxignore = 4792;
		const QName_t LN_pgbrdropt = 4795;
		const QName_t LN_brdrframe = 4796;
		const QName_t LN_shpbxmargin = 4801;
		const QName_t LN_pgbrdrr = 4802;
		const QName_t LN_brdrhair = 4805;
		const QName_t LN_shpbxpage = 4810;
		const QName_t LN_pgbrdrsnap = 4811;
		const QName_t LN_brdrinset = 4813;
		const QName_t LN_pgbrdrt = 4821;
		const QName_t LN_shpbyignore = 4822;
		const QName_t LN_brdrl = 4823;
		const QName_t LN_pghsxn = 4830;
		const QName_t LN_brdrnil = 4831;
		const QName_t LN_shpbymargin = 4834;
		const QName_t LN_pgnbidia = 4839;
		const QName_t LN_brdroutset = 4841;
		const QName_t LN_shpbypage = 4843;
		const QName_t LN_pgnbidib = 4849;
		const QName_t LN_brdrr = 4850;
		const QName_t LN_shpbypara = 4851;
		const QName_t LN_brdrs = 4858;
		const QName_t LN_pgnchosung = 4860;
		const QName_t LN_shpfblwtxt = 4864;
		const QName_t LN_brdrsh = 4867;
		const QName_t LN_pgncnum = 4868;
		const QName_t LN_shpfhdr = 4872;
		const QName_t LN_brdrt = 4873;
		const QName_t LN_pgncont = 4877;
		const QName_t LN_shpgrp = 4883;
		const QName_t LN_brdrtbl = 4884;
		const QName_t LN_pgndbnum = 4887;
		const QName_t LN_shpleft = 4890;
		const QName_t LN_brdrth = 4893;
		const QName_t LN_pgndbnumd = 4896;
		const QName_t LN_shplid = 4898;
		const QName_t LN_brdrthtnlg = 4901;
		const QName_t LN_pgndbnumk = 4906;
		const QName_t LN_shplockanchor = 4908;
		const QName_t LN_brdrthtnmg = 4910;
		const QName_t LN_pgndbnumt = 4915;
		const QName_t LN_shppict = 4919;
		const QName_t LN_brdrthtnsg = 4920;
		const QName_t LN_pgndec = 4923;
		const QName_t LN_shpright = 4925;
		const QName_t LN_brdrtnthlg = 4931;
		const QName_t LN_pgndecd = 4932;
		const QName_t LN_shprslt = 4935;
		const QName_t LN_brdrtnthmg = 4941;
		const QName_t LN_pgnganada = 4942;
		const QName_t LN_shptop = 4945;
		const QName_t LN_pgngbnum = 4950;
		const QName_t LN_brdrtnthsg = 4951;
		const QName_t LN_shptxt = 4952;
		const QName_t LN_shpwrk = 4959;
		const QName_t LN_pgngbnumd = 4960;
		const QName_t LN_brdrtnthtnlg = 4962;
		const QName_t LN_shpwr = 4965;
		const QName_t LN_pgngbnumk = 4967;
		const QName_t LN_brdrtnthtnmg = 4973;
		const QName_t LN_shpz = 4974;
		const QName_t LN_pgngbnuml = 4975;
		const QName_t LN_sl = 4976;
		const QName_t LN_brdrtnthtnsg = 4983;
		const QName_t LN_slmult = 4985;
		const QName_t LN_pgnhindia = 4987;
		const QName_t LN_brdrtriple = 4991;
		const QName_t LN_pgnhindib = 4993;
		const QName_t LN_snaptogridincell = 4994;
		const QName_t LN_brdrw = 4998;
		const QName_t LN_pgnhindic = 5002;
		const QName_t LN_snext = 5003;
		const QName_t LN_brdrwavy = 5006;
		const QName_t LN_softcol = 5011;
		const QName_t LN_pgnhindid = 5012;
		const QName_t LN_brdrwavydb = 5014;
		const QName_t LN_pgnhn = 5019;
		const QName_t LN_softlheight = 5020;
		const QName_t LN_brkfrm = 5022;
		const QName_t LN_pgnhnsc = 5025;
		const QName_t LN_brsp = 5028;
		const QName_t LN_softline = 5029;
		const QName_t LN_pgnhnsh = 5035;
		const QName_t LN_bullet = 5037;
		const QName_t LN_softpage = 5038;
		const QName_t LN_pgnhnsm = 5043;
		const QName_t LN_spersonal = 5047;
		const QName_t LN_pgnhnsn = 5051;
		const QName_t LN_buptim = 5053;
		const QName_t LN_splytwnine = 5056;
		const QName_t LN_bxe = 5060;
		const QName_t LN_pgnhnsp = 5061;
		const QName_t LN_caps = 5064;
		const QName_t LN_sprsbsp = 5066;
		const QName_t LN_pgnid = 5069;
		const QName_t LN_category = 5070;
		const QName_t LN_cb = 5075;
		const QName_t LN_sprslnsp = 5077;
		const QName_t LN_pgnlcltr = 5079;
		const QName_t LN_cbpat = 5083;
		const QName_t LN_sprsspbf = 5087;
		const QName_t LN_pgnlcrm = 5088;
		const QName_t LN_cchs = 5090;
		const QName_t LN_cell = 5097;
		const QName_t LN_sprstsm = 5098;
		const QName_t LN_pgnrestart = 5100;
		const QName_t LN_cellx = 5104;
		const QName_t LN_sprstsp = 5107;
		const QName_t LN_pgnstart = 5109;
		const QName_t LN_cf = 5113;
		const QName_t LN_spv = 5114;
		const QName_t LN_cfpat = 5117;
		const QName_t LN_pgnstarts = 5121;
		const QName_t LN_sreply = 5124;
		const QName_t LN_cgrid = 5125;
		const QName_t LN_pgnthaia = 5128;
		const QName_t LN_ssemihidden = 5131;
		const QName_t LN_charrsid = 5134;
		const QName_t LN_pgnthaib = 5136;
		const QName_t LN_staticval = 5141;
		const QName_t LN_charscalex = 5145;
		const QName_t LN_pgnthaic = 5147;
		const QName_t LN_stextflow = 5150;
		const QName_t LN_chatn = 5152;
		const QName_t LN_strike = 5155;
		const QName_t LN_pgnucltr = 5156;
		const QName_t LN_chbgbdiag = 5161;
		const QName_t LN_pgnucrm = 5165;
		const QName_t LN_striked1 = 5167;
		const QName_t LN_chbgcross = 5173;
		const QName_t LN_stshfbi = 5175;
		const QName_t LN_pgnvieta = 5176;
		const QName_t LN_pgnx = 5183;
		const QName_t LN_chbgdcross = 5186;
		const QName_t LN_stshfdbch = 5187;
		const QName_t LN_pgny = 5191;
		const QName_t LN_stshfhich = 5197;
		const QName_t LN_chbgdkbdiag = 5198;
		const QName_t LN_pgnzodiac = 5200;
		const QName_t LN_stshfloch = 5206;
		const QName_t LN_chbgdkcross = 5207;
		const QName_t LN_pgnzodiacd = 5209;
		const QName_t LN_stylesheet = 5215;
		const QName_t LN_chbgdkdcross = 5218;
		const QName_t LN_pgnzodiacl = 5219;
		const QName_t LN_styrsid = 5223;
		const QName_t LN_pgp = 5225;
		const QName_t LN_sub = 5227;
		const QName_t LN_chbgdkfdiag = 5228;
		const QName_t LN_pgptbl = 5234;
		const QName_t LN_subdocument = 5235;
		const QName_t LN_chbgdkhoriz = 5237;
		const QName_t LN_pgwsxn = 5242;
		const QName_t LN_chbgdkvert = 5247;
		const QName_t LN_phcol = 5249;
		const QName_t LN_subfontbysize = 5251;
		const QName_t LN_subject = 5255;
		const QName_t LN_phmrg = 5256;
		const QName_t LN_chbgfdiag = 5260;
		const QName_t LN_super = 5263;
		const QName_t LN_phpg = 5266;
		const QName_t LN_chbghoriz = 5269;
		const QName_t LN_swpbdr = 5270;
		const QName_t LN_picbmp = 5272;
		const QName_t LN_tab = 5278;
		const QName_t LN_chbgvert = 5282;
		const QName_t LN_picbpp = 5283;
		const QName_t LN_tabsnoovrlp = 5285;
		const QName_t LN_chbrdr = 5287;
		const QName_t LN_piccropb = 5292;
		const QName_t LN_taprtl = 5296;
		const QName_t LN_chcbpat = 5297;
		const QName_t LN_piccropl = 5302;
		const QName_t LN_tb = 5303;
		const QName_t LN_chcfpat = 5306;
		const QName_t LN_piccropr = 5311;
		const QName_t LN_tbllkbestfit = 5315;
		const QName_t LN_chdate = 5316;
		const QName_t LN_piccropt = 5319;
		const QName_t LN_chdpa = 5321;
		const QName_t LN_tbllkborder = 5326;
		const QName_t LN_pich = 5328;
		const QName_t LN_chdpl = 5332;
		const QName_t LN_tbllkcolor = 5335;
		const QName_t LN_pichgoal = 5336;
		const QName_t LN_chftn = 5337;
		const QName_t LN_tbllkfont = 5346;
		const QName_t LN_picprop = 5347;
		const QName_t LN_chftnsep = 5349;
		const QName_t LN_picscaled = 5359;
		const QName_t LN_chftnsepc = 5360;
		const QName_t LN_tbllkhdrcols = 5361;
		const QName_t LN_chpgn = 5368;
		const QName_t LN_picscalex = 5369;
		const QName_t LN_tbllkhdrrows = 5374;
		const QName_t LN_chshdng = 5378;
		const QName_t LN_picscaley = 5379;
		const QName_t LN_tbllklastcol = 5384;
		const QName_t LN_pict = 5385;
		const QName_t LN_chtime = 5387;
		const QName_t LN_picw = 5395;
		const QName_t LN_clbgbdiag = 5399;
		const QName_t LN_tbllklastrow = 5400;
		const QName_t LN_picwgoal = 5405;
		const QName_t LN_clbgcross = 5410;
		const QName_t LN_tbllkshading = 5413;
		const QName_t LN_plain = 5415;
		const QName_t LN_clbgdcross = 5422;
		const QName_t LN_tblrsid = 5423;
		const QName_t LN_pmmetafile = 5428;
		const QName_t LN_tc = 5429;
		const QName_t LN_pn = 5434;
		const QName_t LN_clbgdkbdiag = 5436;
		const QName_t LN_tcelld = 5439;
		const QName_t LN_pnacross = 5443;
		const QName_t LN_tcf = 5444;
		const QName_t LN_clbgdkcross = 5447;
		const QName_t LN_tcl = 5451;
		const QName_t LN_pnaiu = 5452;
		const QName_t LN_tcn = 5458;
		const QName_t LN_clbgdkdcross = 5460;
		const QName_t LN_pnaiud = 5461;
		const QName_t LN_pnaiueo = 5469;
		const QName_t LN_clbgdkfdiag = 5473;
		const QName_t LN_tdfrmtxtBottom = 5474;
		const QName_t LN_pnaiueod = 5481;
		const QName_t LN_clbgdkhor = 5482;
		const QName_t LN_tdfrmtxtLeft = 5484;
		const QName_t LN_pnb = 5488;
		const QName_t LN_clbgdkvert = 5494;
		const QName_t LN_pnbidia = 5495;
		const QName_t LN_tdfrmtxtRight = 5496;
		const QName_t LN_clbgfdiag = 5503;
		const QName_t LN_pnbidib = 5504;
		const QName_t LN_tdfrmtxtTop = 5506;
		const QName_t LN_template = 5509;
		const QName_t LN_clbghoriz = 5510;
		const QName_t LN_pncaps = 5511;
		const QName_t LN_time = 5515;
		const QName_t LN_title = 5517;
		const QName_t LN_pncard = 5518;
		const QName_t LN_clbgvert = 5520;
		const QName_t LN_pncf = 5525;
		const QName_t LN_titlepg = 5527;
		const QName_t LN_clbrdrb = 5529;
		const QName_t LN_tldot = 5536;
		const QName_t LN_pnchosung = 5537;
		const QName_t LN_clbrdrl = 5538;
		const QName_t LN_tleq = 5540;
		const QName_t LN_pncnum = 5545;
		const QName_t LN_clbrdrr = 5548;
		const QName_t LN_tlhyph = 5549;
		const QName_t LN_pndbnum = 5551;
		const QName_t LN_clbrdrt = 5554;
		const QName_t LN_tlmdot = 5560;
		const QName_t LN_pndbnumd = 5561;
		const QName_t LN_clcbpat = 5562;
		const QName_t LN_tlth = 5564;
		const QName_t LN_pndbnumk = 5570;
		const QName_t LN_tlul = 5572;
		const QName_t LN_clcbpatraw = 5573;
		const QName_t LN_pndbnuml = 5578;
		const QName_t LN_clcfpat = 5581;
		const QName_t LN_toplinepunct = 5583;
		const QName_t LN_pndbnumt = 5589;
		const QName_t LN_tphcol = 5593;
		const QName_t LN_clcfpatraw = 5594;
		const QName_t LN_pndec = 5596;
		const QName_t LN_tphmrg = 5600;
		const QName_t LN_cldgll = 5601;
		const QName_t LN_pndecd = 5605;
		const QName_t LN_tphpg = 5608;
		const QName_t LN_cldglu = 5609;
		const QName_t LN_pnf = 5614;
		const QName_t LN_tposnegx = 5619;
		const QName_t LN_clFitText = 5621;
		const QName_t LN_pnfs = 5622;
		const QName_t LN_tposnegy = 5630;
		const QName_t LN_pnganada = 5631;
		const QName_t LN_clftsWidth = 5632;
		const QName_t LN_tposxc = 5636;
		const QName_t LN_clmgf = 5639;
		const QName_t LN_pngblip = 5640;
		const QName_t LN_tposxi = 5643;
		const QName_t LN_clmrg = 5647;
		const QName_t LN_pngbnum = 5650;
		const QName_t LN_tposxl = 5652;
		const QName_t LN_cloWrap = 5655;
		const QName_t LN_pngbnumd = 5660;
		const QName_t LN_tposx = 5662;
		const QName_t LN_clpadb = 5666;
		const QName_t LN_pngbnumk = 5667;
		const QName_t LN_tposxo = 5671;
		const QName_t LN_clpadfb = 5676;
		const QName_t LN_pngbnuml = 5679;
		const QName_t LN_tposxr = 5680;
		const QName_t LN_clpadfl = 5682;
		const QName_t LN_pnhang = 5687;
		const QName_t LN_tposy = 5688;
		const QName_t LN_clpadfr = 5692;
		const QName_t LN_pni = 5693;
		const QName_t LN_tposyb = 5694;
		const QName_t LN_clpadft = 5699;
		const QName_t LN_pnindent = 5700;
		const QName_t LN_tposyc = 5703;
		const QName_t LN_clpadl = 5709;
		const QName_t LN_pniroha = 5710;
		const QName_t LN_tposyil = 5711;
		const QName_t LN_clpadr = 5716;
		const QName_t LN_pnirohad = 5721;
		const QName_t LN_tposyin = 5722;
		const QName_t LN_clpadt = 5725;
		const QName_t LN_pnlcltr = 5728;
		const QName_t LN_tposyoutv = 5732;
		const QName_t LN_clshdng = 5734;
		const QName_t LN_pnlcrm = 5737;
		const QName_t LN_tposyt = 5740;
		const QName_t LN_clshdngraw = 5744;
		const QName_t LN_pnlvl = 5745;
		const QName_t LN_tpvmrg = 5749;
		const QName_t LN_pnlvlblt = 5753;
		const QName_t LN_clshdrawnil = 5755;
		const QName_t LN_tpvpara = 5756;
		const QName_t LN_tpvpg = 5763;
		const QName_t LN_pnlvlbody = 5764;
		const QName_t LN_cltxbtlr = 5766;
		const QName_t LN_tqc = 5771;
		const QName_t LN_pnlvlcont = 5775;
		const QName_t LN_cltxlrtb = 5776;
		const QName_t LN_tqdec = 5780;
		const QName_t LN_pnnumonce = 5786;
		const QName_t LN_cltxlrtbv = 5787;
		const QName_t LN_tqr = 5789;
		const QName_t LN_pnord = 5795;
		const QName_t LN_cltxtbrl = 5798;
		const QName_t LN_transmf = 5799;
		const QName_t LN_pnordt = 5805;
		const QName_t LN_trauth = 5806;
		const QName_t LN_cltxtbrlv = 5807;
		const QName_t LN_pnprev = 5812;
		const QName_t LN_trautofit = 5815;
		const QName_t LN_clvertalb = 5817;
		const QName_t LN_pnqc = 5819;
		const QName_t LN_trbgbdiag = 5823;
		const QName_t LN_pnql = 5825;
		const QName_t LN_clvertalc = 5826;
		const QName_t LN_pnqr = 5830;
		const QName_t LN_trbgcross = 5834;
		const QName_t LN_clvertalt = 5835;
		const QName_t LN_pnrauth = 5840;
		const QName_t LN_clvmgf = 5841;
		const QName_t LN_trbgdcross = 5843;
		const QName_t LN_pnrdate = 5848;
		const QName_t LN_clvmrg = 5850;
		const QName_t LN_trbgdkbdiag = 5854;
		const QName_t LN_pnrestart = 5859;
		const QName_t LN_clwWidth = 5860;
		const QName_t LN_trbgdkcross = 5864;
		const QName_t LN_pnrnfc = 5867;
		const QName_t LN_collapsed = 5871;
		const QName_t LN_pnrnot = 5876;
		const QName_t LN_trbgdkdcross = 5881;
		const QName_t LN_colno = 5882;
		const QName_t LN_pnrpnbr = 5886;
		const QName_t LN_colortbl = 5890;
		const QName_t LN_trbgdkfdiag = 5891;
		const QName_t LN_cols = 5896;
		const QName_t LN_pnrrgb = 5897;
		const QName_t LN_trbgdkhor = 5901;
		const QName_t LN_colsr = 5904;
		const QName_t LN_pnrstart = 5906;
		const QName_t LN_colsx = 5912;
		const QName_t LN_trbgdkvert = 5913;
		const QName_t LN_pnrstop = 5914;
		const QName_t LN_column = 5917;
		const QName_t LN_trbgfdiag = 5924;
		const QName_t LN_pnrxst = 5925;
		const QName_t LN_colw = 5926;
		const QName_t LN_comment = 5932;
		const QName_t LN_pnscaps = 5935;
		const QName_t LN_trbghoriz = 5936;
		const QName_t LN_company = 5940;
		const QName_t LN_pnseclvl = 5945;
		const QName_t LN_trbgvert = 5946;
		const QName_t LN_cpg = 5948;
		const QName_t LN_pnsp = 5953;
		const QName_t LN_trbrdrb = 5955;
		const QName_t LN_crauth = 5956;
		const QName_t LN_pnstart = 5962;
		const QName_t LN_crdate = 5965;
		const QName_t LN_trbrdrh = 5966;
		const QName_t LN_pnstrike = 5971;
		const QName_t LN_creatim = 5976;
		const QName_t LN_trbrdrl = 5977;
		const QName_t LN_cs = 5982;
		const QName_t LN_pntext = 5984;
		const QName_t LN_trbrdrr = 5989;
		const QName_t LN_ctrl = 5992;
		const QName_t LN_pntxta = 5995;
		const QName_t LN_trbrdrt = 6000;
		const QName_t LN_cts = 6001;
		const QName_t LN_pntxtb = 6005;
		const QName_t LN_cufi = 6007;
		const QName_t LN_trbrdrv = 6011;
		const QName_t LN_pnucltr = 6015;
		const QName_t LN_culi = 6017;
		const QName_t LN_trcbpat = 6021;
		const QName_t LN_curi = 6025;
		const QName_t LN_pnucrm = 6026;
		const QName_t LN_trcfpat = 6029;
		const QName_t LN_pnul = 6032;
		const QName_t LN_cvmme = 6033;
		const QName_t LN_trdate = 6039;
		const QName_t LN_pnuld = 6042;
		const QName_t LN_datafield = 6045;
		const QName_t LN_date = 6050;
		const QName_t LN_trftsWidthA = 6052;
		const QName_t LN_pnuldash = 6054;
		const QName_t LN_dbch = 6056;
		const QName_t LN_pnuldashd = 6063;
		const QName_t LN_trftsWidthB = 6064;
		const QName_t LN_deff = 6067;
		const QName_t LN_pnuldashdd = 6075;
		const QName_t LN_trftsWidth = 6077;
		const QName_t LN_defformat = 6079;
		const QName_t LN_pnuldb = 6084;
		const QName_t LN_trgaph = 6086;
		const QName_t LN_deflang = 6088;
		const QName_t LN_trhdr = 6096;
		const QName_t LN_pnulhair = 6097;
		const QName_t LN_deflangfe = 6101;
		const QName_t LN_trkeep = 6105;
		const QName_t LN_pnulnone = 6108;
		const QName_t LN_defshp = 6109;
		const QName_t LN_trleft = 6114;
		const QName_t LN_pnulth = 6116;
		const QName_t LN_deftab = 6118;
		const QName_t LN_trowd = 6123;
		const QName_t LN_pnulw = 6124;
		const QName_t LN_deleted = 6126;
		const QName_t LN_trpaddb = 6132;
		const QName_t LN_pnulwave = 6134;
		const QName_t LN_delrsid = 6135;
		const QName_t LN_trpaddfb = 6141;
		const QName_t LN_pnzodiac = 6144;
		const QName_t LN_dfrauth = 6145;
		const QName_t LN_trpaddfl = 6153;
		const QName_t LN_pnzodiacd = 6156;
		const QName_t LN_dfrdate = 6157;
		const QName_t LN_trpaddfr = 6165;
		const QName_t LN_dfrmtxtx = 6167;
		const QName_t LN_pnzodiacl = 6168;
		const QName_t LN_trpaddft = 6175;
		const QName_t LN_posnegx = 6179;
		const QName_t LN_dfrmtxty = 6180;
		const QName_t LN_trpaddl = 6184;
		const QName_t LN_posnegy = 6186;
		const QName_t LN_dfrstart = 6189;
		const QName_t LN_trpaddr = 6196;
		const QName_t LN_posx = 6197;
		const QName_t LN_dfrstop = 6199;
		const QName_t LN_trpaddt = 6206;
		const QName_t LN_posxc = 6207;
		const QName_t LN_dfrxst = 6209;
		const QName_t LN_trpat = 6214;
		const QName_t LN_posxi = 6215;
		const QName_t LN_dghorigin = 6222;
		const QName_t LN_trqc = 6224;
		const QName_t LN_posxl = 6225;
		const QName_t LN_trql = 6229;
		const QName_t LN_dghshow = 6231;
		const QName_t LN_posxo = 6233;
		const QName_t LN_trqr = 6239;
		const QName_t LN_posxr = 6241;
		const QName_t LN_dghspace = 6242;
		const QName_t LN_trrh = 6247;
		const QName_t LN_posy = 6249;
		const QName_t LN_dgmargin = 6254;
		const QName_t LN_trshdng = 6259;
		const QName_t LN_posyb = 6260;
		const QName_t LN_dgsnap = 6264;
		const QName_t LN_trspdb = 6268;
		const QName_t LN_posyc = 6269;
		const QName_t LN_dgvorigin = 6277;
		const QName_t LN_trspdfb = 6279;
		const QName_t LN_posyil = 6280;
		const QName_t LN_dgvshow = 6286;
		const QName_t LN_posyin = 6289;
		const QName_t LN_trspdfl = 6290;
		const QName_t LN_dgvspace = 6297;
		const QName_t LN_posyout = 6298;
		const QName_t LN_trspdfr = 6300;
		const QName_t LN_dibitmap = 6307;
		const QName_t LN_posyt = 6308;
		const QName_t LN_trspdft = 6310;
		const QName_t LN_dn = 6313;
		const QName_t LN_prcolbl = 6318;
		const QName_t LN_trspdl = 6320;
		const QName_t LN_dntblnsbdb = 6326;
		const QName_t LN_trspdr = 6330;
		const QName_t LN_printdata = 6331;
		const QName_t LN_do = 6333;
		const QName_t LN_trspdt = 6338;
		const QName_t LN_printim = 6340;
		const QName_t LN_dobxcolumn = 6344;
		const QName_t LN_private = 6347;
		const QName_t LN_truncatefontheight = 6353;
		const QName_t LN_dobxmargin = 6354;
		const QName_t LN_propname = 6358;
		const QName_t LN_trwWidthA = 6363;
		const QName_t LN_dobxpage = 6366;
		const QName_t LN_proptype = 6370;
		const QName_t LN_trwWidthB = 6375;
		const QName_t LN_dobymargin = 6378;
		const QName_t LN_trwWidth = 6388;
		const QName_t LN_dobypage = 6392;
		const QName_t LN_ts = 6394;
		const QName_t LN_tsbgbdiag = 6405;
		const QName_t LN_tsbgcross = 6412;
		const QName_t LN_tsbgdcross = 6419;
		const QName_t LN_tsbgdkbdiag = 6427;
		const QName_t LN_tsbgdkcross = 6436;
		const QName_t LN_tsbgdkdcross = 6445;
		const QName_t LN_tsbgdkfdiag = 6457;
		const QName_t LN_tsbgdkhor = 6466;
		const QName_t LN_tsbgdkvert = 6477;
		const QName_t LN_tsbgfdiag = 6486;
		const QName_t LN_tsbghoriz = 6494;
		const QName_t LN_tsbgvert = 6504;
		const QName_t LN_tsbrdrb = 6510;
		const QName_t LN_tsbrdrdgl = 6518;
		const QName_t LN_tsbrdrdgr = 6529;
		const QName_t LN_tsbrdrh = 6540;
		const QName_t LN_tsbrdrl = 6547;
		const QName_t LN_tsbrdrr = 6556;
		const QName_t LN_tsbrdrt = 6565;
		const QName_t LN_tsbrdrv = 6572;
		const QName_t LN_tscbandhorzeven = 6582;
		const QName_t LN_tscbandhorzodd = 6590;
		const QName_t LN_tscbandsh = 6599;
		const QName_t LN_tscbandsv = 6605;
		const QName_t LN_tscbandverteven = 6617;
		const QName_t LN_tscbandvertodd = 6625;
		const QName_t LN_tscellcbpat = 6631;
		const QName_t LN_tscellcfpat = 6641;
		const QName_t LN_tscellpaddb = 6651;
		const QName_t LN_tscellpaddfb = 6662;
		const QName_t LN_tscellpaddfl = 6675;
		const QName_t LN_tscellpaddfr = 6692;
		const QName_t LN_tscellpaddft = 6703;
		const QName_t LN_tscellpaddl = 6714;
		const QName_t LN_tscellpaddr = 6725;
		const QName_t LN_tscellpaddt = 6737;
		const QName_t LN_tscellpct = 6745;
		const QName_t LN_tscellwidth = 6756;
		const QName_t LN_tscellwidthfts = 6769;
		const QName_t LN_tscfirstcol = 6781;
		const QName_t LN_tscfirstrow = 6790;
		const QName_t LN_tsclastcol = 6800;
		const QName_t LN_tsclastrow = 6805;
		const QName_t LN_tscnecell = 6814;
		const QName_t LN_tscnwcell = 6821;
		const QName_t LN_tscsecell = 6830;
		const QName_t LN_tscswcell = 6843;
		const QName_t LN_tsd = 6850;
		const QName_t LN_tsnowrap = 6859;
		const QName_t LN_tsrowd = 6866;
	}
	namespace NS_smil { /* urn:oasis:names:tc:opendocument:xmlns:smil-compatible:1.0 */
		const QName_t LN_calcMode = 975;
		const QName_t LN_type = 1028;
		const QName_t LN_subtype = 1035;
		const QName_t LN_direction = 1038;
		const QName_t LN_fadeColor = 1044;
		const QName_t LN_mode = 1050;
		const QName_t LN_targetElement = 1064;
		const QName_t LN_attributeName = 1075;
		const QName_t LN_values = 1090;
		const QName_t LN_keyTimes = 1097;
		const QName_t LN_keySplines = 1103;
		const QName_t LN_accumulate = 1110;
		const QName_t LN_additive = 1117;
		const QName_t LN_to = 1126;
		const QName_t LN_from = 1133;
		const QName_t LN_by = 1138;
		const QName_t LN_begin = 1144;
		const QName_t LN_end = 1149;
		const QName_t LN_dur = 1155;
		const QName_t LN_endsync = 1163;
		const QName_t LN_repeatDur = 1171;
		const QName_t LN_repeatCount = 1178;
		const QName_t LN_fill = 1187;
		const QName_t LN_fillDefault = 1197;
		const QName_t LN_restart = 1202;
		const QName_t LN_restartDefault = 1212;
		const QName_t LN_accelerate = 1223;
		const QName_t LN_decelerate = 1234;
		const QName_t LN_autoReverse = 1244;
	}
	namespace NS_w12 { /* http://schemas.microsoft.com/office/word/2005/8/25/wordml */
		const QName_t LN_truncateFontHeight = 8;
		const QName_t LN_mwSmallCaps = 15;
		const QName_t LN_usePrinterMetrics = 28;
		const QName_t LN_ww6BorderRules = 40;
		const QName_t LN_wrapTrailSpaces = 53;
		const QName_t LN_footnoteLayoutLikeWW8 = 67;
		const QName_t LN_shapeLayoutLikeWW8 = 79;
		const QName_t LN_alignTablesRowByRow = 90;
		const QName_t LN_forgetLastTabAlignment = 103;
		const QName_t LN_adjustLineHeightInTable = 115;
		const QName_t LN_autoSpaceLikeWord95 = 127;
		const QName_t LN_noSpaceRaiseLower = 138;
		const QName_t LN_doNotUseHTMLParagraphAutoSpacing = 156;
		const QName_t LN_layoutRawTableWidth = 170;
		const QName_t LN_layoutTableRowsApart = 185;
		const QName_t LN_useWord97LineBreakingRules = 202;
		const QName_t LN_breakWrappedTables = 210;
		const QName_t LN_snapToGridInCell = 220;
		const QName_t LN_dontAllowFieldEndSelect = 233;
		const QName_t LN_applyBreakingRules = 246;
		const QName_t LN_wrapTextWithPunct = 259;
		const QName_t LN_useAsianBreakRules = 271;
		const QName_t LN_useWord2002TableStyleRules = 286;
		const QName_t LN_dontGrowAutofit = 295;
		const QName_t LN_useFELayout = 305;
		const QName_t LN_useNormalStyleForList = 318;
		const QName_t LN_dontUseIndentAsNumberingTabStop = 337;
		const QName_t LN_dontUseWord11FELineBreak = 355;
		const QName_t LN_allowSpaceOfSameStyleInTable = 375;
		const QName_t LN_ww11IndentRules = 390;
		const QName_t LN_dontAutofitConstrainedTables = 407;
		const QName_t LN_autofitLikeWW11 = 420;
		const QName_t LN_underlineTabInNumList = 436;
		const QName_t LN_docVar = 444;
		const QName_t LN_rsidRoot = 454;
		const QName_t LN_rsid = 462;
		const QName_t LN_rPrDefault = 473;
		const QName_t LN_pPrDefault = 483;
		const QName_t LN_view = 491;
		const QName_t LN_zoom = 494;
		const QName_t LN_removePersonalInformation = 510;
		const QName_t LN_removeDateAndTime = 524;
		const QName_t LN_dontDisplayPageBoundaries = 543;
		const QName_t LN_displayBackgroundShape = 558;
		const QName_t LN_printPostScriptOverText = 577;
		const QName_t LN_printFractionalCharacterWidth = 600;
		const QName_t LN_printFormsData = 613;
		const QName_t LN_embedTrueTypeFonts = 628;
		const QName_t LN_doNotEmbedSystemFonts = 644;
		const QName_t LN_saveSubsetFonts = 657;
		const QName_t LN_saveFormsData = 668;
		const QName_t LN_mirrorMargins = 681;
		const QName_t LN_alignBordersAndEdges = 699;
		const QName_t LN_bordersDontSurroundHeader = 715;
		const QName_t LN_bordersDontSurroundFooter = 733;
		const QName_t LN_gutterAtTop = 743;
		const QName_t LN_hideSpellingErrors = 757;
		const QName_t LN_hideGrammaticalErrors = 773;
		const QName_t LN_activeWritingStyle = 789;
		const QName_t LN_proofState = 798;
		const QName_t LN_formsDesign = 808;
		const QName_t LN_attachedTemplate = 821;
		const QName_t LN_linkStyles = 829;
		const QName_t LN_stylePaneFormatFilter = 843;
		const QName_t LN_stylePaneSortMethod = 857;
		const QName_t LN_documentType = 868;
		const QName_t LN_mailMerge = 876;
		const QName_t LN_revisionView = 886;
		const QName_t LN_ilvl = 3973;
		const QName_t LN_ilfo = 3979;
		const QName_t LN_top = 3984;
		const QName_t LN_left = 3988;
		const QName_t LN_bottom = 3994;
		const QName_t LN_right = 3997;
		const QName_t LN_between = 4008;
		const QName_t LN_bar = 4013;
		const QName_t LN_tab = 4019;
		const QName_t LN_pStyle = 4026;
		const QName_t LN_keepNext = 4038;
		const QName_t LN_keepLines = 4046;
		const QName_t LN_pageBreakBefore = 4061;
		const QName_t LN_framePr = 4068;
		const QName_t LN_widowControl = 4083;
		const QName_t LN_listPr = 4095;
		const QName_t LN_supressLineNumbers = 4113;
		const QName_t LN_pBdr = 4124;
		const QName_t LN_shd = 4133;
		const QName_t LN_tabs = 4139;
		const QName_t LN_suppressAutoHyphens = 4153;
		const QName_t LN_kinsoku = 4162;
		const QName_t LN_wordWrap = 4172;
		const QName_t LN_overflowPunct = 4182;
		const QName_t LN_topLinePunct = 4194;
		const QName_t LN_autoSpaceDE = 4208;
		const QName_t LN_autoSpaceDN = 4217;
		const QName_t LN_bidi = 4226;
		const QName_t LN_adjustRightInd = 4239;
		const QName_t LN_snapToGrid = 4251;
		const QName_t LN_spacing = 4261;
		const QName_t LN_ind = 4266;
		const QName_t LN_contextualSpacing = 4284;
		const QName_t LN_mirrorIndents = 4296;
		const QName_t LN_textboxTightWrap = 4311;
		const QName_t LN_suppressOverlap = 4325;
		const QName_t LN_jc = 4331;
		const QName_t LN_textDirection = 4341;
		const QName_t LN_textAlignment = 4356;
		const QName_t LN_outlineLvl = 4366;
		const QName_t LN_divId = 4376;
		const QName_t LN_cnfStyle = 4386;
		const QName_t LN_rPr = 4389;
		const QName_t LN_sectPr = 4400;
		const QName_t LN_movie = 4420;
		const QName_t LN_background = 4429;
		const QName_t LN_applet = 4437;
		const QName_t LN_msAccessHTML = 4451;
		const QName_t LN_anchor = 4456;
		const QName_t LN_inline = 4466;
		const QName_t LN_args = 4473;
		const QName_t LN_appletText = 4482;
		const QName_t LN_fldData = 4493;
		const QName_t LN_r = 4497;
		const QName_t LN_fldSimple = 4508;
		const QName_t LN_hyperlink = 4518;
		const QName_t LN_ffData = 4522;
		const QName_t LN_name = 4530;
		const QName_t LN_trackRevisions = 4534;
		const QName_t LN_enabled = 4535;
		const QName_t LN_trackMoves = 4544;
		const QName_t LN_calcOnExit = 4545;
		const QName_t LN_entryMacro = 4555;
		const QName_t LN_trackFormatting = 4558;
		const QName_t LN_exitMacro = 4565;
		const QName_t LN_documentProtection = 4572;
		const QName_t LN_helpText = 4576;
		const QName_t LN_statusText = 4583;
		const QName_t LN_autoFormatOverride = 4588;
		const QName_t LN_checkBox = 4594;
		const QName_t LN_styleLockTheme = 4600;
		const QName_t LN_ddList = 4603;
		const QName_t LN_textInput = 4612;
		const QName_t LN_styleLockQFSet = 4615;
		const QName_t LN_size = 4620;
		const QName_t LN_defaultTabStop = 4629;
		const QName_t LN_sizeAuto = 4630;
		const QName_t LN_default = 4636;
		const QName_t LN_autoHyphenation = 4645;
		const QName_t LN_listEntry = 4648;
		const QName_t LN_type = 4652;
		const QName_t LN_maxLengh = 4663;
		const QName_t LN_consecutiveHyphenLimit = 4666;
		const QName_t LN_format = 4673;
		const QName_t LN_hyphenationZone = 4682;
		const QName_t LN_col = 4683;
		const QName_t LN_hdr = 4691;
		const QName_t LN_ftr = 4696;
		const QName_t LN_doNotHyphenateCaps = 4698;
		const QName_t LN_showEnvelope = 4710;
		const QName_t LN_headerReference = 4711;
		const QName_t LN_summaryLength = 4727;
		const QName_t LN_footerReference = 4728;
		const QName_t LN_footnotePr = 4740;
		const QName_t LN_clickAndTypeStyle = 4741;
		const QName_t LN_endnotePr = 4750;
		const QName_t LN_defaultTableStyle = 4758;
		const QName_t LN_pgSz = 4759;
		const QName_t LN_pgMar = 4763;
		const QName_t LN_evenAndOddHeaders = 4772;
		const QName_t LN_paperSrc = 4774;
		const QName_t LN_pgBorders = 4783;
		const QName_t LN_bookFoldRevPrinting = 4786;
		const QName_t LN_lnNumType = 4794;
		const QName_t LN_bookFoldPrinting = 4799;
		const QName_t LN_pgNumType = 4803;
		const QName_t LN_cols = 4809;
		const QName_t LN_bookFoldPrintingSheets = 4814;
		const QName_t LN_formProt = 4819;
		const QName_t LN_vAlign = 4827;
		const QName_t LN_drawingGridHorizontalSpacing = 4836;
		const QName_t LN_noEndnote = 4837;
		const QName_t LN_titlePg = 4847;
		const QName_t LN_textFlow = 4856;
		const QName_t LN_drawingGridVerticalSpacing = 4857;
		const QName_t LN_rtlGutter = 4866;
		const QName_t LN_docGrid = 4875;
		const QName_t LN_br = 4880;
		const QName_t LN_displayHorizontalDrawingGridEvery = 4881;
		const QName_t LN_t = 4885;
		const QName_t LN_delText = 4895;
		const QName_t LN_displayVerticalDrawingGridEvery = 4903;
		const QName_t LN_instrText = 4905;
		const QName_t LN_delInstrText = 4913;
		const QName_t LN_useMarginsForDrawingGridOrigin = 4921;
		const QName_t LN_noBreakHyphen = 4924;
		const QName_t LN_softHyphen = 4934;
		const QName_t LN_drawingGridHorizontalOrigin = 4940;
		const QName_t LN_dayShort = 4946;
		const QName_t LN_monthShort = 4955;
		const QName_t LN_drawingGridVerticalOrigin = 4958;
		const QName_t LN_yearShort = 4963;
		const QName_t LN_dayLong = 4970;
		const QName_t LN_doNotShadeFormData = 4972;
		const QName_t LN_monthLong = 4979;
		const QName_t LN_punctuationKerning = 4986;
		const QName_t LN_yearLong = 4988;
		const QName_t LN_annotationRef = 4997;
		const QName_t LN_characterSpacingControl = 5001;
		const QName_t LN_footnoteRef = 5007;
		const QName_t LN_printTwoOnOne = 5010;
		const QName_t LN_endnoteRef = 5017;
		const QName_t LN_separator = 5024;
		const QName_t LN_strictFirstAndLastChars = 5026;
		const QName_t LN_footnote = 5034;
		const QName_t LN_noLineBreaksAfter = 5039;
		const QName_t LN_endnote = 5042;
		const QName_t LN_noLineBreaksBefore = 5054;
		const QName_t LN_continuationSeparator = 5058;
		const QName_t LN_sym = 5063;
		const QName_t LN_webPageEncoding = 5068;
		const QName_t LN_pgNum = 5072;
		const QName_t LN_cr = 5078;
		const QName_t LN_object = 5082;
		const QName_t LN_optimizeForBrowser = 5084;
		const QName_t LN_pict = 5089;
		const QName_t LN_relyOnVML = 5093;
		const QName_t LN_fldChar = 5101;
		const QName_t LN_allowPNG = 5105;
		const QName_t LN_ruby = 5106;
		const QName_t LN_doNotRelyOnCSS = 5115;
		const QName_t LN_footnoteReference = 5123;
		const QName_t LN_endnoteReference = 5132;
		const QName_t LN_doNotSaveWebPagesAsSingleFile = 5137;
		const QName_t LN_oArt = 5138;
		const QName_t LN_ptab = 5148;
		const QName_t LN_doNotOrganizeInFolder = 5153;
		const QName_t LN_rStyle = 5154;
		const QName_t LN_rFonts = 5162;
		const QName_t LN_b = 5169;
		const QName_t LN_doNotUseLongFileNames = 5171;
		const QName_t LN_bCs = 5177;
		const QName_t LN_i = 5180;
		const QName_t LN_pixelsPerInch = 5185;
		const QName_t LN_iCs = 5189;
		const QName_t LN_caps = 5195;
		const QName_t LN_targetScreenSz = 5199;
		const QName_t LN_smallCaps = 5203;
		const QName_t LN_savePreviewPicture = 5212;
		const QName_t LN_strike = 5213;
		const QName_t LN_dstrike = 5220;
		const QName_t LN_outline = 5224;
		const QName_t LN_validateAgainstSchema = 5226;
		const QName_t LN_shadow = 5229;
		const QName_t LN_emboss = 5233;
		const QName_t LN_saveInvalidXML = 5238;
		const QName_t LN_imprint = 5240;
		const QName_t LN_noProof = 5250;
		const QName_t LN_ignoreMixedContent = 5254;
		const QName_t LN_vanish = 5257;
		const QName_t LN_webHidden = 5268;
		const QName_t LN_color = 5271;
		const QName_t LN_alwaysShowPlaceholderText = 5274;
		const QName_t LN_w = 5281;
		const QName_t LN_kern = 5284;
		const QName_t LN_position = 5290;
		const QName_t LN_doNotUnderlineInvalidXML = 5293;
		const QName_t LN_sz = 5298;
		const QName_t LN_szCs = 5305;
		const QName_t LN_highlight = 5309;
		const QName_t LN_removeWordSchemaOnSave = 5310;
		const QName_t LN_u = 5314;
		const QName_t LN_effect = 5318;
		const QName_t LN_useXSLTWhenSaving = 5324;
		const QName_t LN_bdr = 5325;
		const QName_t LN_fitText = 5334;
		const QName_t LN_saveThroughXSLT = 5338;
		const QName_t LN_vertAlign = 5344;
		const QName_t LN_showXMLTags = 5350;
		const QName_t LN_rtl = 5353;
		const QName_t LN_cs = 5358;
		const QName_t LN_em = 5366;
		const QName_t LN_alwaysMergeEmptyNamespace = 5373;
		const QName_t LN_hyphen = 5375;
		const QName_t LN_lang = 5380;
		const QName_t LN_doNotEmbedLinguisticData = 5392;
		const QName_t LN_asianLayout = 5394;
		const QName_t LN_specVanish = 5406;
		const QName_t LN_hdrShapeDefaults = 5408;
		const QName_t LN_oMath = 5411;
		const QName_t LN_compat = 5418;
		const QName_t LN_lists = 5420;
		const QName_t LN_styles = 5426;
		const QName_t LN_docVars = 5430;
		const QName_t LN_fonts = 5431;
		const QName_t LN_rsids = 5438;
		const QName_t LN_rubyAlign = 5441;
		const QName_t LN_hps = 5448;
		const QName_t LN_uiCompat97To2003 = 5453;
		const QName_t LN_hpsRaise = 5457;
		const QName_t LN_binData = 5463;
		const QName_t LN_hpsBaseText = 5471;
		const QName_t LN_sourceFileName = 5477;
		const QName_t LN_lid = 5478;
		const QName_t LN_marW = 5483;
		const QName_t LN_rubyPr = 5487;
		const QName_t LN_marH = 5492;
		const QName_t LN_rt = 5493;
		const QName_t LN_scrollbar = 5499;
		const QName_t LN_rubyBase = 5500;
		const QName_t LN_dateFormat = 5508;
		const QName_t LN_noResizeAllowed = 5512;
		const QName_t LN_listItem = 5519;
		const QName_t LN_linkedToFile = 5523;
		const QName_t LN_docPartType = 5531;
		const QName_t LN_noBorder = 5533;
		const QName_t LN_flatBorders = 5541;
		const QName_t LN_docPartCategory = 5544;
		const QName_t LN_docPartUnique = 5555;
		const QName_t LN_framesetSplitbar = 5557;
		const QName_t LN_frameLayout = 5565;
		const QName_t LN_pictureStorageType = 5568;
		const QName_t LN_frameset = 5574;
		const QName_t LN_docPart = 5577;
		const QName_t LN_frame = 5579;
		const QName_t LN_start = 5584;
		const QName_t LN_alias = 5586;
		const QName_t LN_nfc = 5592;
		const QName_t LN_invalidIfBlank = 5598;
		const QName_t LN_lvlRestart = 5603;
		const QName_t LN_lock = 5606;
		const QName_t LN_isLgl = 5610;
		const QName_t LN_placeholder = 5611;
		const QName_t LN_suff = 5618;
		const QName_t LN_showingPlcHdr = 5624;
		const QName_t LN_lvlText = 5627;
		const QName_t LN_edittingPlcHdr = 5635;
		const QName_t LN_lvlPicBulletId = 5641;
		const QName_t LN_dataBinding = 5648;
		const QName_t LN_legacy = 5651;
		const QName_t LN_lvlJc = 5656;
		const QName_t LN_comboBox = 5658;
		const QName_t LN_date = 5664;
		const QName_t LN_lsid = 5665;
		const QName_t LN_plt = 5672;
		const QName_t LN_docPartObj = 5674;
		const QName_t LN_tmpl = 5677;
		const QName_t LN_docPartList = 5684;
		const QName_t LN_styleLink = 5686;
		const QName_t LN_dropDownList = 5695;
		const QName_t LN_listStyleLink = 5696;
		const QName_t LN_lvl = 5704;
		const QName_t LN_picture = 5706;
		const QName_t LN_richText = 5712;
		const QName_t LN_startOverride = 5715;
		const QName_t LN_text = 5719;
		const QName_t LN_p = 5723;
		const QName_t LN_ilst = 5724;
		const QName_t LN_tbl = 5730;
		const QName_t LN_tr = 5733;
		const QName_t LN_lvlOverride = 5735;
		const QName_t LN_tc = 5739;
		const QName_t LN_sdtPr = 5746;
		const QName_t LN_listPicBullet = 5747;
		const QName_t LN_listDef = 5754;
		const QName_t LN_sdtContent = 5759;
		const QName_t LN_list = 5760;
		const QName_t LN_pPr = 5761;
		const QName_t LN_sdt = 5770;
		const QName_t LN_ilfoMacAtCleanup = 5774;
		const QName_t LN_subDoc = 5778;
		const QName_t LN_gridCol = 5781;
		const QName_t LN_aliases = 5783;
		const QName_t LN_insideH = 5788;
		const QName_t LN_sti = 5792;
		const QName_t LN_insideV = 5793;
		const QName_t LN_tl2br = 5797;
		const QName_t LN_basedOn = 5802;
		const QName_t LN_tr2bl = 5803;
		const QName_t LN_tcW = 5809;
		const QName_t LN_next = 5810;
		const QName_t LN_link = 5814;
		const QName_t LN_gridSpan = 5818;
		const QName_t LN_priority = 5822;
		const QName_t LN_hmerge = 5824;
		const QName_t LN_autoRedefine = 5832;
		const QName_t LN_vmerge = 5833;
		const QName_t LN_hidden = 5837;
		const QName_t LN_tcBorders = 5838;
		const QName_t LN_noWrap = 5844;
		const QName_t LN_semiHidden = 5847;
		const QName_t LN_tcMar = 5851;
		const QName_t LN_locked = 5855;
		const QName_t LN_tcFitText = 5862;
		const QName_t LN_unhideWhenUsed = 5869;
		const QName_t LN_hideMark = 5873;
		const QName_t LN_tcPr = 5878;
		const QName_t LN_qformat = 5879;
		const QName_t LN_personal = 5888;
		const QName_t LN_gridBefore = 5889;
		const QName_t LN_gridAfter = 5899;
		const QName_t LN_personalCompose = 5903;
		const QName_t LN_wBefore = 5910;
		const QName_t LN_personalReply = 5916;
		const QName_t LN_wAfter = 5919;
		const QName_t LN_tblStylePr = 5929;
		const QName_t LN_cantSplit = 5931;
		const QName_t LN_trHeight = 5941;
		const QName_t LN_lsdException = 5942;
		const QName_t LN_tblHeader = 5952;
		const QName_t LN_versionOfBuiltInStylenames = 5960;
		const QName_t LN_tblCellSpacing = 5964;
		const QName_t LN_latentStyles = 5973;
		const QName_t LN_tblPrEx = 5974;
		const QName_t LN_style = 5980;
		const QName_t LN_trPr = 5986;
		const QName_t LN_altName = 5994;
		const QName_t LN_tblStyle = 5997;
		const QName_t LN_panose1 = 6004;
		const QName_t LN_tblpPr = 6006;
		const QName_t LN_charset = 6014;
		const QName_t LN_family = 6019;
		const QName_t LN_tblOverlap = 6020;
		const QName_t LN_tblRtl = 6028;
		const QName_t LN_notTrueType = 6031;
		const QName_t LN_pitch = 6040;
		const QName_t LN_bidiVisual = 6041;
		const QName_t LN_sig = 6048;
		const QName_t LN_tblStyleRowBandSize = 6057;
		const QName_t LN_defaultFonts = 6061;
		const QName_t LN_font = 6068;
		const QName_t LN_tblStyleColBandSize = 6076;
		const QName_t LN_blockQuote = 6080;
		const QName_t LN_tblW = 6083;
		const QName_t LN_bodyDiv = 6091;
		const QName_t LN_tblInd = 6094;
		const QName_t LN_marLeft = 6100;
		const QName_t LN_tblBorders = 6106;
		const QName_t LN_marRight = 6111;
		const QName_t LN_tblLayout = 6117;
		const QName_t LN_marTop = 6121;
		const QName_t LN_tblCellMar = 6127;
		const QName_t LN_marBottom = 6129;
		const QName_t LN_tblLook = 6138;
		const QName_t LN_divBdr = 6139;
		const QName_t LN_tblPr = 6142;
		const QName_t LN_tblGrid = 6150;
		const QName_t LN_divsChild = 6151;
		const QName_t LN_pos = 6154;
		const QName_t LN_div = 6158;
		const QName_t LN_numFmt = 6164;
		const QName_t LN_txbxContent = 6170;
		const QName_t LN_numStart = 6174;
		const QName_t LN_cfChunk = 6181;
		const QName_t LN_numRestart = 6185;
		const QName_t LN_active = 6191;
		const QName_t LN_proofErr = 6192;
		const QName_t LN_hash = 6198;
		const QName_t LN_permStart = 6202;
		const QName_t LN_column = 6204;
		const QName_t LN_permEnd = 6212;
		const QName_t LN_uniqueTag = 6217;
		const QName_t LN_comments = 6226;
		const QName_t LN_mappedName = 6227;
		const QName_t LN_footnotes = 6235;
		const QName_t LN_dynamicAddress = 6243;
		const QName_t LN_endnotes = 6246;
		const QName_t LN_udl = 6251;
		const QName_t LN_table = 6257;
		const QName_t LN_category = 6258;
		const QName_t LN_src = 6265;
		const QName_t LN_types = 6267;
		const QName_t LN_filter = 6271;
		const QName_t LN_description = 6274;
		const QName_t LN_sort = 6276;
		const QName_t LN_guid = 6282;
		const QName_t LN_fieldMapData = 6288;
		const QName_t LN_docPartPr = 6292;
		const QName_t LN_colDelim = 6299;
		const QName_t LN_docPartBody = 6303;
		const QName_t LN_jdsoType = 6311;
		const QName_t LN_docPr = 6312;
		const QName_t LN_fHdr = 6319;
		const QName_t LN_docParts = 6321;
		const QName_t LN_recipientData = 6332;
		const QName_t LN_ignoreSubtree = 6335;
		const QName_t LN_mainDocumentType = 6345;
		const QName_t LN_ignoreElements = 6349;
		const QName_t LN_body = 6351;
		const QName_t LN_linkToQuery = 6361;
		const QName_t LN_wordDocument = 6365;
		const QName_t LN_dataType = 6371;
		const QName_t LN_wordTemplate = 6380;
		const QName_t LN_defaultSQL = 6383;
		const QName_t LN_glossaryDocument = 6396;
		const QName_t LN_connectString = 6397;
		const QName_t LN_query = 6404;
		const QName_t LN_dataSource = 6411;
		const QName_t LN_headerSource = 6420;
		const QName_t LN_doNotSuppressBlankLines = 6432;
		const QName_t LN_destination = 6442;
		const QName_t LN_addressFieldName = 6456;
		const QName_t LN_mailSubject = 6465;
		const QName_t LN_mailAsAttachment = 6479;
		const QName_t LN_viewMergedData = 6490;
		const QName_t LN_activeRecord = 6500;
		const QName_t LN_checkErrors = 6511;
		const QName_t LN_odso = 6517;
		const QName_t LN_origWordTableRules = 6532;
		const QName_t LN_wpJustification = 6545;
		const QName_t LN_noTabHangInd = 6558;
		const QName_t LN_noLeading = 6567;
		const QName_t LN_spaceForUL = 6577;
		const QName_t LN_noColumnBalance = 6585;
		const QName_t LN_balanceSingleByteDoubleByteWidth = 6600;
		const QName_t LN_transparentMetafiles = 6615;
		const QName_t LN_noExtraLineSpacing = 6624;
		const QName_t LN_doNotLeaveBackslashAlone = 6636;
		const QName_t LN_ulTrailSpace = 6646;
		const QName_t LN_doNotExpandShiftReturn = 6665;
		const QName_t LN_spacingInWholePoints = 6683;
		const QName_t LN_lineWrapLikeWord6 = 6699;
		const QName_t LN_printBodyTextBeforeHeader = 6721;
		const QName_t LN_printColBlack = 6732;
		const QName_t LN_wpSpaceWidth = 6743;
		const QName_t LN_showBreaksInFrames = 6755;
		const QName_t LN_subFontBySize = 6768;
		const QName_t LN_suppressBottomSpacing = 6783;
		const QName_t LN_suppressTopSpacing = 6798;
		const QName_t LN_suppressTopSpacingMac5 = 6809;
		const QName_t LN_suppressTopSpacingWP = 6822;
		const QName_t LN_suppressSpBfAfterPgBrk = 6840;
		const QName_t LN_swapBordersFacingPages = 6858;
		const QName_t LN_convMailMergeEsc = 6869;
	}
	namespace NS_rtfs { /* urn:rtf:schema */
		const QName_t LN_Toggle = 3505;
		const QName_t LN_Value = 3518;
		const QName_t LN_Flag = 3538;
		const QName_t LN_Destination = 3725;
		const QName_t LN_Symbol = 5045;
	}
	namespace NS_x2 { /* http://schemas.microsoft.com/office/excel/2003/xml */
		const QName_t LN_MapInfo = 2939;
		const QName_t LN_Binding = 2948;
		const QName_t LN_MapID = 2958;
		const QName_t LN_Schema = 2968;
		const QName_t LN_Map = 2978;
		const QName_t LN_ShowImportExportValidationErrors = 3008;
		const QName_t LN_Append = 3020;
		const QName_t LN_Entry = 3027;
		const QName_t LN_Mapdata = 3036;
		const QName_t LN_Range = 3043;
		const QName_t LN_HeaderRange = 3056;
		const QName_t LN_XPath = 3067;
		const QName_t LN_Field = 3073;
		const QName_t LN_ActiveRows = 3083;
		const QName_t LN_NoInserts = 3096;
		const QName_t LN_ReadOnly = 3101;
		const QName_t LN_InstanceShape = 3113;
		const QName_t LN_ActiveRow = 3120;
		const QName_t LN_XSDType = 3128;
		const QName_t LN_Aggregate = 3137;
	}
	namespace NS_ip12 { /* http://schemas.microsoft.com/office/infopath/2003/solutionDefinition */
		const QName_t LN_partFragment = 918;
		const QName_t LN_xmlFileAdapter = 929;
		const QName_t LN_sharepointListAdapter = 944;
		const QName_t LN_field = 947;
		const QName_t LN_davAdapter = 956;
		const QName_t LN_folderURL = 962;
		const QName_t LN_fileName = 969;
		const QName_t LN_emailAdapter = 978;
		const QName_t LN_to = 984;
		const QName_t LN_cc = 987;
		const QName_t LN_bcc = 993;
		const QName_t LN_subject = 996;
		const QName_t LN_intro = 1002;
		const QName_t LN_attachmentFileName = 1011;
		const QName_t LN_dataAdapters = 1016;
		const QName_t LN_documentSchemas = 1022;
		const QName_t LN_documentSchema = 1032;
		const QName_t LN_customValidation = 1042;
		const QName_t LN_errorCondition = 1052;
		const QName_t LN_errorMessage = 1061;
		const QName_t LN_domEventHandlers = 1074;
		const QName_t LN_domEventHandler = 1087;
		const QName_t LN_importParameters = 1107;
		const QName_t LN_importSource = 1114;
		const QName_t LN_listProperties = 1125;
		const QName_t LN_fields = 1128;
		const QName_t LN_submit = 1137;
		const QName_t LN_submitAction = 1148;
		const QName_t LN_successMessage = 1157;
		const QName_t LN_useHttpHandler = 1167;
		const QName_t LN_useScriptHandler = 1180;
		const QName_t LN_useQueryAdapter = 1192;
		const QName_t LN_onLoad = 1198;
		const QName_t LN_roles = 1205;
		const QName_t LN_role = 1210;
		const QName_t LN_membership = 1220;
		const QName_t LN_getUserNameFromData = 1237;
		const QName_t LN_userName = 1246;
		const QName_t LN_group = 1249;
		const QName_t LN_hwsWorkflow = 1260;
		const QName_t LN_location = 1264;
		const QName_t LN_allowedActions = 1275;
		const QName_t LN_action = 1281;
		const QName_t LN_allowedTasks = 1292;
		const QName_t LN_task = 1299;
		const QName_t LN_fileNew = 1307;
		const QName_t LN_initialXmlDocument = 1323;
		const QName_t LN_customCategory = 1339;
		const QName_t LN_package = 1347;
		const QName_t LN_files = 1355;
		const QName_t LN_file = 1358;
		const QName_t LN_fileProperties = 1370;
		const QName_t LN_property = 1375;
		const QName_t LN_permissions = 1388;
		const QName_t LN_allowedControl = 1403;
		const QName_t LN_externalViews = 1415;
		const QName_t LN_externalView = 1428;
		const QName_t LN_attributeData = 1440;
		const QName_t LN_button = 1447;
		const QName_t LN_chooseFragment = 1461;
		const QName_t LN_editWith = 1471;
		const QName_t LN_unboundControls = 1484;
		const QName_t LN_editing = 1493;
		const QName_t LN_masterDetail = 1505;
		const QName_t LN_fragmentToInsert = 1517;
		const QName_t LN_mainpane = 1528;
		const QName_t LN_printSettings = 1539;
		const QName_t LN_header = 1545;
		const QName_t LN_footer = 1551;
		const QName_t LN_toolbar = 1560;
		const QName_t LN_menu = 1569;
		const QName_t LN_menuArea = 1580;
		const QName_t LN_taskpane = 1591;
		const QName_t LN_views = 1598;
		const QName_t LN_view = 1605;
		const QName_t LN_xmlToEdit = 1614;
		const QName_t LN_documentSignatures = 1630;
		const QName_t LN_signedDataBlock = 1643;
		const QName_t LN_message = 1655;
		const QName_t LN_documentVersionUpgrade = 1674;
		const QName_t LN_useTransform = 1684;
		const QName_t LN_extensions = 1695;
		const QName_t LN_extension = 1702;
		const QName_t LN_ruleSetAction = 1716;
		const QName_t LN_rule = 1724;
		const QName_t LN_exitRuleSet = 1734;
		const QName_t LN_dialogBoxMessageAction = 1751;
		const QName_t LN_dialogBoxExpressionAction = 1772;
		const QName_t LN_switchViewAction = 1787;
		const QName_t LN_assignmentAction = 1804;
		const QName_t LN_queryAction = 1817;
		const QName_t LN_openNewDocumentAction = 1840;
		const QName_t LN_closeDocumentAction = 1858;
		const QName_t LN_ruleSet = 1868;
		const QName_t LN_ruleSets = 1879;
		const QName_t LN_calculations = 1893;
		const QName_t LN_calculatedField = 1906;
		const QName_t LN_xDocumentClass = 5245;
		const QName_t LN_schemaErrorMessages = 5265;
		const QName_t LN_override = 5275;
		const QName_t LN_applicationParameters = 5291;
		const QName_t LN_solutionProperties = 5307;
		const QName_t LN_featureRestrictions = 5322;
		const QName_t LN_save = 5331;
		const QName_t LN_exportToWeb = 5342;
		const QName_t LN_exportToExcel = 5356;
		const QName_t LN_print = 5362;
		const QName_t LN_sendMail = 5371;
		const QName_t LN_autoRecovery = 5382;
		const QName_t LN_query = 5388;
		const QName_t LN_scripts = 5393;
		const QName_t LN_script = 5398;
		const QName_t LN_dataObjects = 5412;
		const QName_t LN_dataObject = 5425;
		const QName_t LN_adoAdapter = 5437;
		const QName_t LN_webServiceAdapter = 5450;
		const QName_t LN_hwsAdapter = 5464;
		const QName_t LN_operation = 5467;
		const QName_t LN_hwsOperation = 5480;
		const QName_t LN_input = 5489;
	}
	namespace NS_rel12 { /* http://schemas.microsoft.com/package/2005/06/relationships */
		const QName_t LN_Relationships = 1173;
		const QName_t LN_Relationship = 1185;
	}
	namespace NS_NONE { /*  */
		const QName_t LN_datatypeLibrary = 1628;
		const QName_t LN_name = 1644;
		const QName_t LN_combine = 1810;
		const QName_t LN_type = 3268;
		const QName_t LN_ns = 3335;
		const QName_t LN_href = 3462;
	}
	namespace NS_config { /* urn:oasis:names:tc:opendocument:xmlns:config:1.0 */
		const QName_t LN_config_item_set = 1976;
		const QName_t LN_name = 1981;
		const QName_t LN_config_item = 1995;
		const QName_t LN_type = 2012;
		const QName_t LN_config_item_map_indexed = 2041;
		const QName_t LN_config_item_map_entry = 2058;
		const QName_t LN_config_item_map_named = 2079;
	}
	namespace NS_text { /* urn:oasis:names:tc:opendocument:xmlns:text:1.0 */
		const QName_t LN_dde_connection_decl = 866;
		const QName_t LN_first_row_start_column = 1658;
		const QName_t LN_first_row_end_column = 1672;
		const QName_t LN_last_row_start_column = 1689;
		const QName_t LN_last_row_end_column = 1707;
		const QName_t LN_global = 1890;
		const QName_t LN_object_index_source = 2131;
		const QName_t LN_use_spreadsheet_objects = 2153;
		const QName_t LN_use_math_objects = 2172;
		const QName_t LN_use_draw_objects = 2184;
		const QName_t LN_use_chart_objects = 2201;
		const QName_t LN_use_other_objects = 2217;
		const QName_t LN_object_index_entry_template = 2233;
		const QName_t LN_user_index = 2243;
		const QName_t LN_user_index_source = 2260;
		const QName_t LN_use_graphics = 2267;
		const QName_t LN_use_tables = 2278;
		const QName_t LN_use_floating_frames = 2292;
		const QName_t LN_use_objects = 2305;
		const QName_t LN_copy_outline_levels = 2319;
		const QName_t LN_user_index_entry_template = 2335;
		const QName_t LN_alphabetical_index = 2353;
		const QName_t LN_alphabetical_index_source = 2367;
		const QName_t LN_ignore_case = 2378;
		const QName_t LN_main_entry_style_name = 2393;
		const QName_t LN_alphabetical_separators = 2412;
		const QName_t LN_combine_entries = 2423;
		const QName_t LN_combine_entries_with_dash = 2443;
		const QName_t LN_combine_entries_with_pp = 2461;
		const QName_t LN_use_keys_as_entries = 2477;
		const QName_t LN_capitalize_entries = 2491;
		const QName_t LN_comma_separated = 2505;
		const QName_t LN_sort_algorithm = 2532;
		const QName_t LN_alphabetical_index_auto_mark_file = 2556;
		const QName_t LN_alphabetical_index_entry_template = 2578;
		const QName_t LN_bibliography = 2592;
		const QName_t LN_bibliography_source = 2609;
		const QName_t LN_bibliography_entry_template = 2629;
		const QName_t LN_index_source_styles = 2646;
		const QName_t LN_h = 2652;
		const QName_t LN_index_source_style = 2662;
		const QName_t LN_outline_level = 2667;
		const QName_t LN_index_title_template = 2678;
		const QName_t LN_restart_numbering = 2681;
		const QName_t LN_start_value = 2694;
		const QName_t LN_index_entry_chapter = 2699;
		const QName_t LN_is_list_header = 2709;
		const QName_t LN_index_entry_text = 2713;
		const QName_t LN_number = 2719;
		const QName_t LN_p = 2724;
		const QName_t LN_index_entry_page_number = 2731;
		const QName_t LN_style_name = 2735;
		const QName_t LN_class_names = 2744;
		const QName_t LN_index_entry_span = 2745;
		const QName_t LN_cond_style_name = 2758;
		const QName_t LN_index_entry_bibliography = 2764;
		const QName_t LN_page_sequence = 2770;
		const QName_t LN_page = 2779;
		const QName_t LN_bibliography_data_field = 2782;
		const QName_t LN_master_page_name = 2793;
		const QName_t LN_index_entry_tab_stop = 2802;
		const QName_t LN_list = 2804;
		const QName_t LN_continue_numbering = 2820;
		const QName_t LN_list_item = 2832;
		const QName_t LN_list_header = 2840;
		const QName_t LN_index_entry_link_start = 2846;
		const QName_t LN_numbered_paragraph = 2856;
		const QName_t LN_index_entry_link_end = 2864;
		const QName_t LN_level = 2867;
		const QName_t LN_section = 2873;
		const QName_t LN_name = 2879;
		const QName_t LN_protected = 2888;
		const QName_t LN_protection_key = 2902;
		const QName_t LN_display = 2911;
		const QName_t LN_condition = 2919;
		const QName_t LN_section_source = 2929;
		const QName_t LN_section_name = 2943;
		const QName_t LN_filter_name = 2954;
		const QName_t LN_linenumbering_configuration = 2960;
		const QName_t LN_tracked_changes = 2971;
		const QName_t LN_number_lines = 2975;
		const QName_t LN_track_changes = 2989;
		const QName_t LN_increment = 2990;
		const QName_t LN_changed_region = 3002;
		const QName_t LN_number_position = 3006;
		const QName_t LN_id = 3013;
		const QName_t LN_offset = 3016;
		const QName_t LN_insertion = 3026;
		const QName_t LN_count_empty_lines = 3033;
		const QName_t LN_deletion = 3035;
		const QName_t LN_format_change = 3051;
		const QName_t LN_count_in_text_boxes = 3053;
		const QName_t LN_change = 3062;
		const QName_t LN_restart_on_page = 3069;
		const QName_t LN_change_start = 3077;
		const QName_t LN_change_end = 3090;
		const QName_t LN_linenumbering_separator = 3092;
		const QName_t LN_change_id = 3100;
		const QName_t LN_notes_configuration = 3108;
		const QName_t LN_variable_decls = 3115;
		const QName_t LN_citation_style_name = 3124;
		const QName_t LN_sequence_decls = 3127;
		const QName_t LN_user_field_decls = 3141;
		const QName_t LN_citation_body_style_name = 3143;
		const QName_t LN_dde_connection_decls = 3157;
		const QName_t LN_default_style_name = 3158;
		const QName_t LN_s = 3163;
		const QName_t LN_c = 3170;
		const QName_t LN_start_numbering_at = 3178;
		const QName_t LN_tab = 3179;
		const QName_t LN_tab_ref = 3189;
		const QName_t LN_footnotes_position = 3193;
		const QName_t LN_line_break = 3201;
		const QName_t LN_span = 3212;
		const QName_t LN_a = 3215;
		const QName_t LN_note_continuation_notice_forward = 3218;
		const QName_t LN_visited_style_name = 3230;
		const QName_t LN_note_continuation_notice_backward = 3235;
		const QName_t LN_bookmark = 3239;
		const QName_t LN_bookmark_start = 3254;
		const QName_t LN_bibliography_configuration = 3257;
		const QName_t LN_bookmark_end = 3267;
		const QName_t LN_prefix = 3270;
		const QName_t LN_suffix = 3278;
		const QName_t LN_reference_mark = 3281;
		const QName_t LN_numbered_entries = 3292;
		const QName_t LN_reference_mark_start = 3297;
		const QName_t LN_sort_by_position = 3309;
		const QName_t LN_reference_mark_end = 3313;
		const QName_t LN_sort_key = 3316;
		const QName_t LN_note = 3322;
		const QName_t LN_key = 3324;
		const QName_t LN_note_citation = 3333;
		const QName_t LN_sort_ascending = 3334;
		const QName_t LN_label = 3342;
		const QName_t LN_list_style = 3348;
		const QName_t LN_note_body = 3352;
		const QName_t LN_note_class = 3364;
		const QName_t LN_consecutive_numbering = 3367;
		const QName_t LN_ruby = 3372;
		const QName_t LN_ruby_base = 3385;
		const QName_t LN_list_level_style_number = 3387;
		const QName_t LN_ruby_text = 3397;
		const QName_t LN_date = 3402;
		const QName_t LN_display_levels = 3403;
		const QName_t LN_date_value = 3414;
		const QName_t LN_list_level_style_bullet = 3422;
		const QName_t LN_date_adjust = 3427;
		const QName_t LN_time = 3432;
		const QName_t LN_bullet_char = 3434;
		const QName_t LN_time_value = 3445;
		const QName_t LN_bullet_relative_size = 3452;
		const QName_t LN_time_adjust = 3457;
		const QName_t LN_page_number = 3471;
		const QName_t LN_list_level_style_image = 3472;
		const QName_t LN_page_adjust = 3479;
		const QName_t LN_outline_style = 3483;
		const QName_t LN_select_page = 3491;
		const QName_t LN_outline_level_style = 3500;
		const QName_t LN_page_continuation = 3507;
		const QName_t LN_string_value = 3519;
		const QName_t LN_sender_firstname = 3536;
		const QName_t LN_sender_lastname = 3554;
		const QName_t LN_sender_initials = 3574;
		const QName_t LN_sender_title = 3587;
		const QName_t LN_sender_position = 3601;
		const QName_t LN_sender_email = 3615;
		const QName_t LN_sender_phone_private = 3631;
		const QName_t LN_sender_fax = 3646;
		const QName_t LN_sender_company = 3659;
		const QName_t LN_sender_phone_work = 3675;
		const QName_t LN_sender_street = 3689;
		const QName_t LN_sender_city = 3704;
		const QName_t LN_sender_postal_code = 3722;
		const QName_t LN_sender_country = 3735;
		const QName_t LN_sender_state_or_province = 3753;
		const QName_t LN_author_name = 3765;
		const QName_t LN_author_initials = 3782;
		const QName_t LN_chapter = 3794;
		const QName_t LN_file_name = 3805;
		const QName_t LN_template_name = 3817;
		const QName_t LN_sheet_name = 3829;
		const QName_t LN_variable_decl = 3841;
		const QName_t LN_variable_set = 3853;
		const QName_t LN_variable_get = 3865;
		const QName_t LN_variable_input = 3881;
		const QName_t LN_user_field_decl = 3895;
		const QName_t LN_user_field_get = 3911;
		const QName_t LN_user_field_input = 3922;
		const QName_t LN_sequence_decl = 3937;
		const QName_t LN_display_outline_level = 3951;
		const QName_t LN_separation_character = 3964;
		const QName_t LN_sequence = 3974;
		const QName_t LN_ref_name = 3985;
		const QName_t LN_expression = 3995;
		const QName_t LN_text_input = 4007;
		const QName_t LN_initial_creator = 4011;
		const QName_t LN_creation_date = 4018;
		const QName_t LN_creation_time = 4030;
		const QName_t LN_description = 4033;
		const QName_t LN_user_defined = 4040;
		const QName_t LN_print_time = 4082;
		const QName_t LN_print_date = 4086;
		const QName_t LN_printed_by = 4094;
		const QName_t LN_title = 4098;
		const QName_t LN_subject = 4106;
		const QName_t LN_keywords = 4118;
		const QName_t LN_editing_cycles = 4125;
		const QName_t LN_editing_duration = 4129;
		const QName_t LN_duration = 4140;
		const QName_t LN_modification_time = 4152;
		const QName_t LN_modification_date = 4167;
		const QName_t LN_creator = 4171;
		const QName_t LN_database_name = 4189;
		const QName_t LN_table_name = 4199;
		const QName_t LN_table_type = 4210;
		const QName_t LN_database_display = 4225;
		const QName_t LN_column_name = 4235;
		const QName_t LN_database_next = 4248;
		const QName_t LN_database_row_select = 4264;
		const QName_t LN_row_number = 4276;
		const QName_t LN_database_row_number = 4294;
		const QName_t LN_value = 4298;
		const QName_t LN_page_variable_set = 4314;
		const QName_t LN_active = 4321;
		const QName_t LN_page_variable_get = 4337;
		const QName_t LN_placeholder = 4347;
		const QName_t LN_placeholder_type = 4365;
		const QName_t LN_conditional_text = 4380;
		const QName_t LN_string_value_if_true = 4396;
		const QName_t LN_string_value_if_false = 4413;
		const QName_t LN_current_value = 4427;
		const QName_t LN_hidden_text = 4438;
		const QName_t LN_is_hidden = 4449;
		const QName_t LN_note_ref = 4461;
		const QName_t LN_sequence_ref = 4475;
		const QName_t LN_reference_format = 4484;
		const QName_t LN_script = 4491;
		const QName_t LN_execute_macro = 4505;
		const QName_t LN_hidden_paragraph = 4520;
		const QName_t LN_dde_connection = 4531;
		const QName_t LN_connection_name = 4542;
		const QName_t LN_measure = 4552;
		const QName_t LN_kind = 4561;
		const QName_t LN_table_formula = 4571;
		const QName_t LN_fixed = 4592;
		const QName_t LN_formula = 4602;
		const QName_t LN_toc_mark_start = 4633;
		const QName_t LN_toc_mark_end = 4647;
		const QName_t LN_toc_mark = 4659;
		const QName_t LN_user_index_mark_start = 4676;
		const QName_t LN_line_number = 4688;
		const QName_t LN_user_index_mark_end = 4695;
		const QName_t LN_user_index_mark = 4709;
		const QName_t LN_index_name = 4721;
		const QName_t LN_alphabetical_index_mark_start = 4746;
		const QName_t LN_alphabetical_index_mark_end = 4767;
		const QName_t LN_alphabetical_index_mark = 4782;
		const QName_t LN_key1 = 4791;
		const QName_t LN_key2 = 4797;
		const QName_t LN_string_value_phonetic = 4812;
		const QName_t LN_key1_phonetic = 4825;
		const QName_t LN_key2_phonetic = 4838;
		const QName_t LN_main_entry = 4848;
		const QName_t LN_bibliography_mark = 4862;
		const QName_t LN_bibliography_type = 4878;
		const QName_t LN_index_body = 4888;
		const QName_t LN_index_title = 4899;
		const QName_t LN_table_of_content = 4912;
		const QName_t LN_table_of_content_source = 4929;
		const QName_t LN_use_outline_level = 4943;
		const QName_t LN_use_index_marks = 4957;
		const QName_t LN_dont_balance_text_columns = 4968;
		const QName_t LN_use_index_source_styles = 4971;
		const QName_t LN_index_scope = 4980;
		const QName_t LN_relative_tab_stop_position = 4995;
		const QName_t LN_table_of_content_entry_template = 5015;
		const QName_t LN_illustration_index = 5030;
		const QName_t LN_illustration_index_source = 5048;
		const QName_t LN_use_caption = 5057;
		const QName_t LN_caption_sequence_name = 5076;
		const QName_t LN_caption_sequence_format = 5095;
		const QName_t LN_illustration_index_entry_template = 5122;
		const QName_t LN_table_index = 5130;
		const QName_t LN_table_index_source = 5143;
		const QName_t LN_table_index_entry_template = 5163;
		const QName_t LN_object_index = 5178;
		const QName_t LN_space_before = 5354;
		const QName_t LN_min_label_width = 5367;
		const QName_t LN_min_label_distance = 5383;
		const QName_t LN_animation = 5796;
		const QName_t LN_animation_direction = 5813;
		const QName_t LN_animation_start_inside = 5828;
		const QName_t LN_animation_stop_inside = 5842;
		const QName_t LN_animation_repeat = 5857;
		const QName_t LN_animation_delay = 5870;
		const QName_t LN_animation_steps = 5885;
		const QName_t LN_anchor_type = 6458;
		const QName_t LN_anchor_page_number = 6473;
	}
	namespace NS_tbl12 { /* http://schemas.microsoft.com/office/excel/2005/8/table */
		const QName_t LN_table = 3054;
		const QName_t LN_autofilter = 3058;
		const QName_t LN_sortState = 3065;
		const QName_t LN_cols = 3071;
		const QName_t LN_tableStyle = 3076;
		const QName_t LN_fsb = 3079;
		const QName_t LN_col = 3087;
		const QName_t LN_ccFmla = 3097;
		const QName_t LN_trFmla = 3105;
		const QName_t LN_xmlCPr = 3116;
	}
	namespace NS_pr { /* urn:oasis:names:tc:opendocument:xmlns:presentation:1.0 */
		const QName_t LN_transition_type = 693;
		const QName_t LN_transition_style = 707;
		const QName_t LN_transition_speed = 721;
		const QName_t LN_duration = 723;
		const QName_t LN_visibility = 728;
		const QName_t LN_background_objects_visible = 760;
		const QName_t LN_background_visible = 774;
		const QName_t LN_display_header = 786;
		const QName_t LN_display_footer = 799;
		const QName_t LN_display_page_number = 813;
		const QName_t LN_display_date_time = 825;
		const QName_t LN_class = 927;
		const QName_t LN_placeholder = 930;
		const QName_t LN_user_transformed = 943;
		const QName_t LN_animations = 951;
		const QName_t LN_sound = 958;
		const QName_t LN_play_full = 966;
		const QName_t LN_show_shape = 973;
		const QName_t LN_notes = 1623;
		const QName_t LN_object = 3912;
		const QName_t LN_presentation_page_layout_name = 5821;
		const QName_t LN_use_header_name = 5893;
		const QName_t LN_effect = 5894;
		const QName_t LN_direction = 5898;
		const QName_t LN_speed = 5905;
		const QName_t LN_use_footer_name = 5908;
		const QName_t LN_delay = 5911;
		const QName_t LN_start_scale = 5922;
		const QName_t LN_use_date_time_name = 5923;
		const QName_t LN_path_id = 5933;
		const QName_t LN_show_text = 5944;
		const QName_t LN_hide_shape = 5954;
		const QName_t LN_hide_text = 5967;
		const QName_t LN_dim = 5972;
		const QName_t LN_play = 5993;
		const QName_t LN_animation_group = 6010;
		const QName_t LN_node_type = 6022;
		const QName_t LN_preset_id = 6030;
		const QName_t LN_preset_sub_type = 6046;
		const QName_t LN_preset_class = 6059;
		const QName_t LN_master_element = 6072;
		const QName_t LN_group_id = 6085;
		const QName_t LN_event_listener = 6102;
		const QName_t LN_action = 6122;
		const QName_t LN_verb = 6128;
		const QName_t LN_header = 6137;
		const QName_t LN_footer = 6147;
		const QName_t LN_date_time = 6160;
		const QName_t LN_header_decl = 6172;
		const QName_t LN_name = 6176;
		const QName_t LN_footer_decl = 6188;
		const QName_t LN_date_time_decl = 6203;
		const QName_t LN_source = 6213;
		const QName_t LN_settings = 6220;
		const QName_t LN_start_page = 6230;
		const QName_t LN_show = 6236;
		const QName_t LN_full_screen = 6248;
		const QName_t LN_endless = 6261;
		const QName_t LN_pause = 6270;
		const QName_t LN_show_logo = 6281;
		const QName_t LN_force_manual = 6294;
		const QName_t LN_mouse_visible = 6309;
		const QName_t LN_mouse_as_pen = 6323;
		const QName_t LN_start_with_navigator = 6341;
		const QName_t LN_transition_on_click = 6355;
		const QName_t LN_stay_on_top = 6369;
		const QName_t LN_pages = 6376;
		const QName_t LN_style_name = 6391;
		const QName_t LN_class_names = 6395;
	}
	namespace NS_udcxf11 { /* http://schemas.microsoft.com/data/udc/xmlfile */
		const QName_t LN_File = 836;
	}
	namespace NS_office { /* urn:oasis:names:tc:opendocument:xmlns:office:1.0 */
		const QName_t LN_annotation = 748;
		const QName_t LN_display = 752;
		const QName_t LN_change_info = 816;
		const QName_t LN_event_listeners = 826;
		const QName_t LN_dde_application = 879;
		const QName_t LN_dde_topic = 887;
		const QName_t LN_dde_item = 894;
		const QName_t LN_automatic_update = 907;
		const QName_t LN_dde_source = 923;
		const QName_t LN_conversion_mode = 935;
		const QName_t LN_process_content = 1693;
		const QName_t LN_document = 1741;
		const QName_t LN_document_content = 1753;
		const QName_t LN_document_styles = 1766;
		const QName_t LN_document_meta = 1782;
		const QName_t LN_document_settings = 1798;
		const QName_t LN_version = 1820;
		const QName_t LN_mimetype = 1831;
		const QName_t LN_meta = 1842;
		const QName_t LN_body = 1862;
		const QName_t LN_text = 1871;
		const QName_t LN_drawing = 1901;
		const QName_t LN_presentation = 1918;
		const QName_t LN_spreadsheet = 1929;
		const QName_t LN_chart = 1936;
		const QName_t LN_image = 1942;
		const QName_t LN_settings = 1952;
		const QName_t LN_scripts = 2088;
		const QName_t LN_script = 2099;
		const QName_t LN_font_face_decls = 2137;
		const QName_t LN_styles = 2148;
		const QName_t LN_automatic_styles = 2176;
		const QName_t LN_master_styles = 2191;
		const QName_t LN_target_frame_name = 2385;
		const QName_t LN_name = 3219;
		const QName_t LN_value = 4043;
		const QName_t LN_date_value = 4047;
		const QName_t LN_time_value = 4054;
		const QName_t LN_boolean_value = 4067;
		const QName_t LN_string_value = 4070;
		const QName_t LN_value_type = 4578;
		const QName_t LN_currency = 4585;
		const QName_t LN_binary_data = 6601;
		const QName_t LN_forms = 6724;
		const QName_t LN_target_frame = 6771;
		const QName_t LN_server_map = 6788;
	}
	namespace NS_md12 { /* http://schemas.microsoft.com/office/excel/2005/8/metadata */
		const QName_t LN_Metadata = 93;
		const QName_t LN_metadataTypes = 102;
		const QName_t LN_cellMetadata = 111;
		const QName_t LN_valueMetadata = 120;
		const QName_t LN_mdxMetadata = 128;
		const QName_t LN_strMetadata = 136;
		const QName_t LN_futureMetadata = 146;
		const QName_t LN_fsb = 151;
		const QName_t LN_metadataType = 161;
		const QName_t LN_b = 165;
		const QName_t LN_r = 168;
		const QName_t LN_t = 173;
		const QName_t LN_s = 176;
		const QName_t LN_p = 180;
		const QName_t LN_k = 186;
		const QName_t LN_i = 189;
		const QName_t LN_ib = 196;
	}
	namespace NS_pp12 { /* http://schemas.microsoft.com/office/powerpoint/2005/8/pml */
		const QName_t LN_snd = 1217;
		const QName_t LN_stSnd = 1226;
		const QName_t LN_endSnd = 1235;
		const QName_t LN_blinds = 1241;
		const QName_t LN_checker = 1250;
		const QName_t LN_circle = 1254;
		const QName_t LN_dissolve = 1263;
		const QName_t LN_comb = 1272;
		const QName_t LN_cover = 1280;
		const QName_t LN_cut = 1285;
		const QName_t LN_diamond = 1294;
		const QName_t LN_fade = 1301;
		const QName_t LN_newsflash = 1310;
		const QName_t LN_plus = 1318;
		const QName_t LN_pull = 1328;
		const QName_t LN_push = 1334;
		const QName_t LN_random = 1344;
		const QName_t LN_randomBar = 1352;
		const QName_t LN_split = 1360;
		const QName_t LN_strips = 1369;
		const QName_t LN_wedge = 1377;
		const QName_t LN_wheel = 1383;
		const QName_t LN_wipe = 1392;
		const QName_t LN_zoom = 1400;
		const QName_t LN_sndAc = 1408;
		const QName_t LN_sldRef = 1420;
		const QName_t LN_ssJumpAc = 1429;
		const QName_t LN_sldJumpAc = 1437;
		const QName_t LN_urlAc = 1449;
		const QName_t LN_fileAc = 1456;
		const QName_t LN_presAc = 1465;
		const QName_t LN_tooltip = 1475;
		const QName_t LN_custShow = 1485;
		const QName_t LN_programAc = 1495;
		const QName_t LN_macroAc = 1504;
		const QName_t LN_hlinkAc = 1512;
		const QName_t LN_oleVerbAc = 1522;
		const QName_t LN_mediaAc = 1531;
		const QName_t LN_custShowAc = 1543;
		const QName_t LN_onClick = 1553;
		const QName_t LN_onMouseOver = 1564;
		const QName_t LN_seconds = 1570;
		const QName_t LN_percent = 1581;
		const QName_t LN_chRg = 1586;
		const QName_t LN_pRg = 1595;
		const QName_t LN_bg = 1603;
		const QName_t LN_subSp = 1609;
		const QName_t LN_oleChartEl = 1620;
		const QName_t LN_tx = 1629;
		const QName_t LN_e2o = 1635;
		const QName_t LN_sldTgt = 1645;
		const QName_t LN_sndTgt = 1654;
		const QName_t LN_spTgt = 1663;
		const QName_t LN_tgtEl = 1671;
		const QName_t LN_tn = 1678;
		const QName_t LN_rtn = 1683;
		const QName_t LN_cond = 1691;
		const QName_t LN_par = 1698;
		const QName_t LN_seq = 1704;
		const QName_t LN_excl = 1711;
		const QName_t LN_animate = 1715;
		const QName_t LN_animateColor = 1722;
		const QName_t LN_animateEffect = 1735;
		const QName_t LN_animateMotion = 1742;
		const QName_t LN_animateRotation = 1752;
		const QName_t LN_animateScale = 1764;
		const QName_t LN_command = 1770;
		const QName_t LN_set = 1775;
		const QName_t LN_audio = 1780;
		const QName_t LN_video = 1789;
		const QName_t LN_beginCondLst = 1803;
		const QName_t LN_endCondLst = 1815;
		const QName_t LN_endSync = 1827;
		const QName_t LN_iterate = 1833;
		const QName_t LN_childLst = 1845;
		const QName_t LN_subLst = 1853;
		const QName_t LN_timeNodeBase = 1869;
		const QName_t LN_prevCondLst = 1882;
		const QName_t LN_nextCondLst = 1895;
		const QName_t LN_attrName = 1992;
		const QName_t LN_attrNameLst = 2007;
		const QName_t LN_boolVal = 2018;
		const QName_t LN_intVal = 2031;
		const QName_t LN_fltVal = 2037;
		const QName_t LN_strVal = 2049;
		const QName_t LN_val = 2056;
		const QName_t LN_tav = 2063;
		const QName_t LN_behaviorBase = 2078;
		const QName_t LN_tavLst = 2087;
		const QName_t LN_rgb = 2095;
		const QName_t LN_hsl = 2100;
		const QName_t LN_by = 2106;
		const QName_t LN_from = 2112;
		const QName_t LN_to = 2118;
		const QName_t LN_progress = 2128;
		const QName_t LN_rCenter = 2140;
		const QName_t LN_mediaNodeBase = 2156;
		const QName_t LN_timeNodeLst = 2169;
		const QName_t LN_tmpl = 2175;
		const QName_t LN_tmplLst = 2185;
		const QName_t LN_bldAsOne = 2195;
		const QName_t LN_bldSub = 2205;
		const QName_t LN_bldP = 2211;
		const QName_t LN_bldDgm = 2220;
		const QName_t LN_bldOleChart = 2230;
		const QName_t LN_bldE2o = 2239;
		const QName_t LN_buildLst = 2248;
		const QName_t LN_sld = 2283;
		const QName_t LN_all = 2287;
		const QName_t LN_range = 2295;
		const QName_t LN_custData = 2306;
		const QName_t LN_commentAuthor = 2346;
		const QName_t LN_pos = 2351;
		const QName_t LN_text = 2355;
		const QName_t LN_cm = 2362;
		const QName_t LN_embed = 2434;
		const QName_t LN_link = 2439;
		const QName_t LN_sldId = 2479;
		const QName_t LN_sldMasterId = 2489;
		const QName_t LN_notesMasterId = 2504;
		const QName_t LN_handoutMasterId = 2517;
		const QName_t LN_sldLst = 2525;
		const QName_t LN_sldMasterIdLst = 2542;
		const QName_t LN_sldIdLst = 2549;
		const QName_t LN_notesMasterIdLst = 2562;
		const QName_t LN_handoutMasterIdLst = 2575;
		const QName_t LN_slideSize = 2588;
		const QName_t LN_notesSize = 2600;
		const QName_t LN_custShowLst = 2610;
		const QName_t LN_photoAlbum = 2623;
		const QName_t LN_commentAuthorLst = 2636;
		const QName_t LN_custDataLst = 2648;
		const QName_t LN_creatingAppVersion = 2664;
		const QName_t LN_editingAppVersion = 2679;
		const QName_t LN_presentation = 2687;
		const QName_t LN_pubWhat = 2729;
		const QName_t LN_pubAs = 2738;
		const QName_t LN_present = 2747;
		const QName_t LN_browse = 2755;
		const QName_t LN_kiosk = 2763;
		const QName_t LN_showType = 2774;
		const QName_t LN_showWhat = 2783;
		const QName_t LN_penClr = 2792;
		const QName_t LN_htmlPubPr = 2805;
		const QName_t LN_webPr = 2812;
		const QName_t LN_prnPr = 2821;
		const QName_t LN_showPr = 2831;
		const QName_t LN_presentationPr = 2843;
		const QName_t LN_str = 2884;
		const QName_t LN_bin = 2891;
		const QName_t LN_tag = 2897;
		const QName_t LN_ph = 2934;
		const QName_t LN_media = 2941;
		const QName_t LN_actions = 2950;
		const QName_t LN_anvPr = 2953;
		const QName_t LN_anvSpPr = 2961;
		const QName_t LN_pnvPr = 2970;
		const QName_t LN_nvSpPr = 2977;
		const QName_t LN_spPr = 2983;
		const QName_t LN_style = 2988;
		const QName_t LN_txBody = 2994;
		const QName_t LN_anvCxnSpPr = 3000;
		const QName_t LN_nvCxnSpPr = 3005;
		const QName_t LN_anvGraphicFramePr = 3012;
		const QName_t LN_nvGraphicFramePr = 3019;
		const QName_t LN_xfrm = 3023;
		const QName_t LN_graphic = 3030;
		const QName_t LN_anvGspPr = 3032;
		const QName_t LN_nvGspPr = 3039;
		const QName_t LN_gspPr = 3045;
		const QName_t LN_sp = 3048;
		const QName_t LN_gsp = 3055;
		const QName_t LN_graphicFrame = 3060;
		const QName_t LN_cxnsp = 3066;
		const QName_t LN_clrMap = 3072;
		const QName_t LN_clrMapOvr = 3082;
		const QName_t LN_fill = 3089;
		const QName_t LN_bgPr = 3098;
		const QName_t LN_bgLink = 3106;
		const QName_t LN_bgMaster = 3117;
		const QName_t LN_spTree = 3125;
		const QName_t LN_tagLst = 3134;
		const QName_t LN_sldBase = 3142;
		const QName_t LN_cmLst = 3149;
		const QName_t LN_transition = 3162;
		const QName_t LN_timingInfo = 3173;
		const QName_t LN_hf = 3181;
		const QName_t LN_sldLayout = 3192;
		const QName_t LN_defLink = 3204;
		const QName_t LN_outline1Link = 3216;
		const QName_t LN_outline2Link = 3225;
		const QName_t LN_lvl1Link = 3233;
		const QName_t LN_lvl2Link = 3244;
		const QName_t LN_lvl3Link = 3249;
		const QName_t LN_lvl4Link = 3259;
		const QName_t LN_lvl5Link = 3273;
		const QName_t LN_lvl6Link = 3284;
		const QName_t LN_lvl7Link = 3294;
		const QName_t LN_lvl8Link = 3304;
		const QName_t LN_lvl9Link = 3312;
		const QName_t LN_txLstStyle = 3318;
		const QName_t LN_themeLinkLst = 3328;
		const QName_t LN_titleStyle = 3340;
		const QName_t LN_bodyStyle = 3350;
		const QName_t LN_notesStyle = 3362;
		const QName_t LN_otherStyle = 3377;
		const QName_t LN_sldLayoutId = 3389;
		const QName_t LN_sldLayoutIdLst = 3406;
		const QName_t LN_txStyles = 3416;
		const QName_t LN_sldMaster = 3426;
		const QName_t LN_handoutMaster = 3439;
		const QName_t LN_notesMaster = 3449;
		const QName_t LN_notes = 3455;
		const QName_t LN_restoredLeft = 3537;
		const QName_t LN_restoredTop = 3550;
		const QName_t LN_scale = 3564;
		const QName_t LN_origin = 3570;
		const QName_t LN_viewPrBase = 3583;
		const QName_t LN_guide = 3590;
		const QName_t LN_guideLst = 3602;
		const QName_t LN_sldViewPrBase = 3616;
		const QName_t LN_normalViewPr = 3629;
		const QName_t LN_slideViewPr = 3639;
		const QName_t LN_outlineViewPr = 3653;
		const QName_t LN_notesTextViewPr = 3669;
		const QName_t LN_sorterViewPr = 3684;
		const QName_t LN_notesViewPr = 3697;
		const QName_t LN_gridSpacing = 3710;
		const QName_t LN_viewPr = 3720;
	}
	namespace NS_v11 { /* http://schemas.microsoft.com/visio/2003/core */
		const QName_t LN_VisioDocument = 316;
		const QName_t LN_SolutionXML = 328;
		const QName_t LN_cp = 332;
		const QName_t LN_pp = 338;
		const QName_t LN_tp = 343;
		const QName_t LN_fld = 348;
		const QName_t LN_XProp = 357;
		const QName_t LN_Text = 362;
		const QName_t LN_XForm = 369;
		const QName_t LN_Line = 377;
		const QName_t LN_Fill = 384;
		const QName_t LN_XForm1D = 394;
		const QName_t LN_Event = 402;
		const QName_t LN_LayerMem = 408;
		const QName_t LN_StyleProp = 419;
		const QName_t LN_Foreign = 427;
		const QName_t LN_PageProps = 437;
		const QName_t LN_TextBlock = 446;
		const QName_t LN_TextXForm = 457;
		const QName_t LN_Align = 464;
		const QName_t LN_Protection = 476;
		const QName_t LN_Help = 482;
		const QName_t LN_Misc = 490;
		const QName_t LN_RulerGrid = 497;
		const QName_t LN_DocProps = 506;
		const QName_t LN_Image = 515;
		const QName_t LN_Group = 522;
		const QName_t LN_Layout = 530;
		const QName_t LN_PageLayout = 541;
		const QName_t LN_PrintProps = 550;
		const QName_t LN_Char = 557;
		const QName_t LN_Para = 564;
		const QName_t LN_Tabs = 570;
		const QName_t LN_Scratch = 582;
		const QName_t LN_Connection = 586;
		const QName_t LN_ConnectionABCD = 599;
		const QName_t LN_Field = 607;
		const QName_t LN_Control = 616;
		const QName_t LN_Geom = 623;
		const QName_t LN_Act = 631;
		const QName_t LN_Layer = 637;
		const QName_t LN_User = 645;
		const QName_t LN_Prop = 651;
		const QName_t LN_Hyperlink = 661;
		const QName_t LN_Reviewer = 671;
		const QName_t LN_Annotation = 680;
		const QName_t LN_SmartTagDef = 691;
		const QName_t LN_Data1 = 700;
		const QName_t LN_Data2 = 708;
		const QName_t LN_Data3 = 714;
		const QName_t LN_ForeignData = 724;
		const QName_t LN_PinX = 732;
		const QName_t LN_PinY = 738;
		const QName_t LN_Width = 746;
		const QName_t LN_Height = 756;
		const QName_t LN_LocPinX = 764;
		const QName_t LN_LocPinY = 770;
		const QName_t LN_Angle = 779;
		const QName_t LN_FlipX = 784;
		const QName_t LN_FlipY = 794;
		const QName_t LN_ResizeMode = 804;
		const QName_t LN_LineWeight = 814;
		const QName_t LN_LineColor = 822;
		const QName_t LN_LinePattern = 832;
		const QName_t LN_Rounding = 840;
		const QName_t LN_EndArrowSize = 849;
		const QName_t LN_BeginArrow = 859;
		const QName_t LN_EndArrow = 867;
		const QName_t LN_LineCap = 873;
		const QName_t LN_BeginArrowSize = 885;
		const QName_t LN_LineColorTrans = 897;
		const QName_t LN_FillForegnd = 904;
		const QName_t LN_FillBkgnd = 912;
		const QName_t LN_FillPattern = 924;
		const QName_t LN_ShdwForegnd = 933;
		const QName_t LN_ShdwBkgnd = 940;
		const QName_t LN_ShdwPattern = 950;
		const QName_t LN_FillForegndTrans = 961;
		const QName_t LN_FillBkgndTrans = 970;
		const QName_t LN_ShdwForegndTrans = 982;
		const QName_t LN_ShdwBkgndTrans = 991;
		const QName_t LN_ShapeShdwType = 1001;
		const QName_t LN_ShapeShdwOffsetX = 1008;
		const QName_t LN_ShapeShdwOffsetY = 1015;
		const QName_t LN_ShapeShdwObliqueAngle = 1025;
		const QName_t LN_ShapeShdwScaleFactor = 1036;
		const QName_t LN_BeginX = 1043;
		const QName_t LN_BeginY = 1049;
		const QName_t LN_EndX = 1055;
		const QName_t LN_EndY = 1060;
		const QName_t LN_TheData = 1070;
		const QName_t LN_TheText = 1078;
		const QName_t LN_EventDblClick = 1088;
		const QName_t LN_EventXFMod = 1095;
		const QName_t LN_EventDrop = 1102;
		const QName_t LN_LayerMember = 1108;
		const QName_t LN_EnableLineProps = 1118;
		const QName_t LN_EnableFillProps = 1130;
		const QName_t LN_EnableTextProps = 1142;
		const QName_t LN_HideForApply = 1152;
		const QName_t LN_ImgOffsetX = 1161;
		const QName_t LN_ImgOffsetY = 1169;
		const QName_t LN_ImgWidth = 1177;
		const QName_t LN_ImgHeight = 1188;
		const QName_t LN_PageWidth = 1195;
		const QName_t LN_PageHeight = 1203;
		const QName_t LN_ShdwOffsetX = 1211;
		const QName_t LN_ShdwOffsetY = 1224;
		const QName_t LN_PageScale = 1231;
		const QName_t LN_DrawingScale = 1245;
		const QName_t LN_DrawingSizeType = 1259;
		const QName_t LN_DrawingScaleType = 1271;
		const QName_t LN_InhibitSnap = 1282;
		const QName_t LN_UIVisibility = 1293;
		const QName_t LN_ShdwType = 1304;
		const QName_t LN_ShdwObliqueAngle = 1317;
		const QName_t LN_ShdwScaleFactor = 1331;
		const QName_t LN_LeftMargin = 1343;
		const QName_t LN_RightMargin = 1354;
		const QName_t LN_TopMargin = 1361;
		const QName_t LN_BottomMargin = 1372;
		const QName_t LN_VerticalAlign = 1387;
		const QName_t LN_TextBkgnd = 1398;
		const QName_t LN_DefaultTabStop = 1411;
		const QName_t LN_TextDirection = 1424;
		const QName_t LN_TextBkgndTrans = 1438;
		const QName_t LN_TxtPinX = 1450;
		const QName_t LN_TxtPinY = 1458;
		const QName_t LN_TxtWidth = 1468;
		const QName_t LN_TxtHeight = 1478;
		const QName_t LN_TxtLocPinX = 1489;
		const QName_t LN_TxtLocPinY = 1499;
		const QName_t LN_TxtAngle = 1509;
		const QName_t LN_AlignLeft = 1519;
		const QName_t LN_AlignCenter = 1530;
		const QName_t LN_AlignRight = 1542;
		const QName_t LN_AlignTop = 1554;
		const QName_t LN_AlignMiddle = 1565;
		const QName_t LN_AlignBottom = 1578;
		const QName_t LN_LockWidth = 1588;
		const QName_t LN_LockHeight = 1600;
		const QName_t LN_LockMoveX = 1610;
		const QName_t LN_LockMoveY = 1621;
		const QName_t LN_LockAspect = 1632;
		const QName_t LN_LockDelete = 1646;
		const QName_t LN_LockBegin = 1659;
		const QName_t LN_LockEnd = 1666;
		const QName_t LN_LockRotate = 1676;
		const QName_t LN_LockCrop = 1686;
		const QName_t LN_LockVtxEdit = 1699;
		const QName_t LN_LockTextEdit = 1714;
		const QName_t LN_LockFormat = 1727;
		const QName_t LN_LockGroup = 1737;
		const QName_t LN_LockCalcWH = 1748;
		const QName_t LN_LockSelect = 1759;
		const QName_t LN_LockCustProp = 1771;
		const QName_t LN_HelpTopic = 1783;
		const QName_t LN_Copyright = 1793;
		const QName_t LN_NoObjHandles = 1809;
		const QName_t LN_NonPrinting = 1821;
		const QName_t LN_NoCtlHandles = 1837;
		const QName_t LN_NoAlignBox = 1850;
		const QName_t LN_UpdateAlignBox = 1863;
		const QName_t LN_HideText = 1875;
		const QName_t LN_DynFeedback = 1888;
		const QName_t LN_GlueType = 1900;
		const QName_t LN_WalkPreference = 1913;
		const QName_t LN_BegTrigger = 1921;
		const QName_t LN_EndTrigger = 1932;
		const QName_t LN_ObjType = 1940;
		const QName_t LN_Comment = 1949;
		const QName_t LN_IsDropSource = 1959;
		const QName_t LN_NoLiveDynamics = 1971;
		const QName_t LN_LocalizeMerge = 1985;
		const QName_t LN_Calendar = 1999;
		const QName_t LN_LangID = 2010;
		const QName_t LN_ShapeKeywords = 2025;
		const QName_t LN_DropOnPageScale = 2039;
		const QName_t LN_XRulerDensity = 2054;
		const QName_t LN_YRulerDensity = 2068;
		const QName_t LN_XRulerOrigin = 2082;
		const QName_t LN_YRulerOrigin = 2097;
		const QName_t LN_XGridDensity = 2110;
		const QName_t LN_YGridDensity = 2123;
		const QName_t LN_XGridSpacing = 2139;
		const QName_t LN_YGridSpacing = 2152;
		const QName_t LN_XGridOrigin = 2166;
		const QName_t LN_YGridOrigin = 2180;
		const QName_t LN_OutputFormat = 2193;
		const QName_t LN_LockPreview = 2204;
		const QName_t LN_AddMarkup = 2215;
		const QName_t LN_ViewMarkup = 2224;
		const QName_t LN_PreviewQuality = 2234;
		const QName_t LN_PreviewScope = 2246;
		const QName_t LN_DocLangID = 2256;
		const QName_t LN_Gamma = 2264;
		const QName_t LN_Contrast = 2272;
		const QName_t LN_Brightness = 2281;
		const QName_t LN_Sharpen = 2289;
		const QName_t LN_Blur = 2298;
		const QName_t LN_Denoise = 2308;
		const QName_t LN_Transparency = 2318;
		const QName_t LN_SelectMode = 2327;
		const QName_t LN_DisplayMode = 2337;
		const QName_t LN_IsDropTarget = 2347;
		const QName_t LN_IsSnapTarget = 2361;
		const QName_t LN_IsTextEditTarget = 2374;
		const QName_t LN_DontMoveChildren = 2386;
		const QName_t LN_ShapePermeableX = 2397;
		const QName_t LN_ShapePermeableY = 2411;
		const QName_t LN_ShapePermeablePlace = 2425;
		const QName_t LN_ShapeFixedCode = 2436;
		const QName_t LN_ShapePlowCode = 2450;
		const QName_t LN_ShapeRouteStyle = 2464;
		const QName_t LN_ConFixedCode = 2475;
		const QName_t LN_ConLineJumpCode = 2487;
		const QName_t LN_ConLineJumpStyle = 2503;
		const QName_t LN_ConLineJumpDirX = 2516;
		const QName_t LN_ConLineJumpDirY = 2530;
		const QName_t LN_ShapePlaceFlip = 2544;
		const QName_t LN_ConLineRouteExt = 2557;
		const QName_t LN_ShapeSplit = 2567;
		const QName_t LN_ShapeSplittable = 2580;
		const QName_t LN_ResizePage = 2594;
		const QName_t LN_EnableGrid = 2603;
		const QName_t LN_DynamicsOff = 2616;
		const QName_t LN_CtrlAsInput = 2626;
		const QName_t LN_PlaceStyle = 2638;
		const QName_t LN_RouteStyle = 2650;
		const QName_t LN_PlaceDepth = 2660;
		const QName_t LN_PlowCode = 2671;
		const QName_t LN_LineJumpCode = 2686;
		const QName_t LN_LineJumpStyle = 2701;
		const QName_t LN_PageLineJumpDirX = 2714;
		const QName_t LN_PageLineJumpDirY = 2728;
		const QName_t LN_LineToNodeX = 2739;
		const QName_t LN_LineToNodeY = 2749;
		const QName_t LN_BlockSizeX = 2760;
		const QName_t LN_BlockSizeY = 2772;
		const QName_t LN_AvenueSizeX = 2784;
		const QName_t LN_AvenueSizeY = 2797;
		const QName_t LN_LineToLineX = 2809;
		const QName_t LN_LineToLineY = 2823;
		const QName_t LN_LineJumpFactorX = 2836;
		const QName_t LN_LineJumpFactorY = 2849;
		const QName_t LN_LineAdjustFrom = 2862;
		const QName_t LN_LineAdjustTo = 2874;
		const QName_t LN_PlaceFlip = 2886;
		const QName_t LN_LineRouteExt = 2896;
		const QName_t LN_PageShapeSplit = 2910;
		const QName_t LN_PageLeftMargin = 2922;
		const QName_t LN_PageRightMargin = 2935;
		const QName_t LN_PageTopMargin = 2946;
		const QName_t LN_PageBottomMargin = 2963;
		const QName_t LN_ScaleX = 2972;
		const QName_t LN_ScaleY = 2984;
		const QName_t LN_PagesX = 2995;
		const QName_t LN_PagesY = 3003;
		const QName_t LN_CenterX = 3017;
		const QName_t LN_CenterY = 3028;
		const QName_t LN_OnPage = 3038;
		const QName_t LN_PrintGrid = 3049;
		const QName_t LN_PrintPageOrientation = 3070;
		const QName_t LN_PaperKind = 3081;
		const QName_t LN_PaperSource = 3095;
		const QName_t LN_Font = 3103;
		const QName_t LN_Color = 3111;
		const QName_t LN_Style = 3122;
		const QName_t LN_Case = 3126;
		const QName_t LN_Pos = 3135;
		const QName_t LN_FontScale = 3144;
		const QName_t LN_Locale = 3152;
		const QName_t LN_Size = 3161;
		const QName_t LN_DblUnderline = 3172;
		const QName_t LN_Overline = 3185;
		const QName_t LN_Strikethru = 3197;
		const QName_t LN_Highlight = 3210;
		const QName_t LN_Perpendicular = 3220;
		const QName_t LN_DoubleStrikethrough = 3232;
		const QName_t LN_RTLText = 3242;
		const QName_t LN_UseVertical = 3251;
		const QName_t LN_Letterspace = 3265;
		const QName_t LN_ColorTrans = 3279;
		const QName_t LN_AsianFont = 3288;
		const QName_t LN_ComplexScriptFont = 3303;
		const QName_t LN_LocalizeFont = 3315;
		const QName_t LN_ComplexScriptSize = 3329;
		const QName_t LN_IndFirst = 3338;
		const QName_t LN_IndLeft = 3349;
		const QName_t LN_IndRight = 3358;
		const QName_t LN_SpLine = 3369;
		const QName_t LN_SpBefore = 3382;
		const QName_t LN_SpAfter = 3393;
		const QName_t LN_HorzAlign = 3404;
		const QName_t LN_Bullet = 3412;
		const QName_t LN_BulletStr = 3423;
		const QName_t LN_BulletFont = 3436;
		const QName_t LN_LocalizeBulletFont = 3451;
		const QName_t LN_BulletFontSize = 3464;
		const QName_t LN_TextPosAfterBullet = 3478;
		const QName_t LN_Flags = 3488;
		const QName_t LN_Tab = 3495;
		const QName_t LN_Position = 3504;
		const QName_t LN_Alignment = 3516;
		const QName_t LN_Leader = 3526;
		const QName_t LN_X = 3530;
		const QName_t LN_Y = 3540;
		const QName_t LN_A = 3545;
		const QName_t LN_B = 3553;
		const QName_t LN_C = 3559;
		const QName_t LN_D = 3569;
		const QName_t LN_DirX = 3577;
		const QName_t LN_DirY = 3588;
		const QName_t LN_Type = 3595;
		const QName_t LN_AutoGen = 3605;
		const QName_t LN_Prompt = 3614;
		const QName_t LN_Value = 3621;
		const QName_t LN_EditMode = 3633;
		const QName_t LN_Format = 3641;
		const QName_t LN_UICat = 3651;
		const QName_t LN_UICod = 3662;
		const QName_t LN_UIFmt = 3668;
		const QName_t LN_ObjectKind = 3683;
		const QName_t LN_XDyn = 3691;
		const QName_t LN_YDyn = 3699;
		const QName_t LN_XCon = 3709;
		const QName_t LN_YCon = 3718;
		const QName_t LN_CanGlue = 3729;
		const QName_t LN_NoFill = 3736;
		const QName_t LN_NoLine = 3744;
		const QName_t LN_NoShow = 3749;
		const QName_t LN_NoSnap = 3759;
		const QName_t LN_MoveTo = 3771;
		const QName_t LN_LineTo = 3781;
		const QName_t LN_ArcTo = 3791;
		const QName_t LN_InfiniteLine = 3806;
		const QName_t LN_Ellipse = 3813;
		const QName_t LN_EllipticalArcTo = 3828;
		const QName_t LN_SplineStart = 3840;
		const QName_t LN_SplineKnot = 3851;
		const QName_t LN_PolylineTo = 3863;
		const QName_t LN_NURBSTo = 3872;
		const QName_t LN_E = 3878;
		const QName_t LN_Menu = 3885;
		const QName_t LN_Action = 3896;
		const QName_t LN_Checked = 3902;
		const QName_t LN_Disabled = 3916;
		const QName_t LN_ReadOnly = 3924;
		const QName_t LN_Invisible = 3936;
		const QName_t LN_BeginGroup = 3945;
		const QName_t LN_TagName = 3953;
		const QName_t LN_ButtonFace = 3961;
		const QName_t LN_SortKey = 3968;
		const QName_t LN_Name = 3975;
		const QName_t LN_Status = 3982;
		const QName_t LN_Visible = 3993;
		const QName_t LN_Print = 4001;
		const QName_t LN_Active = 4009;
		const QName_t LN_Lock = 4020;
		const QName_t LN_Snap = 4025;
		const QName_t LN_Glue = 4031;
		const QName_t LN_NameUniv = 4042;
		const QName_t LN_Label = 4052;
		const QName_t LN_Verify = 4059;
		const QName_t LN_Description = 4066;
		const QName_t LN_Address = 4075;
		const QName_t LN_SubAddress = 4084;
		const QName_t LN_ExtraInfo = 4100;
		const QName_t LN_Frame = 4109;
		const QName_t LN_NewWindow = 4123;
		const QName_t LN_Default = 4127;
		const QName_t LN_Initials = 4138;
		const QName_t LN_ReviewerID = 4148;
		const QName_t LN_CurrentIndex = 4160;
		const QName_t LN_MarkerIndex = 4169;
		const QName_t LN_Date = 4179;
		const QName_t LN_XJustify = 4188;
		const QName_t LN_YJustify = 4196;
		const QName_t LN_Title = 4201;
		const QName_t LN_Subject = 4207;
		const QName_t LN_Creator = 4211;
		const QName_t LN_Manager = 4221;
		const QName_t LN_Company = 4229;
		const QName_t LN_Category = 4234;
		const QName_t LN_Keywords = 4238;
		const QName_t LN_Desc = 4245;
		const QName_t LN_HyperlinkBase = 4258;
		const QName_t LN_AlternateNames = 4273;
		const QName_t LN_Template = 4285;
		const QName_t LN_BuildNumberCreated = 4301;
		const QName_t LN_BuildNumberEdited = 4316;
		const QName_t LN_PreviewPicture = 4328;
		const QName_t LN_CustomProps = 4339;
		const QName_t LN_TimeCreated = 4351;
		const QName_t LN_TimeSaved = 4362;
		const QName_t LN_TimeEdited = 4375;
		const QName_t LN_TimePrinted = 4387;
		const QName_t LN_CustomProp = 4398;
		const QName_t LN_GlueSettings = 4409;
		const QName_t LN_SnapSettings = 4419;
		const QName_t LN_SnapExtensions = 4433;
		const QName_t LN_SnapAngles = 4445;
		const QName_t LN_DynamicGridEnabled = 4465;
		const QName_t LN_ProtectStyles = 4476;
		const QName_t LN_ProtectShapes = 4487;
		const QName_t LN_ProtectMasters = 4502;
		const QName_t LN_ProtectBkgnds = 4511;
		const QName_t LN_CustomMenusFile = 4527;
		const QName_t LN_CustomToolbarsFile = 4541;
		const QName_t LN_AttachedToolbars = 4557;
		const QName_t LN_SnapAngle = 4566;
		const QName_t LN_ColorEntry = 4579;
		const QName_t LN_PaperSize = 4587;
		const QName_t LN_PaperWidth = 4597;
		const QName_t LN_PaperHeight = 4610;
		const QName_t LN_PrintCenteredH = 4624;
		const QName_t LN_PrintCenteredV = 4642;
		const QName_t LN_PrintFitOnPages = 4656;
		const QName_t LN_PrintLandscape = 4671;
		const QName_t LN_PrintPagesAcross = 4686;
		const QName_t LN_PrintPagesDown = 4700;
		const QName_t LN_PrintScale = 4712;
		const QName_t LN_FontEntry = 4724;
		const QName_t LN_FaceName = 4736;
		const QName_t LN_StyleSheet = 4747;
		const QName_t LN_Master = 4754;
		const QName_t LN_MasterShortcut = 4769;
		const QName_t LN_PageSheet = 4778;
		const QName_t LN_Shapes = 4785;
		const QName_t LN_Icon = 4793;
		const QName_t LN_Connects = 4800;
		const QName_t LN_Shape = 4808;
		const QName_t LN_Connect = 4817;
		const QName_t LN_Page = 4824;
		const QName_t LN_Window = 4833;
		const QName_t LN_StencilGroup = 4846;
		const QName_t LN_StencilGroupPos = 4859;
		const QName_t LN_ShowRulers = 4869;
		const QName_t LN_ShowGrid = 4879;
		const QName_t LN_ShowPageBreaks = 4892;
		const QName_t LN_ShowGuides = 4900;
		const QName_t LN_ShowConnectionPoints = 4916;
		const QName_t LN_TabSplitterPos = 4927;
		const QName_t LN_EventItem = 4937;
		const QName_t LN_HeaderMargin = 4949;
		const QName_t LN_FooterMargin = 4961;
		const QName_t LN_HeaderLeft = 4969;
		const QName_t LN_HeaderCenter = 4978;
		const QName_t LN_HeaderRight = 4989;
		const QName_t LN_FooterLeft = 4996;
		const QName_t LN_FooterCenter = 5008;
		const QName_t LN_FooterRight = 5018;
		const QName_t LN_HeaderFooterFont = 5031;
		const QName_t LN_DocumentProperties = 5033;
		const QName_t LN_DocumentSettings = 5046;
		const QName_t LN_Colors = 5055;
		const QName_t LN_PrintSetup = 5065;
		const QName_t LN_Fonts = 5073;
		const QName_t LN_FaceNames = 5086;
		const QName_t LN_StyleSheets = 5099;
		const QName_t LN_DocumentSheet = 5112;
		const QName_t LN_Masters = 5120;
		const QName_t LN_Pages = 5127;
		const QName_t LN_Windows = 5133;
		const QName_t LN_EventList = 5144;
		const QName_t LN_HeaderFooter = 5157;
		const QName_t LN_VBProjectData = 5170;
		const QName_t LN_EmailRoutingData = 5184;
	}
	namespace NS_sst12 { /* http://schemas.microsoft.com/office/excel/2005/8/sst */
		const QName_t LN_Sst = 2338;
	}
	namespace NS_swb12 { /* http://schemas.microsoft.com/office/excel/2005/8/sharedworkbook */
		const QName_t LN_revisions = 1970;
		const QName_t LN_info = 1978;
		const QName_t LN_header = 1983;
		const QName_t LN_rwCol = 1993;
		const QName_t LN_move = 2005;
		const QName_t LN_userView = 2015;
		const QName_t LN_sheetName = 2027;
		const QName_t LN_sheet = 2035;
		const QName_t LN_cell = 2045;
		const QName_t LN_formatting = 2050;
		const QName_t LN_autofmt = 2059;
		const QName_t LN_name = 2064;
		const QName_t LN_comment = 2070;
		const QName_t LN_qtField = 2080;
		const QName_t LN_conflict = 2094;
		const QName_t LN_revdata = 2103;
		const QName_t LN_tabidMap = 2115;
		const QName_t LN_tabId = 2124;
		const QName_t LN_undoinfo = 2136;
		const QName_t LN_cellOld = 2147;
		const QName_t LN_cellNew = 2159;
		const QName_t LN_dxfOld = 2168;
		const QName_t LN_dxfNew = 2177;
		const QName_t LN_dxfFmt = 2186;
		const QName_t LN_formula = 2192;
		const QName_t LN_formulaOld = 2203;
	}
	namespace NS_pic12 { /* http://schemas.microsoft.com/office/officeart/2005/8/picture */
		const QName_t LN_spPr = 2396;
	}
	namespace NS_vml { /* urn:schemas-microsoft-com:vml */
		const QName_t LN_shape = 854;
		const QName_t LN_group = 860;
		const QName_t LN_shapetype = 869;
		const QName_t LN_VMLFrame = 877;
		const QName_t LN_background = 881;
		const QName_t LN_path = 882;
		const QName_t LN_formulas = 891;
		const QName_t LN_f = 896;
		const QName_t LN_handles = 901;
		const QName_t LN_h = 908;
		const QName_t LN_fill = 910;
		const QName_t LN_stroke = 914;
		const QName_t LN_shadow = 917;
		const QName_t LN_textbox = 926;
		const QName_t LN_textpath = 934;
		const QName_t LN_imagedata = 942;
		const QName_t LN_line = 946;
		const QName_t LN_Behavior = 953;
		const QName_t LN_Sequence = 960;
		const QName_t LN_Action = 965;
		const QName_t LN_arc = 968;
		const QName_t LN_curve = 974;
		const QName_t LN_polyline = 977;
		const QName_t LN_rect = 980;
		const QName_t LN_roundrect = 989;
		const QName_t LN_oval = 994;
		const QName_t LN_image = 998;
	}
	namespace NS_ax12 { /* http://schemas.microsoft.com/office/activeX/2005/ax */
		const QName_t LN_ocx = 1218;
		const QName_t LN_ocxPr = 1228;
		const QName_t LN_ocxMBed = 1238;
	}
	namespace NS_ws12 { /* http://schemas.microsoft.com/office/excel/2005/8/worksheet */
		const QName_t LN_workSheet = 1031;
		const QName_t LN_macroSheet = 1039;
		const QName_t LN_dialogSheet = 1047;
		const QName_t LN_chartSheet = 1057;
		const QName_t LN_wsPr = 1063;
		const QName_t LN_dimension = 1067;
		const QName_t LN_wsViews = 1076;
		const QName_t LN_userShViews = 1085;
		const QName_t LN_wsFmtInfo = 1092;
		const QName_t LN_colInfos = 1099;
		const QName_t LN_sheetData = 1105;
		const QName_t LN_calcChains = 1111;
		const QName_t LN_autofilter = 1115;
		const QName_t LN_sortState = 1123;
		const QName_t LN_rwBrks = 1132;
		const QName_t LN_colBrks = 1140;
		const QName_t LN_pageMargins = 1150;
		const QName_t LN_printOptions = 1158;
		const QName_t LN_pageSetup = 1165;
		const QName_t LN_headerFooter = 1176;
		const QName_t LN_drawing = 1181;
		const QName_t LN_fsb = 1186;
		const QName_t LN_phonetic = 1193;
		const QName_t LN_dataConsolidation = 1204;
		const QName_t LN_mergeCells = 1213;
		const QName_t LN_dVals = 1219;
		const QName_t LN_smartTags = 1229;
		const QName_t LN_hyperlinks = 1240;
		const QName_t LN_conditionalFormatting = 1257;
		const QName_t LN_legacyDrawing = 1269;
		const QName_t LN_scenarios = 1279;
		const QName_t LN_cellWatches = 1288;
		const QName_t LN_sheetProtection = 1305;
		const QName_t LN_protectedRanges = 1315;
		const QName_t LN_picture = 1320;
		const QName_t LN_webPubItems = 1332;
		const QName_t LN_row = 1338;
		const QName_t LN_chain = 1346;
		const QName_t LN_c = 1351;
		const QName_t LN_colInfo = 1357;
		const QName_t LN_f = 1362;
		const QName_t LN_v = 1367;
		const QName_t LN_rst = 1374;
		const QName_t LN_tabColor = 1384;
		const QName_t LN_wsView = 1393;
		const QName_t LN_pane = 1402;
		const QName_t LN_selection = 1413;
		const QName_t LN_brk = 1419;
		const QName_t LN_afdd = 1425;
		const QName_t LN_filter = 1430;
		const QName_t LN_DateGroupItem = 1443;
		const QName_t LN_criteria = 1454;
		const QName_t LN_criteriaColor = 1467;
		const QName_t LN_criteriaCellIcon = 1482;
		const QName_t LN_dataRefs = 1491;
		const QName_t LN_dataRef = 1498;
		const QName_t LN_mergeCell = 1510;
		const QName_t LN_cellSmartTags = 1521;
		const QName_t LN_cellSmartTag = 1534;
		const QName_t LN_cellSmartTagPr = 1550;
		const QName_t LN_userShView = 1559;
		const QName_t LN_dVal = 1568;
		const QName_t LN_formula1 = 1579;
		const QName_t LN_formula2 = 1589;
		const QName_t LN_cfRule = 1597;
		const QName_t LN_formula = 1604;
		const QName_t LN_colorScale = 1616;
		const QName_t LN_databar = 1624;
		const QName_t LN_iconset = 1633;
		const QName_t LN_hyperlink = 1640;
		const QName_t LN_cfvo = 1648;
		const QName_t LN_color = 1652;
		const QName_t LN_oddHeader = 1662;
		const QName_t LN_oddFooter = 1673;
		const QName_t LN_evenHeader = 1682;
		const QName_t LN_evenFooter = 1694;
		const QName_t LN_firstHeader = 1708;
		const QName_t LN_firstFooter = 1723;
		const QName_t LN_sortCondition = 1736;
		const QName_t LN_sct = 1743;
		const QName_t LN_rangeProtection = 1755;
		const QName_t LN_slc = 1762;
		const QName_t LN_cellWatch = 1773;
		const QName_t LN_t = 1778;
		const QName_t LN_r = 1784;
		const QName_t LN_rt = 1788;
		const QName_t LN_rubyBase = 1795;
		const QName_t LN_rPr = 1800;
		const QName_t LN_font = 1806;
		const QName_t LN_charset = 1811;
		const QName_t LN_family = 1814;
		const QName_t LN_b = 1822;
		const QName_t LN_i = 1826;
		const QName_t LN_strike = 1832;
		const QName_t LN_outline = 1838;
		const QName_t LN_shadow = 1844;
		const QName_t LN_condense = 1854;
		const QName_t LN_extend = 1864;
		const QName_t LN_sz = 1870;
		const QName_t LN_u = 1876;
		const QName_t LN_vertAlign = 1881;
		const QName_t LN_ruby = 1885;
		const QName_t LN_sstItem = 1896;
		const QName_t LN_webPubItem = 1905;
		const QName_t LN_csViews = 1916;
		const QName_t LN_csView = 1925;
	}
	namespace NS_wddr12 { /* http://schemas.microsoft.com/office/officeart/2005/8/wddr */
		const QName_t LN_extent = 3760;
		const QName_t LN_effectExtent = 3778;
		const QName_t LN_docPr = 3786;
		const QName_t LN_graphic = 3793;
		const QName_t LN_start = 3797;
		const QName_t LN_lineTo = 3804;
		const QName_t LN_wrapPolygon = 3814;
		const QName_t LN_wrapNone = 3825;
		const QName_t LN_wrapSquare = 3837;
		const QName_t LN_wrapTight = 3845;
		const QName_t LN_wrapThrough = 3857;
		const QName_t LN_wrapTopAndBottom = 3874;
		const QName_t LN_align = 3879;
		const QName_t LN_offset = 3882;
		const QName_t LN_simplePos = 3892;
		const QName_t LN_positionH = 3903;
		const QName_t LN_positionV = 3917;
	}
	namespace NS_a12 { /* http://schemas.microsoft.com/office/officeart/2005/8/oartml */
		const QName_t LN_spcPct = 17;
		const QName_t LN_spcPts = 24;
		const QName_t LN_tab = 30;
		const QName_t LN_lineSpc = 38;
		const QName_t LN_spcBef = 46;
		const QName_t LN_spcAft = 54;
		const QName_t LN_tabLst = 60;
		const QName_t LN_defRPr = 68;
		const QName_t LN_br = 71;
		const QName_t LN_field = 74;
		const QName_t LN_math = 80;
		const QName_t LN_t = 107;
		const QName_t LN_st = 1296;
		const QName_t LN_end = 1302;
		const QName_t LN_audioCd = 1314;
		const QName_t LN_audioFile = 1326;
		const QName_t LN_videoFile = 1337;
		const QName_t LN_dark1 = 1379;
		const QName_t LN_light1 = 1385;
		const QName_t LN_dark2 = 1395;
		const QName_t LN_light2 = 1405;
		const QName_t LN_accent1 = 1414;
		const QName_t LN_accent2 = 1423;
		const QName_t LN_accent3 = 1432;
		const QName_t LN_accent4 = 1442;
		const QName_t LN_accent5 = 1453;
		const QName_t LN_accent6 = 1463;
		const QName_t LN_hlink = 1472;
		const QName_t LN_folHlink = 1480;
		const QName_t LN_custClr = 1494;
		const QName_t LN_latin = 1503;
		const QName_t LN_highAnsi = 1511;
		const QName_t LN_complexScript = 1524;
		const QName_t LN_eastAsian = 1533;
		const QName_t LN_majorFont = 1544;
		const QName_t LN_minorFont = 1555;
		const QName_t LN_fillStyle = 1567;
		const QName_t LN_line = 1573;
		const QName_t LN_lineStyle = 1583;
		const QName_t LN_scene3d = 1592;
		const QName_t LN_sp3d = 1599;
		const QName_t LN_effectStyle = 1612;
		const QName_t LN_bgFillStyle = 1625;
		const QName_t LN_fillStyleLst = 1638;
		const QName_t LN_lineStyleLst = 1649;
		const QName_t LN_effectStyleLst = 1664;
		const QName_t LN_bgFillStyleLst = 1679;
		const QName_t LN_clrScheme = 1688;
		const QName_t LN_custClrLst = 1700;
		const QName_t LN_fontScheme = 1712;
		const QName_t LN_effectScheme = 1728;
		const QName_t LN_sx = 1823;
		const QName_t LN_sy = 1829;
		const QName_t LN_off = 1839;
		const QName_t LN_ext = 1849;
		const QName_t LN_chOff = 1856;
		const QName_t LN_chExt = 1865;
		const QName_t LN_tint = 1884;
		const QName_t LN_shade = 1894;
		const QName_t LN_comp = 1902;
		const QName_t LN_inv = 1909;
		const QName_t LN_gray = 1914;
		const QName_t LN_alpha = 1924;
		const QName_t LN_alphaOff = 1931;
		const QName_t LN_alphaMod = 1939;
		const QName_t LN_hue = 1947;
		const QName_t LN_hueOff = 1954;
		const QName_t LN_hueMod = 1961;
		const QName_t LN_sat = 1967;
		const QName_t LN_satOff = 1977;
		const QName_t LN_satMod = 1988;
		const QName_t LN_lum = 1996;
		const QName_t LN_lumOff = 2006;
		const QName_t LN_lumMod = 2017;
		const QName_t LN_red = 2023;
		const QName_t LN_redOff = 2033;
		const QName_t LN_redMod = 2043;
		const QName_t LN_green = 2048;
		const QName_t LN_greenOff = 2057;
		const QName_t LN_greenMod = 2069;
		const QName_t LN_blue = 2073;
		const QName_t LN_blueOff = 2085;
		const QName_t LN_blueMod = 2096;
		const QName_t LN_scrgbClr = 2113;
		const QName_t LN_srgbClr = 2122;
		const QName_t LN_hslClr = 2134;
		const QName_t LN_sysClr = 2145;
		const QName_t LN_schemeClr = 2157;
		const QName_t LN_prstClr = 2167;
		const QName_t LN_spLock = 3146;
		const QName_t LN_cxnSpLock = 3154;
		const QName_t LN_stCxn = 3165;
		const QName_t LN_endCxn = 3174;
		const QName_t LN_gspLock = 3187;
		const QName_t LN_graphicFrameLock = 3203;
		const QName_t LN_bounds = 3240;
		const QName_t LN_graphicData = 3289;
		const QName_t LN_graphic = 3298;
		const QName_t LN_igx = 3337;
		const QName_t LN_chart = 3345;
		const QName_t LN_bldIgx = 3373;
		const QName_t LN_bldChart = 3386;
		const QName_t LN_txBody = 3469;
		const QName_t LN_xfrm = 3476;
		const QName_t LN_useSpRect = 3486;
		const QName_t LN_anvPr = 3494;
		const QName_t LN_anvSpPr = 3502;
		const QName_t LN_nvSpPr = 3512;
		const QName_t LN_spPr = 3520;
		const QName_t LN_txsp = 3529;
		const QName_t LN_style = 3534;
		const QName_t LN_anvCxnSpPr = 3548;
		const QName_t LN_nvCxnSpPr = 3562;
		const QName_t LN_anvGraphicFramePr = 3580;
		const QName_t LN_nvGraphicFramePr = 3597;
		const QName_t LN_anvGspPr = 3608;
		const QName_t LN_nvGspPr = 3619;
		const QName_t LN_gspPr = 3627;
		const QName_t LN_sp = 3632;
		const QName_t LN_cxnsp = 3640;
		const QName_t LN_graphicFrame = 3654;
		const QName_t LN_gsp = 3664;
		const QName_t LN_spid = 3711;
		const QName_t LN_name = 3717;
		const QName_t LN_descr = 3726;
		const QName_t LN_rot = 3768;
		const QName_t LN_camera = 3850;
		const QName_t LN_lightRig = 3861;
		const QName_t LN_backdrop = 3870;
		const QName_t LN_anchor = 3918;
		const QName_t LN_normal = 3925;
		const QName_t LN_up = 3933;
		const QName_t LN_bevelT = 3967;
		const QName_t LN_bevelB = 3977;
		const QName_t LN_extrusionClr = 3990;
		const QName_t LN_contourClr = 4003;
		const QName_t LN_flatTx = 4010;
		const QName_t LN_clrFrom = 4055;
		const QName_t LN_clrTo = 4063;
		const QName_t LN_fillToRect = 4076;
		const QName_t LN_gs = 4081;
		const QName_t LN_gsList = 4092;
		const QName_t LN_lin = 4101;
		const QName_t LN_path = 4107;
		const QName_t LN_tileRect = 4121;
		const QName_t LN_fillRect = 4132;
		const QName_t LN_alphaBiLevel = 4144;
		const QName_t LN_alphaCeiling = 4154;
		const QName_t LN_alphaFloor = 4164;
		const QName_t LN_alphaInv = 4174;
		const QName_t LN_alphaModFix = 4184;
		const QName_t LN_alphaRepl = 4193;
		const QName_t LN_biLevel = 4204;
		const QName_t LN_blur = 4212;
		const QName_t LN_clrBal = 4220;
		const QName_t LN_clrChange = 4230;
		const QName_t LN_clrRepl = 4242;
		const QName_t LN_duotone = 4249;
		const QName_t LN_fillOverlay = 4263;
		const QName_t LN_grayscl = 4271;
		const QName_t LN_hsl = 4279;
		const QName_t LN_luminance = 4283;
		const QName_t LN_sharpen = 4293;
		const QName_t LN_blip = 4302;
		const QName_t LN_srcRect = 4309;
		const QName_t LN_tile = 4318;
		const QName_t LN_stretch = 4326;
		const QName_t LN_fgClr = 4334;
		const QName_t LN_bgClr = 4342;
		const QName_t LN_noFill = 4350;
		const QName_t LN_solidFill = 4361;
		const QName_t LN_gradFill = 4371;
		const QName_t LN_blipFill = 4382;
		const QName_t LN_pattFill = 4392;
		const QName_t LN_grpFill = 4402;
		const QName_t LN_cont = 4410;
		const QName_t LN_effect = 4414;
		const QName_t LN_alphaOutset = 4425;
		const QName_t LN_blend = 4431;
		const QName_t LN_fill = 4439;
		const QName_t LN_glow = 4446;
		const QName_t LN_innerShdw = 4458;
		const QName_t LN_outerShdw = 4469;
		const QName_t LN_prstShdw = 4479;
		const QName_t LN_reflection = 4488;
		const QName_t LN_relOff = 4498;
		const QName_t LN_sftEdg = 4507;
		const QName_t LN_effectLst = 4515;
		const QName_t LN_effectDag = 4525;
		const QName_t LN_gd = 4599;
		const QName_t LN_pos = 4608;
		const QName_t LN_ahXY = 4614;
		const QName_t LN_ahPolar = 4625;
		const QName_t LN_cxn = 4634;
		const QName_t LN_rect = 4639;
		const QName_t LN_pt = 4644;
		const QName_t LN_close = 4655;
		const QName_t LN_moveTo = 4665;
		const QName_t LN_lineTo = 4674;
		const QName_t LN_arcTo = 4684;
		const QName_t LN_quadBezTo = 4693;
		const QName_t LN_cubicBezTo = 4706;
		const QName_t LN_avLst = 4715;
		const QName_t LN_gdLst = 4726;
		const QName_t LN_ahLst = 4733;
		const QName_t LN_cxnLst = 4743;
		const QName_t LN_rectLst = 4753;
		const QName_t LN_pathLst = 4761;
		const QName_t LN_custGeom = 4771;
		const QName_t LN_prstGeom = 4779;
		const QName_t LN_round = 4818;
		const QName_t LN_bevel = 4826;
		const QName_t LN_miter = 4835;
		const QName_t LN_prstDash = 4845;
		const QName_t LN_custDash = 4852;
		const QName_t LN_headEnd = 4861;
		const QName_t LN_tailEnd = 4871;
		const QName_t LN_ds = 4909;
		const QName_t LN_noLine = 4918;
		const QName_t LN_solidLine = 4926;
		const QName_t LN_gradLine = 4936;
		const QName_t LN_pattLine = 4947;
		const QName_t LN_font = 5040;
		const QName_t LN_txbPr = 5081;
		const QName_t LN_txLstStyle = 5092;
		const QName_t LN_spDef = 5102;
		const QName_t LN_lnDef = 5111;
		const QName_t LN_txbxDef = 5119;
		const QName_t LN_masterClrMapping = 5166;
		const QName_t LN_overrideClrMapping = 5181;
		const QName_t LN_baseStyles = 5193;
		const QName_t LN_objectDefaults = 5204;
		const QName_t LN_masterClrScheme = 5217;
		const QName_t LN_overrideClrScheme = 5231;
		const QName_t LN_masterFontScheme = 5243;
		const QName_t LN_overrideFontScheme = 5258;
		const QName_t LN_masterStyleMatrix = 5273;
		const QName_t LN_overrideStyleMatrix = 5288;
		const QName_t LN_clrMap = 5299;
		const QName_t LN_lnL = 5339;
		const QName_t LN_lnR = 5345;
		const QName_t LN_lnT = 5355;
		const QName_t LN_lnB = 5363;
		const QName_t LN_lnTlToBr = 5372;
		const QName_t LN_lnBlToTr = 5381;
		const QName_t LN_cell3D = 5391;
		const QName_t LN_gridCol = 5401;
		const QName_t LN_txbx = 5409;
		const QName_t LN_tcPr = 5419;
		const QName_t LN_tc = 5427;
		const QName_t LN_tableStyle = 5440;
		const QName_t LN_tableStyleId = 5449;
		const QName_t LN_tblPr = 5456;
		const QName_t LN_tblGrid = 5468;
		const QName_t LN_tr = 5476;
		const QName_t LN_unthemedFill = 5516;
		const QName_t LN_themedFill = 5528;
		const QName_t LN_ln = 5535;
		const QName_t LN_unthemedLine = 5547;
		const QName_t LN_themedLine = 5556;
		const QName_t LN_unthemedFonts = 5566;
		const QName_t LN_themedFonts = 5576;
		const QName_t LN_fonts = 5585;
		const QName_t LN_b = 5591;
		const QName_t LN_i = 5595;
		const QName_t LN_left = 5604;
		const QName_t LN_right = 5612;
		const QName_t LN_top = 5620;
		const QName_t LN_bottom = 5628;
		const QName_t LN_insideH = 5637;
		const QName_t LN_insideV = 5645;
		const QName_t LN_tl2br = 5653;
		const QName_t LN_tr2bl = 5663;
		const QName_t LN_tcBorders = 5673;
		const QName_t LN_rPr = 5681;
		const QName_t LN_tableBg = 5690;
		const QName_t LN_wholeTable = 5698;
		const QName_t LN_band1Horz = 5708;
		const QName_t LN_band2Horz = 5718;
		const QName_t LN_band1Vert = 5726;
		const QName_t LN_band2Vert = 5738;
		const QName_t LN_lastCol = 5748;
		const QName_t LN_firstCol = 5757;
		const QName_t LN_lastRow = 5767;
		const QName_t LN_seCell = 5773;
		const QName_t LN_swCell = 5782;
		const QName_t LN_firstRow = 5794;
		const QName_t LN_neCell = 5804;
		const QName_t LN_nwCell = 5811;
		const QName_t LN_topBaseline = 5852;
		const QName_t LN_bottomBaseline = 5865;
		const QName_t LN_pPr = 5874;
		const QName_t LN_endParaRPr = 5884;
		const QName_t LN_defPPr = 5895;
		const QName_t LN_outline1pPr = 5909;
		const QName_t LN_outline2pPr = 5918;
		const QName_t LN_lvl1pPr = 5930;
		const QName_t LN_lvl2pPr = 5939;
		const QName_t LN_lvl3pPr = 5949;
		const QName_t LN_lvl4pPr = 5958;
		const QName_t LN_lvl5pPr = 5968;
		const QName_t LN_lvl6pPr = 5979;
		const QName_t LN_lvl7pPr = 5991;
		const QName_t LN_lvl8pPr = 6002;
		const QName_t LN_lvl9pPr = 6012;
		const QName_t LN_noAutofit = 6024;
		const QName_t LN_normAutofit = 6036;
		const QName_t LN_shapeAutofit = 6049;
		const QName_t LN_textWarp = 6058;
		const QName_t LN_prot = 6069;
		const QName_t LN_bodyPr = 6078;
		const QName_t LN_lstStyle = 6089;
		const QName_t LN_p = 6093;
		const QName_t LN_buColorTx = 6140;
		const QName_t LN_buColor = 6152;
		const QName_t LN_buSzTx = 6161;
		const QName_t LN_buSzPct = 6171;
		const QName_t LN_buSzPts = 6182;
		const QName_t LN_buFontTx = 6193;
		const QName_t LN_buFont = 6201;
		const QName_t LN_buBlip = 6210;
		const QName_t LN_noBullet = 6223;
		const QName_t LN_autonumberBullet = 6238;
		const QName_t LN_charBullet = 6250;
		const QName_t LN_blipBullet = 6263;
		const QName_t LN_shadow = 6305;
		const QName_t LN_outline = 6317;
		const QName_t LN_engrave = 6328;
		const QName_t LN_emboss = 6337;
		const QName_t LN_highlight = 6346;
		const QName_t LN_formatting = 6359;
		const QName_t LN_u = 6364;
		const QName_t LN_ascii = 6374;
		const QName_t LN_ea = 6382;
		const QName_t LN_cs = 6389;
		const QName_t LN_hAnsi = 6398;
		const QName_t LN_sym = 6403;
		const QName_t LN_link = 6408;
		const QName_t LN_acc = 6439;
		const QName_t LN_bar = 6443;
		const QName_t LN_box = 6450;
		const QName_t LN_d = 6455;
		const QName_t LN_eqArray = 6463;
		const QName_t LN_f = 6469;
		const QName_t LN_func = 6475;
		const QName_t LN_groupChr = 6484;
		const QName_t LN_lLow = 6491;
		const QName_t LN_lUp = 6496;
		const QName_t LN_m = 6502;
		const QName_t LN_nary = 6509;
		const QName_t LN_phant = 6514;
		const QName_t LN_rad = 6519;
		const QName_t LN_sPre = 6527;
		const QName_t LN_sSub = 6534;
		const QName_t LN_sSubSup = 6543;
		const QName_t LN_sSup = 6551;
		const QName_t LN_r = 6557;
		const QName_t LN_chr = 6563;
		const QName_t LN_accPr = 6570;
		const QName_t LN_e = 6576;
		const QName_t LN_barPr = 6579;
		const QName_t LN_begChr = 6586;
		const QName_t LN_sepChr = 6592;
		const QName_t LN_endChr = 6598;
		const QName_t LN_grow = 6602;
		const QName_t LN_shp = 6609;
		const QName_t LN_dPr = 6614;
		const QName_t LN_baseJc = 6618;
		const QName_t LN_maxDist = 6626;
		const QName_t LN_objDist = 6630;
		const QName_t LN_eqArrPr = 6637;
		const QName_t LN_type = 6642;
		const QName_t LN_numJc = 6649;
		const QName_t LN_denJc = 6657;
		const QName_t LN_fPr = 6663;
		const QName_t LN_num = 6673;
		const QName_t LN_den = 6679;
		const QName_t LN_fName = 6689;
		const QName_t LN_groupChrPr = 6700;
		const QName_t LN_lim = 6706;
		const QName_t LN_count = 6712;
		const QName_t LN_mcJc = 6719;
		const QName_t LN_mcPr = 6726;
		const QName_t LN_mc = 6733;
		const QName_t LN_plcHide = 6742;
		const QName_t LN_mcs = 6747;
		const QName_t LN_mrJc = 6753;
		const QName_t LN_mrPr = 6761;
		const QName_t LN_mPr = 6766;
		const QName_t LN_mr = 6773;
		const QName_t LN_limLoc = 6782;
		const QName_t LN_subHide = 6789;
		const QName_t LN_supHide = 6796;
		const QName_t LN_naryPr = 6803;
		const QName_t LN_sub = 6808;
		const QName_t LN_sup = 6812;
		const QName_t LN_width = 6818;
		const QName_t LN_asc = 6820;
		const QName_t LN_desc = 6826;
		const QName_t LN_phantPr = 6833;
		const QName_t LN_degHide = 6844;
		const QName_t LN_radPr = 6851;
		const QName_t LN_deg = 6860;
	}
	namespace NS_svg { /* urn:oasis:names:tc:opendocument:xmlns:svg-compatible:1.0 */
		const QName_t LN_path = 959;
		const QName_t LN_origin = 967;
		const QName_t LN_type = 1018;
		const QName_t LN_font_family = 1834;
		const QName_t LN_font_style = 1848;
		const QName_t LN_font_variant = 1860;
		const QName_t LN_font_weight = 1874;
		const QName_t LN_font_stretch = 1887;
		const QName_t LN_font_size = 1899;
		const QName_t LN_unicode_range = 1912;
		const QName_t LN_units_per_em = 1923;
		const QName_t LN_panose_1 = 1930;
		const QName_t LN_stemv = 1938;
		const QName_t LN_stemh = 1946;
		const QName_t LN_slope = 1953;
		const QName_t LN_cap_height = 1963;
		const QName_t LN_x_height = 1972;
		const QName_t LN_accent_height = 1987;
		const QName_t LN_ascent = 1998;
		const QName_t LN_descent = 2009;
		const QName_t LN_widths = 2020;
		const QName_t LN_bbox = 2028;
		const QName_t LN_ideographic = 2042;
		const QName_t LN_alphabetic = 2053;
		const QName_t LN_mathematical = 2066;
		const QName_t LN_hanging = 2077;
		const QName_t LN_v_ideographic = 2090;
		const QName_t LN_v_alphabetic = 2105;
		const QName_t LN_v_mathematical = 2121;
		const QName_t LN_v_hanging = 2133;
		const QName_t LN_underline_position = 2151;
		const QName_t LN_underline_thickness = 2173;
		const QName_t LN_strikethrough_position = 2190;
		const QName_t LN_strikethrough_thickness = 2208;
		const QName_t LN_overline_position = 2222;
		const QName_t LN_overline_thickness = 2237;
		const QName_t LN_font_face_src = 2249;
		const QName_t LN_font_face_uri = 2262;
		const QName_t LN_font_face_format = 2273;
		const QName_t LN_string = 2279;
		const QName_t LN_font_face_name = 2291;
		const QName_t LN_name = 2297;
		const QName_t LN_definition_src = 2312;
		const QName_t LN_linearGradient = 3658;
		const QName_t LN_radialGradient = 3672;
		const QName_t LN_fx = 3678;
		const QName_t LN_fy = 3687;
		const QName_t LN_stop = 3696;
		const QName_t LN_offset = 3700;
		const QName_t LN_stop_color = 3714;
		const QName_t LN_stop_opacity = 3731;
		const QName_t LN_gradientUnits = 3740;
		const QName_t LN_gradientTransform = 3755;
		const QName_t LN_spreadMethod = 3769;
		const QName_t LN_stroke_width = 5435;
		const QName_t LN_stroke_color = 5446;
		const QName_t LN_stroke_opacity = 5539;
		const QName_t LN_fill_rule = 5772;
		const QName_t LN_x1 = 5963;
		const QName_t LN_y1 = 5970;
		const QName_t LN_x2 = 5978;
		const QName_t LN_y2 = 5987;
		const QName_t LN_d = 6081;
		const QName_t LN_cx = 6098;
		const QName_t LN_cy = 6103;
		const QName_t LN_r = 6110;
		const QName_t LN_rx = 6155;
		const QName_t LN_ry = 6162;
		const QName_t LN_y = 6334;
		const QName_t LN_x = 6342;
		const QName_t LN_width = 6348;
		const QName_t LN_height = 6357;
		const QName_t LN_viewBox = 6379;
		const QName_t LN_desc = 6777;
	}
	namespace NS_on12 { /* http://schemas.microsoft.com/office/onenote/2004/import */
		const QName_t LN_Import = 1943;
		const QName_t LN_EnsurePage = 1958;
		const QName_t LN_PlaceObjects = 1968;
		const QName_t LN_Object = 1979;
		const QName_t LN_Delete = 1989;
		const QName_t LN_Position = 1994;
		const QName_t LN_Image = 2001;
		const QName_t LN_Ink = 2011;
		const QName_t LN_Outline = 2022;
		const QName_t LN_Html = 2030;
		const QName_t LN_File = 2036;
		const QName_t LN_Data = 2047;
	}
	namespace NS_form { /* urn:oasis:names:tc:opendocument:xmlns:form:1.0 */
		const QName_t LN_detail_fields = 3;
		const QName_t LN_escape_processing = 13;
		const QName_t LN_filter = 18;
		const QName_t LN_ignore_result = 29;
		const QName_t LN_navigation_mode = 41;
		const QName_t LN_order = 47;
		const QName_t LN_tab_cycle = 57;
		const QName_t LN_connection_resource = 69;
		const QName_t LN_text = 77;
		const QName_t LN_textarea = 84;
		const QName_t LN_password = 85;
		const QName_t LN_echo_char = 95;
		const QName_t LN_file = 99;
		const QName_t LN_formatted_text = 109;
		const QName_t LN_max_value = 116;
		const QName_t LN_min_value = 123;
		const QName_t LN_validation = 132;
		const QName_t LN_number = 135;
		const QName_t LN_value = 139;
		const QName_t LN_current_value = 143;
		const QName_t LN_date = 145;
		const QName_t LN_time = 150;
		const QName_t LN_fixed_text = 160;
		const QName_t LN_multi_line = 167;
		const QName_t LN_combobox = 175;
		const QName_t LN_auto_complete = 188;
		const QName_t LN_item = 195;
		const QName_t LN_listbox = 201;
		const QName_t LN_multiple = 208;
		const QName_t LN_xforms_list_source = 217;
		const QName_t LN_option = 223;
		const QName_t LN_button = 229;
		const QName_t LN_default_button = 237;
		const QName_t LN_toggle = 256;
		const QName_t LN_focus_on_click = 267;
		const QName_t LN_xforms_submission = 277;
		const QName_t LN_image = 281;
		const QName_t LN_checkbox = 290;
		const QName_t LN_current_state = 298;
		const QName_t LN_is_tristate = 307;
		const QName_t LN_state = 314;
		const QName_t LN_radio = 321;
		const QName_t LN_frame = 325;
		const QName_t LN_image_frame = 334;
		const QName_t LN_hidden = 341;
		const QName_t LN_grid = 347;
		const QName_t LN_column = 349;
		const QName_t LN_text_style_name = 354;
		const QName_t LN_value_range = 365;
		const QName_t LN_step_size = 385;
		const QName_t LN_page_step_size = 399;
		const QName_t LN_delay_for_repeat = 411;
		const QName_t LN_orientation = 415;
		const QName_t LN_generic_control = 428;
		const QName_t LN_name = 432;
		const QName_t LN_control_implementation = 449;
		const QName_t LN_button_type = 467;
		const QName_t LN_id = 472;
		const QName_t LN_current_selected = 486;
		const QName_t LN_disabled = 495;
		const QName_t LN_dropdown = 502;
		const QName_t LN_for = 508;
		const QName_t LN_image_data = 519;
		const QName_t LN_label = 523;
		const QName_t LN_max_length = 534;
		const QName_t LN_printable = 545;
		const QName_t LN_readonly = 552;
		const QName_t LN_selected = 560;
		const QName_t LN_size = 566;
		const QName_t LN_tab_index = 576;
		const QName_t LN_tab_stop = 588;
		const QName_t LN_title = 590;
		const QName_t LN_visual_effect = 604;
		const QName_t LN_image_position = 617;
		const QName_t LN_image_align = 627;
		const QName_t LN_bound_column = 638;
		const QName_t LN_convert_empty_to_null = 655;
		const QName_t LN_data_field = 660;
		const QName_t LN_list_source = 670;
		const QName_t LN_list_source_type = 687;
		const QName_t LN_properties = 695;
		const QName_t LN_property = 703;
		const QName_t LN_property_name = 716;
		const QName_t LN_list_property = 726;
		const QName_t LN_list_value = 736;
		const QName_t LN_automatic_focus = 6738;
		const QName_t LN_apply_design_mode = 6751;
		const QName_t LN_form = 6760;
		const QName_t LN_method = 6779;
		const QName_t LN_enctype = 6786;
		const QName_t LN_allow_deletes = 6797;
		const QName_t LN_allow_inserts = 6804;
		const QName_t LN_allow_updates = 6816;
		const QName_t LN_apply_filter = 6825;
		const QName_t LN_command_type = 6836;
		const QName_t LN_command = 6846;
		const QName_t LN_datasource = 6857;
		const QName_t LN_master_fields = 6868;
	}
	namespace NS_script { /* urn:oasis:names:tc:opendocument:xmlns:script:1.0 */
		const QName_t LN_event_listener = 830;
		const QName_t LN_macro_name = 839;
		const QName_t LN_language = 2120;
		const QName_t LN_event_name = 6112;
	}
	namespace NS_aml12 { /* http://schemas.microsoft.com/aml/2001/core */
		const QName_t LN_annotation = 920;
		const QName_t LN_arc = 1034;
		const QName_t LN_content = 1072;
		const QName_t LN_context = 1080;
		const QName_t LN_property = 1086;
	}
	namespace NS_dc { /* http://purl.org/dc/elements/1.1/ */
		const QName_t LN_title = 2209;
		const QName_t LN_description = 2219;
		const QName_t LN_subject = 2228;
		const QName_t LN_creator = 2259;
		const QName_t LN_date = 2284;
		const QName_t LN_language = 2389;
	}
	namespace NS_wa11 { /* http://schemas.microsoft.com/office/word/2003/auxHint */
		const QName_t LN_sect = 6425;
		const QName_t LN_sub_section = 6433;
		const QName_t LN_allowEmptyCollapse = 6446;
		const QName_t LN_font = 6449;
		const QName_t LN_sym = 6453;
		const QName_t LN_top = 6459;
		const QName_t LN_left = 6462;
		const QName_t LN_bottom = 6467;
		const QName_t LN_right = 6472;
		const QName_t LN_between = 6476;
		const QName_t LN_bar = 6480;
		const QName_t LN_width = 6483;
		const QName_t LN_height = 6488;
		const QName_t LN_jc = 6492;
		const QName_t LN_vertFromText = 6503;
		const QName_t LN_horizFromText = 6513;
		const QName_t LN_borders = 6520;
		const QName_t LN_margin_left = 6525;
		const QName_t LN_margin_right = 6531;
		const QName_t LN_apo = 6537;
		const QName_t LN_shd = 6541;
		const QName_t LN_pBdrGroup = 6550;
		const QName_t LN_t = 6555;
		const QName_t LN_uiName = 6564;
	}
	namespace NS_swbu12 { /* http://schemas.microsoft.com/office/excel/2005/8/sharedworkbookusers */
		const QName_t LN_users = 2247;
		const QName_t LN_usrinfo = 2254;
	}
	namespace NS_c12 { /* http://schemas.microsoft.com/office/2004/7/core */
		const QName_t LN_SmartTagType = 184;
		const QName_t LN_schemaRef = 194;
	}

	typedef const sal_Char * PoolRef_t;

	class WRITERFILTER_DLLPUBLIC QNameTokenizerContext
	{
	public:
		virtual void enterScope() = 0;
		virtual void leaveScope() = 0;
		virtual void addBinding(const sal_Char *attrName, const sal_Char *attrValue) = 0;
		virtual PoolRef_t resolvePrefix(const sal_Char *prefix) = 0;
	};

	class WRITERFILTER_DLLPUBLIC QNameSerializerContext
	{
	public:
		virtual PoolRef_t addPrefix(const sal_Char *prefix, const sal_Char *namespaceUri) = 0;
		virtual PoolRef_t getPrefix(PoolRef_t namespaceUri) = 0;
	};


	class WRITERFILTER_DLLPUBLIC QNameTokenizer
	{
		friend class QName;
	public:
		virtual PoolRef_t getNamespaceUri(QName_t qName) const = 0;
		virtual PoolRef_t getLocalName(QName_t qName) const = 0;
		virtual int getQNames() const = 0;


	public:
		virtual std::auto_ptr<QNameTokenizerContext> createQNameTokenizerContext() = 0; 
		virtual std::auto_ptr<QNameSerializerContext> createQNameSerializerContext() = 0; 
		virtual QName_t insert(const sal_Char *namespaceUri, const sal_Char* localName) = 0;
		virtual bool insert(const sal_Char *qName, QNameTokenizerContext &nsContext, QName_t *qn, bool formDefault=false) = 0;
	};


	class WRITERFILTER_DLLPUBLIC QName
	{
	public:
		static const char EMPTY_STRING[];
		static const QNameTokenizer& serializer();
		static QNameTokenizer& tokenizer();
	};

} // namespace writerfilter


#endif /* INCLUDED_QNAME_HXX */
